Package: bezier
Date: 2018-12-08
Title: Toolkit for Bezier Curves and Splines
Description: The bezier package is a toolkit for working with Bezier curves and splines. The package provides functions for point generation, arc length estimation, degree elevation and curve fitting.
Version: 1.1.2
Author: Aaron Olsen
Maintainer: Aaron Olsen <aarolsen@gmail.com>
Repository: CRAN
License: GPL (>= 2)
NeedsCompilation: no
Packaged: 2018-12-08 14:58:40 UTC; aaron
Date/Publication: 2018-12-14 21:30:20 UTC
Built: R 4.6.0; ; 2026-04-25 16:33:31 UTC; unix

importFrom("stats", "lm", "na.omit", "nls", "nls.control", "optim", "sd")

S3method(summary, bezierArcLength)
S3method(summary, bezierCurveFit)

S3method(print, summary.bezierArcLength)
S3method(print, summary.bezierCurveFit)

exportPattern("^[[:alpha:]]+")

module speedup

  implicit none
  private
  public &
       de_casteljau_one_round, evaluate_curve_barycentric, evaluate_multi, &
       linearization_error, evaluate_barycentric, evaluate_barycentric_multi, &
       evaluate_cartesian_multi, cross_product, segment_intersection, bbox, &
       specialize_curve_generic, specialize_curve_quadratic, &
       specialize_curve, jacobian_both, evaluate_hodograph, &
       newton_refine_intersect, jacobian_det, bbox_intersect, &
       wiggle_interval, parallel_different, from_linearized

  ! NOTE: This still relies on .f2py_f2cmap being present
  !       in the directory that build is called from.
  integer, parameter :: dp=kind(0.d0)

contains

  subroutine de_casteljau_one_round( &
       num_nodes, dimension_, nodes, degree, &
       lambda1, lambda2, lambda3, new_nodes)

    ! NOTE: This is de Casteljau on a Bezier surface / triangle.

    !f2py integer intent(hide), depend(nodes) :: num_nodes = size(nodes, 1)
    !f2py integer intent(hide), depend(nodes) :: dimension_ = size(nodes, 2)
    integer :: num_nodes
    integer :: dimension_
    real(dp), intent(in) :: nodes(num_nodes, dimension_)
    integer :: degree
    real(dp), intent(in) :: lambda1
    real(dp), intent(in) :: lambda2
    real(dp), intent(in) :: lambda3
    real(dp), intent(out) :: new_nodes(num_nodes - degree - 1, dimension_)
    ! Variables outside of signature.
    integer :: index_
    integer :: parent_i1
    integer :: parent_i2
    integer :: parent_i3
    integer :: k, j

    index_ = 1
    parent_i1 = 1
    parent_i2 = 2
    parent_i3 = degree + 2
    ! NOTE: Throughout for index_ <--> (i, j, k) in the (degree - 1)
    !       triangle, we have parent_i1 = index_ + k <--> (i + 1, j, k),
    !       parent_i2 = index_ + k + 1 <--> (i, j + 1, k) and
    !       parent_i3 = index_ + degree + 1 <--> (i, j, k + 1).
    do k = 0, degree - 1
       do j = 0, degree - k - 1
          ! NOTE: i = (degree - 1) - j - k
          new_nodes(index_, :) = ( &
               lambda1 * nodes(parent_i1, :) + &
               lambda2 * nodes(parent_i2, :) + &
               lambda3 * nodes(parent_i3, :))
          ! Update all the indices.
          parent_i1 = parent_i1 + 1
          parent_i2 = parent_i2 + 1
          parent_i3 = parent_i3 + 1
          index_ = index_ + 1
       end do
       ! Update the indices that depend on k.
       parent_i1 = parent_i1 + 1
       parent_i2 = parent_i2 + 1
    end do

  end subroutine de_casteljau_one_round

  subroutine evaluate_curve_barycentric( &
       nodes, degree, dimension_, lambda1, lambda2, num_vals, evaluated)

    ! NOTE: This is evaluate_multi_barycentric for a Bezier curve.

    !f2py integer intent(hide), depend(nodes) :: degree = size(nodes, 1) - 1
    !f2py integer intent(hide), depend(nodes) :: dimension_ = size(nodes, 2)
    !f2py integer intent(hide), depend(lambda1) :: num_vals = size(lambda1)
    real(dp), intent(in) :: nodes(degree + 1, dimension_)
    integer :: degree
    integer :: dimension_
    real(dp), intent(in) :: lambda1(num_vals)
    real(dp), intent(in) :: lambda2(num_vals)
    integer :: num_vals
    real(dp), intent(out) :: evaluated(num_vals, dimension_)
    ! Variables outside of signature.
    integer :: i, j
    real(dp) :: lambda2_pow(num_vals)
    integer :: binom_val

    lambda2_pow = 1.0_dp
    binom_val = 1

    forall (i = 1:num_vals)
       evaluated(i, :) = lambda1(i) * nodes(1, :)
    end forall

    do i = 2, degree
       lambda2_pow = lambda2_pow * lambda2
       binom_val = (binom_val * (degree - i + 2)) / (i - 1)
       forall (j = 1:num_vals)
          evaluated(j, :) = ( &
               evaluated(j, :) + &
               binom_val * lambda2_pow(j) * nodes(i, :)) * lambda1(j)
       end forall
    end do

    forall (i = 1:num_vals)
       evaluated(i, :) = ( &
            evaluated(i, :) + &
            lambda2_pow(i) * lambda2(i) * nodes(degree + 1, :))
    end forall

  end subroutine evaluate_curve_barycentric

  subroutine evaluate_multi( &
       nodes, degree, dimension_, s_vals, num_vals, evaluated)

    ! NOTE: This is evaluate_multi for a Bezier curve.

    !f2py integer intent(hide), depend(nodes) :: degree = size(nodes, 1) - 1
    !f2py integer intent(hide), depend(nodes) :: dimension_ = size(nodes, 2)
    !f2py integer intent(hide), depend(s_vals) :: num_vals = size(s_vals)
    real(dp), intent(in) :: nodes(degree + 1, dimension_)
    integer :: degree
    integer :: dimension_
    real(dp), intent(in) :: s_vals(num_vals)
    integer :: num_vals
    real(dp), intent(out) :: evaluated(num_vals, dimension_)
    ! Variables outside of signature.
    real(dp) :: one_less(num_vals)

    one_less = 1.0_dp - s_vals
    call evaluate_curve_barycentric( &
         nodes, degree, dimension_, one_less, s_vals, num_vals, evaluated)
  end subroutine evaluate_multi

  subroutine linearization_error(nodes, degree, dimension_, error)

    !f2py integer intent(hide), depend(nodes) :: dimension_ = size(nodes, 2)
    real(dp), intent(in) :: nodes(degree + 1, dimension_)
    integer :: dimension_
    integer, intent(in) :: degree
    real(dp), intent(out) :: error
    ! Variables outside of signature.
    real(dp) :: second_deriv(degree - 1, dimension_)
    real(dp) :: worst_case(dimension_)

    if (degree == 1) then
       error = 0.0_dp
       return
    end if

    second_deriv = ( &
         nodes(:degree - 1, :) - &
         2.0_dp * nodes(2:degree, :) + &
         nodes(3:, :))
    worst_case = maxval(abs(second_deriv), 1)
    error = 0.125_dp * degree * (degree - 1) * norm2(worst_case)
  end subroutine linearization_error

  subroutine evaluate_barycentric( &
       num_nodes, dimension_, nodes, degree, &
       lambda1, lambda2, lambda3, point)

    ! NOTE: This evaluation is on a Bezier surface / triangle.
    ! NOTE: This assumes degree >= 1.

    !f2py integer intent(hide), depend(nodes) :: num_nodes = size(nodes, 1)
    !f2py integer intent(hide), depend(nodes) :: dimension_ = size(nodes, 2)
    integer :: num_nodes
    integer :: dimension_
    real(dp), intent(in) :: nodes(num_nodes, dimension_)
    integer :: degree
    real(dp), intent(in) :: lambda1
    real(dp), intent(in) :: lambda2
    real(dp), intent(in) :: lambda3
    real(dp), intent(out) :: point(1, dimension_)
    ! Variables outside of signature.
    real(dp) :: param_vals(1, 3)

    param_vals(1, 1) = lambda1
    param_vals(1, 2) = lambda2
    param_vals(1, 3) = lambda3
    call evaluate_barycentric_multi( &
         num_nodes, nodes, degree, 1, param_vals, dimension_, point)

  end subroutine evaluate_barycentric

  subroutine evaluate_barycentric_multi( &
       num_nodes, nodes, degree, num_vals, param_vals, dimension_, evaluated)

    ! NOTE: This evaluation is on a Bezier surface / triangle.
    ! NOTE: This assumes degree >= 1.

    !f2py integer intent(hide), depend(nodes) :: num_nodes = size(nodes, 1)
    !f2py integer depend(nodes) :: dimension_ = size(nodes, 2)
    !f2py integer intent(hide), depend(param_vals) :: num_vals &
    !f2py     = size(param_vals, 1)
    integer :: num_nodes
    integer :: dimension_
    real(dp), intent(in) :: nodes(num_nodes, dimension_)
    integer :: degree
    integer :: num_vals
    real(dp), intent(in) :: param_vals(num_vals, 3)
    real(dp), intent(out) :: evaluated(num_vals, dimension_)
    ! Variables outside of signature.
    integer :: k, binom_val, index_, new_index
    real(dp) :: row_result(num_vals, dimension_)

    index_ = num_nodes
    forall (new_index = 1:num_vals)  ! Borrow new_index for this loop.
       evaluated(new_index, :) = nodes(index_, :)
    end forall

    if (degree == 0) then
       return
    end if

    binom_val = 1
    do k = degree - 1, 0, -1
        ! We want to go from (d C (k + 1)) to (d C k).
        binom_val = (binom_val * (k + 1)) / (degree - k)
        index_ = index_ - 1  ! Step to last element in row.
        !     k = d - 1, d - 2, ...
        ! d - k =     1,     2, ...
        ! We know row k has (d - k + 1) elements.
        new_index = index_ - degree + k  ! First element in row.

        ! lambda1 = param_vals(:, 1)
        ! lambda2 = param_vals(:, 2)
        call evaluate_curve_barycentric( &
             nodes(new_index:index_, :), degree - k, dimension_, &
             param_vals(:, 1), param_vals(:, 2), num_vals, row_result)

        ! Update index for next iteration.
        index_ = new_index

        ! lambda3 = param_vals(:, 3)
        forall (new_index = 1:num_vals)  ! Borrow new_index for this loop.
           evaluated(new_index, :) = ( &
                param_vals(new_index, 3) * evaluated(new_index, :) + &
                binom_val * row_result(new_index, :))
        end forall
    end do

  end subroutine evaluate_barycentric_multi

  subroutine evaluate_cartesian_multi( &
       num_nodes, nodes, degree, num_vals, param_vals, dimension_, evaluated)

    ! NOTE: This evaluation is on a Bezier surface / triangle.
    ! NOTE: This mostly copies evaluate_barycentric_multi but does not just
    !       call it directly. This is to avoid copying param_vals.

    !f2py integer intent(hide), depend(nodes) :: num_nodes = size(nodes, 1)
    !f2py integer depend(nodes) :: dimension_ = size(nodes, 2)
    !f2py integer intent(hide), depend(param_vals) :: num_vals &
    !f2py     = size(param_vals, 1)
    integer :: num_nodes
    integer :: dimension_
    real(dp), intent(in) :: nodes(num_nodes, dimension_)
    integer :: degree
    integer :: num_vals
    real(dp), intent(in) :: param_vals(num_vals, 2)
    real(dp), intent(out) :: evaluated(num_vals, dimension_)
    ! Variables outside of signature.
    integer :: k, binom_val, index_, new_index
    real(dp) :: row_result(num_vals, dimension_)
    real(dp) :: lambda1_vals(num_vals)

    index_ = num_nodes
    forall (new_index = 1:num_vals)  ! Borrow new_index for this loop.
       evaluated(new_index, :) = nodes(index_, :)
    end forall

    if (degree == 0) then
       return
    end if

    lambda1_vals = 1.0_dp - param_vals(:, 1) - param_vals(:, 2)

    binom_val = 1
    do k = degree - 1, 0, -1
        ! We want to go from (d C (k + 1)) to (d C k).
        binom_val = (binom_val * (k + 1)) / (degree - k)
        index_ = index_ - 1  ! Step to last element in row.
        !     k = d - 1, d - 2, ...
        ! d - k =     1,     2, ...
        ! We know row k has (d - k + 1) elements.
        new_index = index_ - degree + k  ! First element in row.

        ! lambda1 = param_vals(:, 1)
        ! lambda2 = param_vals(:, 1)
        call evaluate_curve_barycentric( &
             nodes(new_index:index_, :), degree - k, dimension_, &
             lambda1_vals, param_vals(:, 1), num_vals, row_result)

        ! Update index for next iteration.
        index_ = new_index

        ! lambda3 = param_vals(:, 2)
        forall (new_index = 1:num_vals)  ! Borrow new_index for this loop.
           evaluated(new_index, :) = ( &
                param_vals(new_index, 2) * evaluated(new_index, :) + &
                binom_val * row_result(new_index, :))
        end forall
    end do

  end subroutine evaluate_cartesian_multi

  subroutine cross_product(vec0, vec1, result_)

    real(dp), intent(in) :: vec0(1, 2)
    real(dp), intent(in) :: vec1(1, 2)
    real(dp), intent(out) :: result_

    result_ = vec0(1, 1) * vec1(1, 2) - vec0(1, 2) * vec1(1, 1)

  end subroutine cross_product

  subroutine segment_intersection(start0, end0, start1, end1, s, t, success)

    real(dp), intent(in) :: start0(1, 2)
    real(dp), intent(in) :: end0(1, 2)
    real(dp), intent(in) :: start1(1, 2)
    real(dp), intent(in) :: end1(1, 2)
    real(dp), intent(out) :: s, t
    logical(1), intent(out) :: success
    ! Variables outside of signature.
    real(dp) :: delta0(1, 2)
    real(dp) :: delta1(1, 2)
    real(dp) :: start_delta(1, 2)
    real(dp) :: cross_d0_d1
    real(dp) :: other_cross

    delta0 = end0 - start0
    delta1 = end1 - start1
    call cross_product(delta0, delta1, cross_d0_d1)

    if (cross_d0_d1 == 0.0_dp) then
       success = .FALSE.
    else
       start_delta = start1 - start0
       call cross_product(start_delta, delta1, other_cross)
       s = other_cross / cross_d0_d1
       call cross_product(start_delta, delta0, other_cross)
       t = other_cross / cross_d0_d1
       success = .TRUE.
    end if

  end subroutine segment_intersection

  subroutine bbox(num_nodes, nodes, left, right, bottom, top)

    !f2py integer intent(hide), depend(nodes) :: num_nodes = size(nodes, 1)
    integer :: num_nodes
    real(dp), intent(in) :: nodes(num_nodes, 2)
    real(dp), intent(out) :: left, right, bottom, top
    ! Variables outside of signature.
    real(dp) :: workspace(2)

    workspace = minval(nodes, 1)
    left = workspace(1)
    bottom = workspace(2)
    workspace = maxval(nodes, 1)
    right = workspace(1)
    top = workspace(2)

  end subroutine bbox

  subroutine specialize_curve_generic( &
       nodes, degree, dimension_, start, end_, new_nodes)

    ! NOTE: This is a helper for ``specialize_curve`` that works on any degree.

    !f2py integer intent(hide), depend(nodes) :: dimension_ = size(nodes, 2)
    real(dp), intent(in) :: nodes(degree + 1, dimension_)
    integer :: dimension_
    integer, intent(in) :: degree
    real(dp), intent(in) :: start, end_
    real(dp), intent(out) :: new_nodes(degree + 1, dimension_)
    ! Variables outside of signature.
    real(dp) :: workspace(degree, dimension_, degree + 1)
    integer :: index_, curr_size, j
    real(dp) :: minus_start, minus_end

    minus_start = 1.0_dp - start
    minus_end = 1.0_dp - end_
    workspace(:, :, 1) = minus_start * nodes(:degree, :) + start * nodes(2:, :)
    workspace(:, :, 2) = minus_end * nodes(:degree, :) + end_ * nodes(2:, :)

    curr_size = degree
    do index_ = 3, degree + 1
       curr_size = curr_size - 1
       ! First add a new "column" (or whatever the 3rd dimension is called)
       ! at the end using ``end_``.
       workspace(:curr_size, :, index_) = ( &
            minus_end * workspace(:curr_size, :, index_ - 1) + &
            end_ * workspace(2:curr_size + 1, :, index_ - 1))
       ! Update all the values in place by using de Casteljau with the
       ! ``start`` parameter.
       forall (j = 1:index_ - 1)
          workspace(:curr_size, :, j) = ( &
               minus_start * workspace(:curr_size, :, j) + &
               start * workspace(2:curr_size + 1, :, j))
       end forall
    end do

    ! Move the final "column" (or whatever the 3rd dimension is called)
    ! of the workspace into ``new_nodes``.
    forall (index_ = 1:degree + 1)
       new_nodes(index_, :) = workspace(1, :, index_)
    end forall

  end subroutine specialize_curve_generic

  subroutine specialize_curve_quadratic( &
       nodes, dimension_, start, end_, new_nodes)

    !f2py integer intent(hide), depend(nodes) :: dimension_ = size(nodes, 2)
    real(dp), intent(in) :: nodes(3, dimension_)
    integer :: dimension_
    real(dp), intent(in) :: start, end_
    real(dp), intent(out) :: new_nodes(3, dimension_)
    ! Variables outside of signature.
    real(dp) :: minus_start, minus_end, prod_both

    minus_start = 1.0_dp - start
    minus_end = 1.0_dp - end_
    prod_both = start * end_

    new_nodes(1, :) = ( &
         minus_start * minus_start * nodes(1, :) + &
         2.0_dp * start * minus_start * nodes(2, :) + &
         start * start * nodes(3, :))
    new_nodes(2, :) = ( &
         minus_start * minus_end * nodes(1, :) + &
         (end_ + start - 2.0_dp * prod_both) * nodes(2, :) + &
         prod_both * nodes(3, :))
    new_nodes(3, :) = ( &
         minus_end * minus_end * nodes(1, :) + &
         2.0_dp * end_ * minus_end * nodes(2, :) + &
         end_ * end_ * nodes(3, :))

  end subroutine specialize_curve_quadratic

  subroutine specialize_curve( &
       nodes, degree, dimension_, start, end_, curve_start, curve_end, &
       new_nodes, true_start, true_end)

    !f2py integer intent(hide), depend(nodes) :: dimension_ = size(nodes, 2)
    real(dp), intent(in) :: nodes(degree + 1, dimension_)
    integer :: dimension_
    integer, intent(in) :: degree
    real(dp), intent(in) :: start, end_, curve_start, curve_end
    real(dp), intent(out) :: new_nodes(degree + 1, dimension_)
    real(dp), intent(out) :: true_start, true_end
    ! Variables outside of signature.
    real(dp) :: interval_delta

    if (degree == 1) then
       new_nodes(1, :) = (1.0_dp - start) * nodes(1, :) + start * nodes(2, :)
       new_nodes(2, :) = (1.0_dp - end_) * nodes(1, :) + end_ * nodes(2, :)
    else if (degree == 2) then
       call specialize_curve_quadratic( &
            nodes, dimension_, start, end_, new_nodes)
    else
       call specialize_curve_generic( &
            nodes, degree, dimension_, start, end_, new_nodes)
    end if

    ! Now, compute the new interval.
    interval_delta = curve_end - curve_start
    true_start = curve_start + start * interval_delta
    true_end = curve_start + end_ * interval_delta

  end subroutine specialize_curve

  subroutine jacobian_both( &
       num_nodes, dimension_, nodes, degree, new_nodes)

    !f2py integer intent(hide), depend(nodes) :: num_nodes = size(nodes, 1)
    !f2py integer, depend(nodes) :: dimension_ = size(nodes, 2)
    integer :: num_nodes
    integer :: dimension_
    real(dp), intent(in) :: nodes(num_nodes, dimension_)
    integer :: degree
    real(dp), intent(out) :: new_nodes(num_nodes - degree - 1, 2 * dimension_)
    ! Variables outside of signature.
    integer :: index_, i, j, k, num_vals

    index_ = 1
    i = 1
    j = degree + 2
    do num_vals = degree, 1, -1
       do k = 0, num_vals - 1
          ! jacobian_s
          new_nodes(index_, :dimension_) = nodes(i + 1, :) - nodes(i, :)
          ! jacobian_t
          new_nodes(index_, dimension_ + 1:) = nodes(j, :) - nodes(i, :)
          ! Update the indices
          index_ = index_ + 1
          i = i + 1
          j = j + 1
       end do
       ! In between each row, the index_ gains an extra value.
       i = i + 1
    end do

    new_nodes = degree * new_nodes

  end subroutine jacobian_both

  subroutine evaluate_hodograph(s, nodes, dimension_, degree, hodograph)

    !f2py integer intent(hide), depend(nodes) :: dimension_ = size(nodes, 2)
    real(dp), intent(in) :: s
    real(dp), intent(in) :: nodes(degree + 1, dimension_)
    integer :: dimension_
    integer, intent(in) :: degree
    real(dp), intent(out) :: hodograph(1, dimension_)
    ! Variables outside of signature.
    real(dp) :: first_deriv(degree, dimension_)
    real(dp) :: param(1)

    first_deriv = nodes(2:, :) - nodes(:degree, :)
    param = s
    call evaluate_multi( &
         first_deriv, degree - 1, dimension_, param, 1, hodograph)
    hodograph = degree * hodograph

  end subroutine evaluate_hodograph

  subroutine newton_refine_intersect( &
       s, nodes1, degree1, t, nodes2, degree2, new_s, new_t)

    !f2py integer intent(hide), depend(nodes1) :: degree1 = size(nodes1, 1) - 1
    !f2py integer intent(hide), depend(nodes2) :: degree2 = size(nodes2, 1) - 1
    real(dp), intent(in) :: s
    real(dp), intent(in) :: nodes1(degree1 + 1, 2)
    integer :: degree1
    real(dp), intent(in) :: t
    real(dp), intent(in) :: nodes2(degree2 + 1, 2)
    integer :: degree2
    real(dp), intent(out) :: new_s, new_t
    ! Variables outside of signature.
    real(dp) :: param(1)
    real(dp) :: func_val(1, 2)
    real(dp) :: workspace(1, 2)
    real(dp) :: jac_mat(2, 2)
    real(dp) :: determinant, delta_s, delta_t

    param = t
    call evaluate_multi( &
         nodes2, degree2, 2, param, 1, func_val)
    param = s
    call evaluate_multi( &
         nodes1, degree1, 2, param, 1, workspace)
    func_val = func_val - workspace

    if (all(func_val == 0.0_dp)) then
       new_s = s
       new_t = t
       return
    end if

    call evaluate_hodograph(s, nodes1, 2, degree1, jac_mat(1:1, :))
    ! NOTE: We actually want the negative, since we want -B2'(t), but
    !       since we manually solve the system, it's just algebra
    !       to figure out how to use the negative values.
    call evaluate_hodograph(t, nodes2, 2, degree2, jac_mat(2:2, :))

    determinant = ( &
         jac_mat(1, 1) * jac_mat(2, 2) - jac_mat(1, 2) * jac_mat(2, 1))

    ! NOTE: We manually invert the 2x2 system ([ds, dt] J)^T = f^T.
    delta_s = ( &
         (jac_mat(2, 2) * func_val(1, 1) - &
         jac_mat(2, 1) * func_val(1, 2)) / determinant)
    new_s = s + delta_s

    delta_t = ( &
         (jac_mat(1, 2) * func_val(1, 1) - &
         jac_mat(1, 1) * func_val(1, 2)) / determinant)
    new_t = t + delta_t

  end subroutine newton_refine_intersect

  subroutine jacobian_det( &
       num_nodes, nodes, degree, num_vals, param_vals, evaluated)

    !f2py integer intent(hide), depend(nodes) :: num_nodes = size(nodes, 1)
    !f2py integer intent(hide), depend(param_vals) :: num_vals &
    !f2py     = size(param_vals, 1)
    integer :: num_nodes
    real(dp), intent(in) :: nodes(num_nodes, 2)
    integer :: degree
    integer :: num_vals
    real(dp), intent(in) :: param_vals(num_vals, 2)
    real(dp), intent(out) :: evaluated(num_vals)
    ! Variables outside of signature.
    real(dp) :: jac_nodes(num_nodes - degree - 1, 4)
    real(dp) :: Bs_Bt_vals(num_vals, 4)
    real(dp) :: determinant

    call jacobian_both( &
         num_nodes, 2, nodes, degree, jac_nodes)
    if (degree == 1) then
       determinant = ( &
            jac_nodes(1, 1) * jac_nodes(1, 4) - &
            jac_nodes(1, 2) * jac_nodes(1, 3))
       evaluated = determinant
    else
       call evaluate_cartesian_multi( &
            num_nodes - degree - 1, jac_nodes, degree - 1, &
            num_vals, param_vals, 4, Bs_Bt_vals)
       evaluated = ( &
            Bs_Bt_vals(:, 1) * Bs_Bt_vals(:, 4) - &
            Bs_Bt_vals(:, 2) * Bs_Bt_vals(:, 3))
    end if

  end subroutine jacobian_det

  subroutine bbox_intersect(num_nodes1, nodes1, num_nodes2, nodes2, enum_)

    !f2py integer intent(hide), depend(nodes1) :: num_nodes1 = size(nodes1, 1)
    !f2py integer intent(hide), depend(nodes2) :: num_nodes2 = size(nodes2, 1)
    integer :: num_nodes1, num_nodes2
    real(dp), intent(in) :: nodes1(num_nodes1, 2)
    real(dp), intent(in) :: nodes2(num_nodes2, 2)
    integer, intent(out) :: enum_
    ! Variables outside of signature.
    real(dp) :: left1, right1, bottom1, top1
    real(dp) :: left2, right2, bottom2, top2

    call bbox(num_nodes1, nodes1, left1, right1, bottom1, top1)
    call bbox(num_nodes2, nodes2, left2, right2, bottom2, top2)

    if ( &
         right2 < left1 .OR. right1 < left2 .OR. &
         top2 < bottom1 .OR. top1 < bottom2) then
        enum_ = 2
     else if ( &
          right2 == left1 .OR. right1 == left2 .OR. &
          top2 == bottom1 .OR. top1 == bottom2) then
        enum_ = 1
    else
        enum_ = 0
    end if

  end subroutine bbox_intersect

  subroutine wiggle_interval(value_, result_, success)

    real(dp), intent(in) :: value_
    real(dp), intent(out) :: result_
    logical(1), intent(out) :: success

    success = .TRUE.
    if (-0.5_dp**45 < value_ .AND. value_ < 0.5_dp**45) then
       result_ = 0.0_dp
    else if (0.5_dp**45 <= value_ .AND. value_ <= 1.0_dp - 0.5_dp**45) then
       result_ = value_
    else if ( &
         1.0_dp - 0.5_dp**45 < value_ .AND. value_ < 1.0_dp + 0.5_dp**45) then
       result_ = 1.0_dp
    else
       success = .FALSE.
    end if

  end subroutine wiggle_interval

  subroutine parallel_different(start0, end0, start1, end1, result_)

    real(dp), intent(in) :: start0(1, 2)
    real(dp), intent(in) :: end0(1, 2)
    real(dp), intent(in) :: start1(1, 2)
    real(dp), intent(in) :: end1(1, 2)
    logical(1), intent(out) :: result_
    ! Variables outside of signature.
    real(dp) :: delta0(1, 2)
    real(dp) :: val1, val2, val3

    delta0 = end0 - start0
    call cross_product(start0, delta0, val1)  ! line0_const
    call cross_product(start1, delta0, val2)  ! start1_against

    if (val1 /= val2) then
       result_ = .TRUE.
       return
    end if

    val1 = dot_product(delta0(1, :), delta0(1, :))  ! norm0_sq
    val2 = dot_product(start1(1, :) - start0(1, :), delta0(1, :))  ! start_numer
    !      0 <= start_numer / norm0_sq <= 1
    ! <==> 0 <= start_numer            <= norm0_sq
    if (0.0_dp <= val2 .AND. val2 <= val1) then
       result_ = .FALSE.
       return
    end if

    val2 = dot_product(end1(1, :) - start0(1, :), delta0(1, :))  ! end_numer
    !      0 <= end_numer / norm0_sq <= 1
    ! <==> 0 <= end_numer            <= norm0_sq
    if (0.0_dp <= val2 .AND. val2 <= val1) then
       result_ = .FALSE.
       return
    end if

    ! We know neither the start or end parameters are in [0, 1], but
    ! they may contain [0, 1] between them.
    val3 = min(val1, val2)  ! min_val
    val1 = max(val1, val2)  ! max_val

    ! So we make sure that 0 isn't between them.
    if (val3 <= 0.0_dp .AND. 0.0_dp <= val1) then
       result_ = .FALSE.
    else
       result_ = .TRUE.
    end if

  end subroutine parallel_different

  subroutine from_linearized( &
       error1, start1, end1, start_node1, end_node1, nodes1, degree1, &
       error2, start2, end2, start_node2, end_node2, nodes2, degree2, &
       refined_s, refined_t, does_intersect, py_exc)

    !f2py integer intent(hide), depend(nodes1) :: degree1 = size(nodes1, 1) - 1
    !f2py integer intent(hide), depend(nodes2) :: degree2 = size(nodes2, 1) - 1
    real(dp), intent(in) :: error1, start1, end1
    real(dp), intent(in) :: start_node1(1, 2)
    real(dp), intent(in) :: end_node1(1, 2)
    real(dp), intent(in) :: nodes1(degree1 + 1, 2)
    integer, intent(in) :: degree1
    real(dp), intent(in) :: error2, start2, end2
    real(dp), intent(in) :: start_node2(1, 2)
    real(dp), intent(in) :: end_node2(1, 2)
    real(dp), intent(in) :: nodes2(degree2 + 1, 2)
    integer, intent(in) :: degree2
    real(dp), intent(out) :: refined_s, refined_t
    logical(1), intent(out) :: does_intersect
    integer, intent(out) :: py_exc
    ! Variables outside of signature.
    real(dp) :: s, t
    integer :: enum_
    logical(1) :: success

    py_exc = 0
    call segment_intersection( &
         start_node1, end_node1, start_node2, end_node2, s, t, success)

    if (success) then
       ! Special case for lines, allow no leeway on almost intersections.
       if (error1 == 0.0_dp .AND. (s < 0.0_dp .OR. 1.0_dp < s)) then
          does_intersect = .FALSE.
          return
       end if

       if (error2 == 0.0_dp .AND. (t < 0.0_dp .OR. 1.0_dp < t)) then
          does_intersect = .FALSE.
          return
       end if

       if (s < -(0.5_dp**16) .OR. 1.0_dp + 0.5_dp**16 < s) then
          does_intersect = .FALSE.
          return
       end if

       if (t < -(0.5_dp**16) .OR. 1.0_dp + 0.5_dp**16 < t) then
          does_intersect = .FALSE.
          return
       end if
    else
       ! Handle special case where the curves are actually lines.
       if (error1 == 0.0_dp .AND. error2 == 0.0_dp) then
          call parallel_different( &
               start_node1, end_node1, start_node2, end_node2, success)
          if (success) then
             does_intersect = .FALSE.
             return
          end if
       else
          call bbox_intersect( &
               degree1 + 1, nodes1, degree2 + 1, nodes2, enum_)
          if (enum_ == 2) then  ! Disjoint
             does_intersect = .FALSE.
             return
          end if
       end if

       ! Expect the wrapper code to raise
       ! NotImplementedError('Line segments parallel.')
       py_exc = 1
       return
    end if

    does_intersect = .TRUE.
    ! Now, promote ``s`` and ``t`` onto the original curves.
    s = (1.0_dp - s) * start1 + s * end1  ! orig_s
    t = (1.0_dp - t) * start2 + t * end2  ! orig_t
    ! Perform one step of Newton iteration to refine the computed
    ! values of s and t.
    call newton_refine_intersect( &
         s, nodes1, degree1, t, nodes2, degree2, refined_s, refined_t)

    call wiggle_interval(refined_s, s, success)
    if (.NOT. success) then
       ! py_exc==2 indicates ``wiggle_interval`` failed.
       py_exc = 2
       return
    end if
    refined_s = s

    call wiggle_interval(refined_t, t, success)
    if (.NOT. success) then
       ! py_exc==2 indicates ``wiggle_interval`` failed.
       py_exc = 2
       return
    end if
    refined_t = t

  end subroutine from_linearized

end module speedup

! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     https://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

module helpers

  use, intrinsic :: iso_c_binding, only: c_double, c_int, c_bool
  use types, only: dp
  implicit none
  private
  public &
       WIGGLE, VECTOR_CLOSE_EPS, cross_product, bbox, wiggle_interval, &
       contains_nd, vector_close, in_interval, ulps_away

  real(c_double), parameter :: WIGGLE = 0.5_dp**45
  ! NOTE: This is intended to be used as the default value for ``eps``
  !       in ``vector_close``.
  real(c_double), parameter :: VECTOR_CLOSE_EPS = 0.5_dp**40

contains

  subroutine cross_product( &
       vec0, vec1, result_) &
       bind(c, name='cross_product')

    real(c_double), intent(in) :: vec0(1, 2)
    real(c_double), intent(in) :: vec1(1, 2)
    real(c_double), intent(out) :: result_

    result_ = vec0(1, 1) * vec1(1, 2) - vec0(1, 2) * vec1(1, 1)

  end subroutine cross_product

  subroutine bbox( &
       num_nodes, nodes, left, right, bottom, top) &
       bind(c, name='bbox')

    integer(c_int), intent(in) :: num_nodes
    real(c_double), intent(in) :: nodes(num_nodes, 2)
    real(c_double), intent(out) :: left, right, bottom, top
    ! Variables outside of signature.
    real(c_double) :: workspace(2)

    workspace = minval(nodes, 1)
    left = workspace(1)
    bottom = workspace(2)
    workspace = maxval(nodes, 1)
    right = workspace(1)
    top = workspace(2)

  end subroutine bbox

  subroutine wiggle_interval( &
       value_, result_, success) &
       bind(c, name='wiggle_interval')

    real(c_double), intent(in) :: value_
    real(c_double), intent(out) :: result_
    logical(c_bool), intent(out) :: success

    success = .TRUE.
    if (-WIGGLE < value_ .AND. value_ < WIGGLE) then
       result_ = 0.0_dp
    else if (WIGGLE <= value_ .AND. value_ <= 1.0_dp - WIGGLE) then
       result_ = value_
    else if ( &
         1.0_dp - WIGGLE < value_ .AND. value_ < 1.0_dp + WIGGLE) then
       result_ = 1.0_dp
    else
       success = .FALSE.
    end if

  end subroutine wiggle_interval

  pure subroutine contains_nd( &
       num_nodes, dimension_, nodes, point, predicate) &
       bind(c, name='contains_nd')

    integer(c_int), intent(in) :: num_nodes, dimension_
    real(c_double), intent(in) :: nodes(num_nodes, dimension_)
    real(c_double), intent(in) :: point(dimension_)
    logical(c_bool), intent(out) :: predicate

    if (any(point < minval(nodes, 1))) then
       predicate = .FALSE.
    else if (any(maxval(nodes, 1) < point)) then
       predicate = .FALSE.
    else
       predicate = .TRUE.
    end if

  end subroutine contains_nd

  logical(c_bool) pure function vector_close( &
       num_values, vec1, vec2, eps) result(is_close) &
       bind(c, name='vector_close')

    integer(c_int), intent(in) :: num_values
    real(c_double), intent(in) :: vec1(1, num_values)
    real(c_double), intent(in) :: vec2(1, num_values)
    real(c_double), intent(in) :: eps
    ! Variables outside of signature.
    real(c_double) :: size1, size2

    size1 = norm2(vec1)
    size2 = norm2(vec2)
    if (size1 == 0.0_dp) then
       is_close = size2 <= eps
    else if (size2 == 0.0_dp) then
       is_close = size1 <= eps
    else
       ! This is the most common path.
       is_close = norm2(vec1 - vec2) <= eps * min(size1, size2)
    end if

  end function vector_close

  pure function in_interval( &
       value_, start, end) result(predicate) &
       bind(c, name='in_interval')

    real(c_double), intent(in) :: value_, start, end
    logical(c_bool) :: predicate

    predicate = (start <= value_) .AND. (value_ <= end)

  end function in_interval

  pure function ulps_away( &
       value1, value2, num_bits, eps) result(predicate) &
       bind(c, name='ulps_away')

    real(c_double), intent(in) :: value1, value2
    integer(c_int), intent(in) :: num_bits
    real(c_double), intent(in) :: eps
    logical(c_bool) :: predicate

    if (value1 == 0.0_dp) then
       predicate = abs(value2) < eps
    else if (value2 == 0.0_dp) then
       predicate = abs(value1) < eps
    else
       ! NOTE: This assumes `spacing` always returns a positive (which is
       !       not the case with ``numpy.spacing``, which keeps the sign
       !       of the input).
       ! NOTE: This will be the most common path through this function.
       predicate = abs(value1 - value2) <= num_bits * spacing(value1)
    end if

  end function ulps_away

end module helpers

! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     https://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

module triangle_intersection

  use, intrinsic :: iso_c_binding, only: c_double, c_int, c_bool
  use status, only: &
       Status_SUCCESS, Status_INSUFFICIENT_SPACE, Status_SAME_CURVATURE, &
       Status_BAD_INTERIOR, Status_EDGE_END, Status_UNKNOWN
  use curve, only: CurveData, LOCATE_MISS, evaluate_hodograph, get_curvature
  use curve_intersection, only: &
       BoxIntersectionType_INTERSECTION, INTERSECTIONS_WORKSPACE, &
       bbox_intersect, all_intersections
  use helpers, only: cross_product, contains_nd, vector_close
  use types, only: dp
  use triangle, only: &
       evaluate_barycentric, jacobian_both, subdivide_nodes, compute_edge_nodes
  implicit none
  private &
       LocateCandidate, &
       MAX_LOCATE_SUBDIVISIONS, LOCATE_EPS, MAX_EDGES, &
       ALMOST_TANGENT, SEGMENT_ENDS_WORKSPACE, SEGMENTS_WORKSPACE, &
       newton_refine_solve, split_candidate, allocate_candidates, &
       update_candidates, ignored_edge_corner, ignored_double_corner, &
       ignored_corner, classify_tangent_intersection, &
       no_intersections, remove_node, finalize_segment, &
       check_contained
  public &
       Intersection, CurvedPolygonSegment, IntersectionClassification_UNSET, &
       IntersectionClassification_FIRST, IntersectionClassification_SECOND, &
       IntersectionClassification_OPPOSED, &
       IntersectionClassification_TANGENT_FIRST, &
       IntersectionClassification_TANGENT_SECOND, &
       IntersectionClassification_IGNORED_CORNER, &
       IntersectionClassification_TANGENT_BOTH, &
       IntersectionClassification_COINCIDENT, &
       IntersectionClassification_COINCIDENT_UNUSED, &
       TriangleContained_NEITHER, &
       TriangleContained_FIRST, TriangleContained_SECOND, newton_refine, &
       locate_point, classify_intersection, update_edge_end_unused, &
       find_corner_unused, add_st_vals, should_keep, &
       triangles_intersection_points, is_first, is_second, &
       get_next, to_front, add_segment, &
       interior_combine, triangles_intersect, triangles_intersect_abi, &
       free_triangle_intersections_workspace

  integer(c_int), parameter :: IntersectionClassification_UNSET = -99

  ! NOTE: This (for now) is not meant to be C-interoperable.
  type :: Intersection
     real(c_double) :: s = -1.0_dp
     real(c_double) :: t = -1.0_dp
     integer(c_int) :: index_first = -1
     integer(c_int) :: index_second = -1
     integer(c_int) :: interior_curve = IntersectionClassification_UNSET
  end type Intersection

  ! For ``locate_point``; this is not meant to be C-interoperable.
  type :: LocateCandidate
     real(c_double) :: centroid_x = 1.0_dp  ! Actually triple.
     real(c_double) :: centroid_y = 1.0_dp  ! Actually triple.
     real(c_double) :: width = 1.0_dp
     real(c_double), allocatable :: nodes(:, :)
  end type LocateCandidate

  type, bind(c) :: CurvedPolygonSegment
     real(c_double) :: start
     real(c_double) :: end_
     integer(c_int) :: edge_index
  end type CurvedPolygonSegment

  ! NOTE: These values are also defined in equivalent Python source.
  integer(c_int), parameter :: MAX_LOCATE_SUBDIVISIONS = 20
  real(c_double), parameter :: LOCATE_EPS = 0.5_dp**47
  integer(c_int), parameter :: MAX_EDGES = 10
  ! Values of IntersectionClassification enum. These values must be
  ! non-negative, they will be used as exponents for "bit flip" check.
  ! There is a "special" ``UNSET`` value which won't actually be used
  ! after a classification is finalized. See:
  integer(c_int), parameter :: IntersectionClassification_FIRST = 0
  integer(c_int), parameter :: IntersectionClassification_SECOND = 1
  integer(c_int), parameter :: IntersectionClassification_OPPOSED = 2
  integer(c_int), parameter :: IntersectionClassification_TANGENT_FIRST = 3
  integer(c_int), parameter :: IntersectionClassification_TANGENT_SECOND = 4
  integer(c_int), parameter :: IntersectionClassification_IGNORED_CORNER = 5
  integer(c_int), parameter :: IntersectionClassification_TANGENT_BOTH = 6
  integer(c_int), parameter :: IntersectionClassification_COINCIDENT = 7
  integer(c_int), parameter :: IntersectionClassification_COINCIDENT_UNUSED = 8
  ! Values of TriangleContained enum:
  integer(c_int), parameter :: TriangleContained_NEITHER = 0
  integer(c_int), parameter :: TriangleContained_FIRST = 1
  integer(c_int), parameter :: TriangleContained_SECOND = 2
  ! Threshold where a vector cross-product (u x v) is considered
  ! to be "zero". This is a "hack", since it doesn't take ||u||
  ! or ||v|| into account.
  real(c_double), parameter :: ALMOST_TANGENT = 0.5_dp**50
  ! Long-lived workspaces for ``triangles_intersect_abi()``. If multiple
  ! threads are used, each of these **should** be thread-local.
  integer(c_int), allocatable :: SEGMENT_ENDS_WORKSPACE(:)
  type(CurvedPolygonSegment), allocatable :: SEGMENTS_WORKSPACE(:)

contains

  subroutine newton_refine_solve( &
       jac_both, x_val, triangle_x, y_val, triangle_y, delta_s, delta_t)

    ! NOTE: This is a helper for ``newton_refine``.

    real(c_double), intent(in) :: jac_both(4, 1)
    real(c_double), intent(in) :: x_val, triangle_x
    real(c_double), intent(in) :: y_val, triangle_y
    real(c_double), intent(out) :: delta_s, delta_t
    ! Variables outside of signature.
    real(c_double) :: e_val, f_val, denominator

    e_val = x_val - triangle_x
    f_val = y_val - triangle_y
    denominator = ( &
         jac_both(1, 1) * jac_both(4, 1) - jac_both(2, 1) * jac_both(3, 1))
    delta_s = (jac_both(4, 1) * e_val - jac_both(3, 1) * f_val) / denominator
    delta_t = (jac_both(1, 1) * f_val - jac_both(2, 1) * e_val) / denominator

  end subroutine newton_refine_solve

  subroutine newton_refine( &
       num_nodes, nodes, degree, x_val, y_val, &
       s, t, updated_s, updated_t) &
       bind(c, name='BEZ_newton_refine_triangle')

    integer(c_int), intent(in) :: num_nodes
    real(c_double), intent(in) :: nodes(2, num_nodes)
    integer(c_int), intent(in) :: degree
    real(c_double), intent(in) :: x_val, y_val
    real(c_double), intent(in) :: s, t
    real(c_double), intent(out) :: updated_s, updated_t
    ! Variables outside of signature.
    real(c_double) :: point(2, 1), jac_both(4, 1)
    real(c_double) :: jac_nodes(4, num_nodes - degree - 1)
    real(c_double) :: delta_s, delta_t

    call evaluate_barycentric( &
         num_nodes, 2, nodes, degree, &
         1.0_dp - s - t, s, t, point)

    if (point(1, 1) == x_val .AND. point(2, 1) == y_val) then
       ! No refinement is needed.
       updated_s = s
       updated_t = t
       return
    end if

    call jacobian_both( &
         num_nodes, 2, nodes, degree, jac_nodes)
    call evaluate_barycentric( &
         num_nodes - degree - 1, 4, jac_nodes, degree - 1, &
         1.0_dp - s - t, s, t, jac_both)
    call newton_refine_solve( &
         jac_both, x_val, point(1, 1), &
         y_val, point(2, 1), delta_s, delta_t)
    updated_s = s + delta_s
    updated_t = t + delta_t

  end subroutine newton_refine

  subroutine split_candidate( &
       num_nodes, degree, candidate, num_next_candidates, next_candidates)

    ! NOTE: This assumes nodes are 2-dimensional.
    ! NOTE: This assumes that the nodes in each sub-candidate are
    !       not yet allocated.

    integer(c_int), intent(in) :: num_nodes
    integer(c_int), intent(in) :: degree
    type(LocateCandidate), intent(in) :: candidate
    integer(c_int), intent(in) :: num_next_candidates
    type(LocateCandidate), intent(inout) :: next_candidates(:)
    ! Variables outside of signature.
    real(c_double) :: half_width

    ! Allocate the new nodes and call sub-divide.
    ! NOTE: This **assumes** but does not check that if the nodes are
    !       allocated, they are also the correct shape.
    if (.NOT. allocated(next_candidates(num_next_candidates - 3)%nodes)) then
       allocate(next_candidates(num_next_candidates - 3)%nodes(2, num_nodes))
    end if
    if (.NOT. allocated(next_candidates(num_next_candidates - 2)%nodes)) then
       allocate(next_candidates(num_next_candidates - 2)%nodes(2, num_nodes))
    end if
    if (.NOT. allocated(next_candidates(num_next_candidates - 1)%nodes)) then
       allocate(next_candidates(num_next_candidates - 1)%nodes(2, num_nodes))
    end if
    if (.NOT. allocated(next_candidates(num_next_candidates)%nodes)) then
       allocate(next_candidates(num_next_candidates)%nodes(2, num_nodes))
    end if

    call subdivide_nodes( &
         num_nodes, 2, candidate%nodes, degree, &
         next_candidates(num_next_candidates - 3)%nodes, &
         next_candidates(num_next_candidates - 2)%nodes, &
         next_candidates(num_next_candidates - 1)%nodes, &
         next_candidates(num_next_candidates)%nodes)

    half_width = 0.5_dp * candidate%width

    ! Subdivision A.
    next_candidates(num_next_candidates - 3)%centroid_x = ( &
         candidate%centroid_x - half_width)
    next_candidates(num_next_candidates - 3)%centroid_y = ( &
         candidate%centroid_y - half_width)
    next_candidates(num_next_candidates - 3)%width = half_width

    ! Subdivision B.
    next_candidates(num_next_candidates - 2)%centroid_x = candidate%centroid_x
    next_candidates(num_next_candidates - 2)%centroid_y = candidate%centroid_y
    next_candidates(num_next_candidates - 2)%width = -half_width

    ! Subdivision C.
    next_candidates(num_next_candidates - 1)%centroid_x = ( &
         candidate%centroid_x + candidate%width)
    next_candidates(num_next_candidates - 1)%centroid_y = ( &
         next_candidates(num_next_candidates - 3)%centroid_y)
    next_candidates(num_next_candidates - 1)%width = half_width

    ! Subdivision D.
    next_candidates(num_next_candidates)%centroid_x = ( &
         next_candidates(num_next_candidates - 3)%centroid_x)
    next_candidates(num_next_candidates)%centroid_y = ( &
         candidate%centroid_y + candidate%width)
    next_candidates(num_next_candidates)%width = half_width

  end subroutine split_candidate

  subroutine allocate_candidates(num_candidates, next_candidates)
    integer(c_int), intent(in) :: num_candidates
    type(LocateCandidate), allocatable, intent(inout) :: next_candidates(:)

    if (allocated(next_candidates)) then
       if (size(next_candidates) < 4 * num_candidates) then
          deallocate(next_candidates)
          allocate(next_candidates(4 * num_candidates))
       end if
    else
       allocate(next_candidates(4 * num_candidates))
    end if

  end subroutine allocate_candidates

  subroutine update_candidates( &
       num_nodes, degree, point, num_candidates, candidates, &
       num_next_candidates, next_candidates)

    integer(c_int), intent(in) :: num_nodes, degree
    real(c_double), intent(in) :: point(2)
    integer(c_int), intent(in) :: num_candidates
    type(LocateCandidate), intent(in) :: candidates(:)
    integer(c_int), intent(inout) :: num_next_candidates
    type(LocateCandidate), allocatable, intent(inout) :: next_candidates(:)
    ! Variables outside of signature.
    integer(c_int) :: cand_index
    logical(c_bool) :: predicate

    call allocate_candidates(num_candidates, next_candidates)

    do cand_index = 1, num_candidates
       call contains_nd( &
            num_nodes, 2, candidates(cand_index)%nodes, &
            point, predicate)

       if (predicate) then
          num_next_candidates = num_next_candidates + 4
          call split_candidate( &
               num_nodes, degree, candidates(cand_index), &
               num_next_candidates, next_candidates)
       end if
    end do

  end subroutine update_candidates

  subroutine locate_point( &
       num_nodes, nodes, degree, x_val, y_val, s_val, t_val) &
       bind(c, name='BEZ_locate_point_triangle')

    ! NOTE: This solves the inverse problem B(s, t) = (x, y) (if it can be
    !       solved). Does so by subdividing the triangle until the sub-triangles
    !       are sufficiently small, then using Newton's method to narrow
    !       in on the pre-image of the point.
    ! NOTE: This returns ``-1`` (``LOCATE_MISS``) for ``s_val`` as a signal
    !       for "point is not on the triangle".
    ! NOTE: This assumes, but does not check, that the triangle is "valid",
    !       i.e. all pre-images are unique.

    integer(c_int), intent(in) :: num_nodes
    real(c_double), intent(in) :: nodes(2, num_nodes)
    integer(c_int), intent(in) :: degree
    real(c_double), intent(in) :: x_val, y_val
    real(c_double), intent(out) :: s_val, t_val
    ! Variables outside of signature.
    real(c_double) :: point(2)
    integer(c_int) :: sub_index
    integer(c_int) :: num_candidates, num_next_candidates
    type(LocateCandidate), allocatable :: candidates_odd(:), candidates_even(:)
    real(c_double) :: s_approx, t_approx
    real(c_double) :: actual(2)
    logical(c_bool) :: is_even

    point = [x_val, y_val]
    ! Start out with the full curve.
    allocate(candidates_odd(1))  ! First iteration is odd.
    candidates_odd(1) = LocateCandidate(1.0_dp, 1.0_dp, 1.0_dp, nodes)
    num_candidates = 1
    s_val = LOCATE_MISS

    is_even = .TRUE.  ! At zero.
    do sub_index = 1, MAX_LOCATE_SUBDIVISIONS + 1
       is_even = .NOT. is_even  ! Switch parity.
       num_next_candidates = 0

       if (is_even) then
          ! Read from even, write to odd.
          call update_candidates( &
               num_nodes, degree, point, num_candidates, candidates_even, &
               num_next_candidates, candidates_odd)
       else
          ! Read from odd, write to even.
          call update_candidates( &
               num_nodes, degree, point, num_candidates, candidates_odd, &
               num_next_candidates, candidates_even)
       end if

       ! If there are no more candidates, we are done.
       if (num_next_candidates == 0) then
          return
       end if

       num_candidates = num_next_candidates

    end do

    ! Compute the s- and t-parameters as the mean of the centroid positions.
    ! We divide by `3n` rather than `n` since we have tracked thrice the
    ! centroid rather than the centroid itself (to avoid round-off until
    ! right now).
    if (is_even) then
       ! NOTE: We "exclude" this block from ``lcov`` because it can never
       !       be invoked while ``MAX_LOCATE_SUBDIVISIONS`` is even.
       ! LCOV_EXCL_START
       s_approx = ( &
            sum(candidates_odd(:num_candidates)%centroid_x) / &
            (3.0_dp * num_candidates))
       t_approx = ( &
            sum(candidates_odd(:num_candidates)%centroid_y) / &
            (3.0_dp * num_candidates))
       ! LCOV_EXCL_STOP
    else
       s_approx = ( &
            sum(candidates_even(:num_candidates)%centroid_x) / &
            (3.0_dp * num_candidates))
       t_approx = ( &
            sum(candidates_even(:num_candidates)%centroid_y) / &
            (3.0_dp * num_candidates))
    end if

    call newton_refine( &
         num_nodes, nodes, degree, x_val, y_val, &
         s_approx, t_approx, s_val, t_val)

    ! Check if the solution is "close enough" ...
    call evaluate_barycentric( &
         num_nodes, 2, nodes, degree, &
         1.0_dp - s_val - t_val, s_val, t_val, actual)

    if (vector_close(2, point, actual, LOCATE_EPS)) then
       return
    end if

    ! ... and if **not** close enough, do one more round of
    ! Newton's method if not.
    s_approx = s_val
    t_approx = t_val
    call newton_refine( &
         num_nodes, nodes, degree, x_val, y_val, &
         s_approx, t_approx, s_val, t_val)

  end subroutine locate_point

  logical(c_bool) function ignored_edge_corner( &
       edge_tangent, corner_tangent, num_nodes, &
       previous_edge_nodes) result(predicate)

    real(c_double), intent(in) :: edge_tangent(2)
    real(c_double), intent(in) :: corner_tangent(2)
    integer(c_int), intent(in) :: num_nodes
    real(c_double), intent(in) :: previous_edge_nodes(2, num_nodes)
    ! Variables outside of signature.
    real(c_double) :: cross_prod
    real(c_double) :: alt_corner_tangent(2)

    call cross_product( &
         edge_tangent, corner_tangent, cross_prod)
    ! A negative cross product indicates that ``edge_tangent`` is
    ! "inside" / "to the left" of ``corner_tangent`` (due to right-hand rule).
    if (cross_prod > 0.0_dp) then
       predicate = .FALSE.
       return
    end if

    ! Do the same for the **other** tangent at the corner.
    call evaluate_hodograph( &
         1.0_dp, num_nodes, 2, &
         previous_edge_nodes, alt_corner_tangent)
    ! Change the direction of the "in" tangent so that it points "out".
    alt_corner_tangent = -alt_corner_tangent
    call cross_product( &
         edge_tangent, alt_corner_tangent, cross_prod)
    predicate = (cross_prod <= 0.0_dp)

  end function ignored_edge_corner

  logical(c_bool) function ignored_double_corner( &
       edges_first, edges_second, intersection_, &
       tangent_s, tangent_t) result(predicate)

    ! NOTE: This assumes that ``intersection_%index_(first|second)``
    !       are in [1, 2, 3] (marked as the edges of a triangle).

    type(CurveData), intent(in) :: edges_first(3), edges_second(3)
    type(Intersection), intent(in) :: intersection_
    real(c_double), intent(in) :: tangent_s(2), tangent_t(2)
    ! Variables outside of signature.
    integer(c_int) :: index, num_nodes
    real(c_double) :: alt_tangent_s(2), alt_tangent_t(2)
    real(c_double) :: cross_prod1, cross_prod2, cross_prod3

    ! Compute the other edge for the ``s`` triangle.
    index = 1 + modulo(intersection_%index_first - 2, 3)
    num_nodes = size(edges_first(index)%nodes, 2)
    call evaluate_hodograph( &
         1.0_dp, num_nodes, 2, &
         edges_first(index)%nodes, alt_tangent_s)

    ! First check if ``tangent_t`` is interior to the ``s`` triangle.
    call cross_product( &
         tangent_s, tangent_t, cross_prod1)
    ! A positive cross product indicates that ``tangent_t`` is
    ! interior to ``tangent_s``. Similar for ``alt_tangent_s``.
    ! If ``tangent_t`` is interior to both, then the triangles
    ! do more than just "kiss" at the corner, so the corner should
    ! not be ignored.
    if (cross_prod1 >= 0.0_dp) then
       ! Only compute ``cross_prod2`` if we need to.
       call cross_product( &
            alt_tangent_s, tangent_t, cross_prod2)
       if (cross_prod2 >= 0.0_dp) then
          predicate = .FALSE.
          return
       end if
    end if

    ! If ``tangent_t`` is not interior, we check the other ``t``
    ! edge that ends at the corner.
    index = 1 + modulo(intersection_%index_second - 2, 3)
    num_nodes = size(edges_second(index)%nodes, 2)
    call evaluate_hodograph( &
         1.0_dp, num_nodes, 2, &
         edges_second(index)%nodes, alt_tangent_t)
    ! Change the direction of the "in" tangent so that it points "out".
    alt_tangent_t = -alt_tangent_t

    call cross_product( &
         tangent_s, alt_tangent_t, cross_prod2)
    if (cross_prod2 >= 0.0_dp) then
       ! Only compute ``cross_prod3`` if we need to.
       call cross_product( &
            alt_tangent_s, alt_tangent_t, cross_prod3)
       if (cross_prod3 >= 0.0_dp) then
          predicate = .FALSE.
          return
       end if
    end if

    ! If neither of ``tangent_t`` or ``alt_tangent_t`` are interior
    ! to the ``s`` triangle, one of two things is true. Either
    ! the two triangles have no interior intersection (1) or the
    ! ``s`` triangle is bounded by both edges of the ``t`` triangle
    ! at the corner intersection (2). To detect (2), we only need
    ! check if ``tangent_s`` is interior to both ``tangent_t``
    ! and ``alt_tangent_t``. ``cross_prod1`` contains
    ! (tangent_s) x (tangent_t), so it's negative will tell if
    ! ``tangent_s`` is interior. Similarly, ``cross_prod3``
    ! contains (tangent_s) x (alt_tangent_t), but we also reversed
    ! the sign on ``alt_tangent_t`` so switching the sign back
    ! and reversing the arguments in the cross product cancel out.
    predicate = (cross_prod1 > 0.0_dp .OR. cross_prod2 < 0.0_dp)

  end function ignored_double_corner

  logical(c_bool) function ignored_corner( &
       edges_first, edges_second, intersection_, &
       tangent_s, tangent_t) result(predicate)

    ! NOTE: This assumes that ``intersection_%index_(first|second)``
    !       are in [1, 2, 3] (marked as the edges of a triangle).

    type(CurveData), intent(in) :: edges_first(3), edges_second(3)
    type(Intersection), intent(in) :: intersection_
    real(c_double), intent(in) :: tangent_s(2), tangent_t(2)
    ! Variables outside of signature.
    integer(c_int) :: index, num_nodes

    if (intersection_%s == 0.0_dp) then
       if (intersection_%t == 0.0_dp) then
          ! Double corner.
          predicate = ignored_double_corner( &
               edges_first, edges_second, intersection_, &
               tangent_s, tangent_t)
       else
          ! s-only corner.
          index = 1 + modulo(intersection_%index_first - 2, 3)
          ! NOTE: This is a "trick" which requires `modulo` (not `mod`)
          !       since it will return values in {0, 1, 2}. The goal is
          !       to send [1, 2, 3] --> [3, 1, 2] (i.e. move indices to
          !       the left and wrap around).
          num_nodes = size(edges_first(index)%nodes, 2)
          predicate = ignored_edge_corner( &
               tangent_t, tangent_s, num_nodes, edges_first(index)%nodes)
       end if
    else if (intersection_%t == 0.0_dp) then
       ! t-only corner.
       index = 1 + modulo(intersection_%index_second - 2, 3)
       ! NOTE: This is a "trick" which requires `modulo` (not `mod`)
       !       since it will return values in {0, 1, 2}. The goal is
       !       to send [1, 2, 3] --> [3, 1, 2] (i.e. move indices to
       !       the left and wrap around).
       num_nodes = size(edges_second(index)%nodes, 2)
       predicate = ignored_edge_corner( &
            tangent_s, tangent_t, num_nodes, edges_second(index)%nodes)
    else
       predicate = .FALSE.
    end if

  end function ignored_corner

  subroutine classify_tangent_intersection( &
       edges_first, edges_second, intersection_, &
       tangent_s, tangent_t, enum_, status)

    ! NOTE: This **assumes**, but does not check that
    !       ``intersection_%index_(first|second)`` are valid indices within
    !       ``edges_(first|second)`` and that each of those ``CurveData``
    !       instances have already allocated ``%nodes``.

    ! Possible error states:
    ! * Status_SUCCESS       : On success.
    ! * Status_SAME_CURVATURE: If the curves have identical curvature at the
    !                          point of tangency.

    type(CurveData), intent(in) :: edges_first(3), edges_second(3)
    type(Intersection), intent(in) :: intersection_
    real(c_double), intent(in) :: tangent_s(2), tangent_t(2)
    integer(c_int), intent(out) :: enum_
    integer(c_int), intent(out) :: status
    ! Variables outside of signature.
    real(c_double) :: dot_prod
    integer(c_int) :: num_nodes
    real(c_double) :: curvature1, curvature2
    real(c_double) :: sign1, sign2
    real(c_double) :: delta_c

    status = Status_SUCCESS
    dot_prod = dot_product(tangent_s, tangent_t)
    ! NOTE: When computing curvatures we assume that we don't have lines
    !       here, because lines that are tangent at an intersection are
    !       parallel and we don't handle that case.
    num_nodes = size(edges_first(intersection_%index_first)%nodes, 2)
    call get_curvature( &
         num_nodes, edges_first(intersection_%index_first)%nodes, &
         tangent_s, intersection_%s, curvature1)

    num_nodes = size(edges_second(intersection_%index_second)%nodes, 2)
    call get_curvature( &
         num_nodes, edges_second(intersection_%index_second)%nodes, &
         tangent_t, intersection_%t, curvature2)

    if (dot_prod < 0.0_dp) then
       ! If the tangent vectors are pointing in the opposite direction,
       ! then the curves are facing opposite directions.
       sign1 = sign(1.0_dp, curvature1)
       sign2 = sign(1.0_dp, curvature2)
       if (sign1 == sign2) then
          ! If both curvatures are positive, since the curves are
          ! moving in opposite directions, the tangency isn't part of
          ! the triangle intersection.
          if (sign1 == 1.0_dp) then
             enum_ = IntersectionClassification_OPPOSED
          else
             enum_ = IntersectionClassification_TANGENT_BOTH
          end if
       else
          delta_c = abs(curvature1) - abs(curvature2)
          if (delta_c == 0.0_dp) then
             status = Status_SAME_CURVATURE
          else
             sign2 = sign(1.0_dp, delta_c)
             if (sign1 == sign2) then
                enum_ = IntersectionClassification_OPPOSED
             else
                enum_ = IntersectionClassification_TANGENT_BOTH
             end if
          end if
       end if
    else
       if (curvature1 > curvature2) then
          enum_ = IntersectionClassification_TANGENT_FIRST
       else if (curvature1 < curvature2) then
          enum_ = IntersectionClassification_TANGENT_SECOND
       else
          status = Status_SAME_CURVATURE
       end if
    end if

  end subroutine classify_tangent_intersection

  subroutine classify_intersection( &
       edges_first, edges_second, intersection_, enum_, status)

    ! NOTE: This is **explicitly** not intended for C inter-op.
    ! NOTE: This subroutine is not part of the C ABI for this module,
    !       but it is (for now) public, so that it can be tested.
    ! NOTE: This **assumes**, but does not check that
    !       ``intersection_%index_(first|second)`` are valid indices within
    !       ``edges_(first|second)`` and that each of those ``CurveData``
    !       instances have already allocated ``%nodes``.

    ! Possible error states:
    ! * Status_SUCCESS       : On success.
    ! * Status_EDGE_END      : If either the s- or t-parameter of the
    !                          intersection is equal to ``1.0``, i.e. if the
    !                          intersection is at the end of an edge. Since
    !                          another edge of the triangle will also contain
    !                          that point (at it's beginning), that edge
    !                          should be used.
    ! * Status_SAME_CURVATURE: Via ``classify_tangent_intersection()``.

    type(CurveData), intent(in) :: edges_first(3), edges_second(3)
    type(Intersection), intent(in) :: intersection_
    integer(c_int), intent(out) :: enum_
    integer(c_int), intent(out) :: status
    ! Variables outside of signature.
    integer(c_int) :: num_nodes
    real(c_double) :: tangent_s(2), tangent_t(2)
    real(c_double) :: cross_prod

    status = Status_SUCCESS
    if (intersection_%s == 1.0_dp .OR. intersection_%t == 1.0_dp) then
       status = Status_EDGE_END
       return
    end if

    ! NOTE: We assume, but don't check that ``%nodes`` is allocated
    !       and that it has 2 columns.
    num_nodes = size(edges_first(intersection_%index_first)%nodes, 2)
    call evaluate_hodograph( &
         intersection_%s, num_nodes, 2, &
         edges_first(intersection_%index_first)%nodes, tangent_s)

    ! NOTE: We assume, but don't check that ``%nodes`` is allocated
    !       and that it has 2 columns.
    num_nodes = size(edges_second(intersection_%index_second)%nodes, 2)
    call evaluate_hodograph( &
         intersection_%t, num_nodes, 2, &
         edges_second(intersection_%index_second)%nodes, tangent_t)

    if (ignored_corner( &
         edges_first, edges_second, intersection_, &
         tangent_s, tangent_t)) then
       enum_ = IntersectionClassification_IGNORED_CORNER
       return
    end if

    ! Take the cross product of tangent vectors to determine which one
    ! is more "inside" / "to the left".
    call cross_product( &
         tangent_s, tangent_t, cross_prod)
    if (cross_prod < -ALMOST_TANGENT) then
       enum_ = IntersectionClassification_FIRST
    else if (cross_prod > ALMOST_TANGENT) then
       enum_ = IntersectionClassification_SECOND
    else
       ! NOTE: A more robust approach would take ||tangent1|| and ||tangent2||
       !       into account when comparing (tangent1 x tangent2) to the
       !       "almost zero" threshold. We (for now) avoid doing this because
       !       normalizing the tangent vectors has a "cost" of ~6 flops each
       !       and that cost would happen for **every** single intersection.
       call classify_tangent_intersection( &
            edges_first, edges_second, intersection_, &
            tangent_s, tangent_t, enum_, status)
    end if

  end subroutine classify_intersection

  subroutine update_edge_end_unused( &
       s, index_first, t, index_second, &
       intersections, num_intersections)

    ! NOTE: This assumes, but does not check, that at least one of
    !       ``s == 1`` or ``t == 1`` is true. I.e. the caller must **pass**
    !       in a corner that is at the end of an edge.
    ! NOTE: This is **explicitly** not intended for C inter-op.
    ! NOTE: This subroutine is not part of the C ABI for this module,
    !       but it is (for now) public, so that it can be tested.

    real(c_double), intent(in) :: s
    integer(c_int), intent(in) :: index_first
    real(c_double), intent(in) :: t
    integer(c_int), intent(in) :: index_second
    type(Intersection), intent(inout) :: intersections(:)
    integer(c_int), intent(inout) :: num_intersections
    ! Variables outside of signature.
    real(c_double) :: front_s, front_t
    integer(c_int) :: i, index1, index2

    ! First, "rotate" the indices according the which edge is at the end.
    if (s == 1.0_dp) then
       front_s = 0.0_dp
       index1 = 1 + modulo(index_first, 3)
    else
       front_s = s
       index1 = index_first
    end if
    if (t == 1.0_dp) then
       front_t = 0.0_dp
       index2 = 1 + modulo(index_second, 3)
    else
       front_t = t
       index2 = index_second
    end if

    ! Then, try to find an intersection matching our edge indices and
    ! starting at a relevant corner. If we do find a match, edit the
    ! classification in place.
    if (front_s == 0.0_dp) then
       do i = 1, num_intersections
          if (index1 == intersections(i)%index_first .AND. &
               index2 == intersections(i)%index_second .AND. &
               intersections(i)%s == 0.0_dp) then
             intersections(i)%interior_curve = ( &
                  IntersectionClassification_COINCIDENT_UNUSED)
             return
          end if
       end do
    else
       ! NOTE: This assumes, but does not check, that ``front_t == 0``.
       do i = 1, num_intersections
          if (index1 == intersections(i)%index_first .AND. &
               index2 == intersections(i)%index_second .AND. &
               intersections(i)%t == 0.0_dp) then
             intersections(i)%interior_curve = ( &
                  IntersectionClassification_COINCIDENT_UNUSED)
             return
          end if
       end do
    end if

    ! If we have reached this point, then the ``COINCIDENT_UNUSED``
    ! intersection should be added.
    num_intersections = num_intersections + 1
    intersections(num_intersections)%s = front_s
    intersections(num_intersections)%t = front_t
    intersections(num_intersections)%index_first = index1
    intersections(num_intersections)%index_second = index2
    intersections(num_intersections)%interior_curve = ( &
         IntersectionClassification_COINCIDENT_UNUSED)

  end subroutine update_edge_end_unused

  subroutine find_corner_unused( &
       s, index_first, index_second, &
       intersections, num_intersections, found)

    ! We want to see if a candidate intersection was already added by
    ! ``update_edge_end_unused()``. This assumes the caller has checked
    ! that the ``COINCIDENT_UNUSED`` classification has already been seen
    ! and that the candidate intersection is a corner (i.e. this subroutine
    ! assumes, but does not check, that at least one of ``s == 0`` or
    ! ``t == 0`` is true.)

    ! NOTE: This is **explicitly** not intended for C inter-op.
    ! NOTE: This subroutine is **very** similar to
    !       ``update_edge_end_unused()``.
    ! NOTE: This subroutine is not part of the C ABI for this module,
    !       but it is (for now) public, so that it can be tested.

    real(c_double), intent(in) :: s
    integer(c_int), intent(in) :: index_first
    integer(c_int), intent(in) :: index_second
    type(Intersection), intent(in) :: intersections(:)
    integer(c_int), intent(in) :: num_intersections
    logical(c_bool), intent(out) :: found
    ! Variables outside of signature.
    integer(c_int) :: i

    found = .FALSE.
    if (s == 0.0_dp) then
       do i = 1, num_intersections
          if (intersections(i)%interior_curve == &
               IntersectionClassification_COINCIDENT_UNUSED .AND. &
               index_first == intersections(i)%index_first .AND. &
               index_second == intersections(i)%index_second .AND. &
               intersections(i)%s == 0.0_dp) then
             found = .TRUE.
             return
          end if
       end do
    else
       ! NOTE: This assumes, but does not check, that ``t == 0``.
       do i = 1, num_intersections
          if (intersections(i)%interior_curve == &
               IntersectionClassification_COINCIDENT_UNUSED .AND. &
               index_first == intersections(i)%index_first .AND. &
               index_second == intersections(i)%index_second .AND. &
               intersections(i)%t == 0.0_dp) then
             found = .TRUE.
             return
          end if
       end do
    end if

  end subroutine find_corner_unused

  subroutine add_st_vals( &
       edges_first, edges_second, num_st_vals, st_vals, known_enum, &
       index_first, index_second, intersections, num_intersections, status)

    ! NOTE: This is **explicitly** not intended for C inter-op.
    ! NOTE: This subroutine is not part of the C ABI for this module,
    !       but it is (for now) public, so that it can be tested.
    ! NOTE: This assumes but does not check that ``num_st_vals > 0``.
    ! NOTE: This assumes but does not check that each of ``index_first``
    !       and ``index_second`` is in {1, 2, 3}.

    ! Possible error states:
    ! * Status_SUCCESS       : On success.
    ! * Status_EDGE_END      : Via ``classify_intersection()``.
    ! * Status_SAME_CURVATURE: Via ``classify_intersection()``.

    type(CurveData), intent(in) :: edges_first(3), edges_second(3)
    integer(c_int), intent(in) :: num_st_vals
    real(c_double), intent(in) :: st_vals(2, num_st_vals)
    integer(c_int), intent(inout) :: known_enum
    integer(c_int), intent(in) :: index_first, index_second
    type(Intersection), allocatable, intent(inout) :: intersections(:)
    integer(c_int), intent(inout) :: num_intersections
    integer(c_int), intent(out) :: status
    ! Variables outside of signature.
    integer(c_int) :: curr_size, i, intersection_index
    type(Intersection), allocatable :: intersections_swap(:)
    integer(c_int) :: enum_
    logical(c_bool) :: found

    status = Status_SUCCESS

    intersection_index = num_intersections
    ! NOTE: Intersections at the end of an edge will be skipped, so this
    !       may over-estimate the number of intersections.
    num_intersections = num_intersections + num_st_vals
    if (allocated(intersections)) then
       curr_size = size(intersections)
       if (curr_size < num_intersections) then
          allocate(intersections_swap(num_intersections))
          intersections_swap(:curr_size) = intersections(:curr_size)
          call move_alloc(intersections_swap, intersections)
       end if
    else
       allocate(intersections(num_intersections))
    end if

    value_loop: do i = 1, num_st_vals
       if (st_vals(1, i) == 1.0_dp .OR. st_vals(2, i) == 1.0_dp) then
          ! If the intersection is at the end of an edge, ignore it.
          ! This intersection **could** be saved to verify that it matches an
          ! equivalent intersection from the beginning of the previous edge.
          ! In the **special** case that the intersection is classified as
          ! ``COINCIDENT_UNUSED``, we **might** add it (since an intersection
          ! at a corner may be classified differently depending on which
          ! of the 2 or 4 edge pairs it lies on).
          if (known_enum == IntersectionClassification_COINCIDENT_UNUSED) then
             call update_edge_end_unused( &
                  st_vals(1, i), index_first, st_vals(2, i), index_second, &
                  intersections, intersection_index)
          end if
          cycle value_loop
       end if

       ! Before classifying, try to determine if this intersection was
       ! already added as a ``COINCIDENT_UNUSED`` intersection. Only check
       ! if the intersection is at a corner (though it'd be nice to know
       ! check if ``COINCIDENT_UNUSED`` has been encountered).
       if (st_vals(1, i) == 0.0_dp .OR. st_vals(2, i) == 0.0_dp) then
          call find_corner_unused( &
               st_vals(1, i), index_first, index_second, &
               intersections, intersection_index, found)
          if (found) then
             cycle value_loop
          end if
       end if

       intersection_index = intersection_index + 1
       intersections(intersection_index)%s = st_vals(1, i)
       intersections(intersection_index)%t = st_vals(2, i)
       intersections(intersection_index)%index_first = index_first
       intersections(intersection_index)%index_second = index_second

       if (known_enum == IntersectionClassification_UNSET) then
          call classify_intersection( &
               edges_first, edges_second, &
               intersections(intersection_index), enum_, status)
          if (status /= Status_SUCCESS) then
             return
          end if
       else
          enum_ = known_enum
       end if
       intersections(intersection_index)%interior_curve = enum_
    end do value_loop

    ! Actually set ``num_intersections`` based on the number of **accepted**
    ! ``s-t`` pairs.
    num_intersections = intersection_index

  end subroutine add_st_vals

  logical(c_bool) function should_keep(intersection_) result(predicate)

    ! NOTE: This function is not part of the C ABI for this module,
    !       but it is (for now) public, so that it can be tested.

    type(Intersection), intent(in) :: intersection_
    ! Variables outside of signature.
    integer(c_int) :: enum_

    enum_ = intersection_%interior_curve
    ! "Keep" the intersection if it is ``FIRST``, ``SECOND`` or
    ! ``COINCIDENT``.
    if ( &
         enum_ == IntersectionClassification_FIRST .OR. &
         enum_ == IntersectionClassification_SECOND .OR. &
         enum_ == IntersectionClassification_COINCIDENT) then
       predicate = .TRUE.
       return
    end if

    ! "Keep" the intersection if it is tangent and a corner.
    if ( &
         enum_ == IntersectionClassification_TANGENT_FIRST .OR. &
         enum_ == IntersectionClassification_TANGENT_SECOND) then
       if (intersection_%s == 0.0_dp .OR. intersection_%t == 0.0_dp) then
          predicate = .TRUE.
          return
       end if
    end if

    predicate = .FALSE.

  end function should_keep

  subroutine triangles_intersection_points( &
       num_nodes1, nodes1, degree1, &
       num_nodes2, nodes2, degree2, &
       intersections, num_intersections, all_types, status)

    ! NOTE: This is **explicitly** not intended for C inter-op.
    ! NOTE: This (and ``add_st_vals``) ignores duplicate nodes (caused when
    !       an intersection happens at a corner of the triangle, which will
    !       be at the end of one edge and the start of another). If desired,
    !       a "verify" option could be added (as is done in Python) to make
    !       sure that any "duplicate" intersections (i.e. ones that occur at
    !       the end of an edge) do match with the corresponding intersection
    !       at the beginning of an edge (in the case of a double corner, this
    !       means **three** duplicate intersections).
    ! NOTE: The returned ``all_types`` uses the first 9 bits to identify
    !       which classified states are among the intersections. (The
    !       possible classifications must be in {0, 1, 2, 3, 4, 5, 7, 8}).

    ! Possible error states:
    ! * Status_SUCCESS         : On success.
    ! * Status_NO_CONVERGE     : Via ``all_intersections()`` from
    !                            ``curve_intersection.f90``.
    ! * (N >= MAX_CANDIDATES)  : Via ``all_intersections()``.
    ! * Status_BAD_MULTIPLICITY: Via ``all_intersections()``.
    ! * Status_EDGE_END        : Via ``add_st_vals()``.
    ! * Status_SAME_CURVATURE  : Via ``add_st_vals()``.

    integer(c_int), intent(in) :: num_nodes1
    real(c_double), intent(in) :: nodes1(2, num_nodes1)
    integer(c_int), intent(in) :: degree1
    integer(c_int), intent(in) :: num_nodes2
    real(c_double), intent(in) :: nodes2(2, num_nodes2)
    integer(c_int), intent(in) :: degree2
    type(Intersection), allocatable, intent(inout) :: intersections(:)
    integer(c_int), intent(out) :: num_intersections
    integer(c_int), intent(out) :: all_types
    integer(c_int), intent(out) :: status
    ! Variables outside of signature.
    type(CurveData) :: edges_first(3), edges_second(3)
    integer(c_int) :: index1, index2
    integer(c_int) :: num_st_vals
    logical(c_bool) :: coincident
    integer(c_int) :: enum_

    ! Compute the edge nodes for the first triangle.
    allocate(edges_first(1)%nodes(2, degree1 + 1))
    allocate(edges_first(2)%nodes(2, degree1 + 1))
    allocate(edges_first(3)%nodes(2, degree1 + 1))
    call compute_edge_nodes( &
         num_nodes1, 2, nodes1, degree1, &
         edges_first(1)%nodes, edges_first(2)%nodes, edges_first(3)%nodes)

    ! Compute the edge nodes for the second triangle.
    allocate(edges_second(1)%nodes(2, degree2 + 1))
    allocate(edges_second(2)%nodes(2, degree2 + 1))
    allocate(edges_second(3)%nodes(2, degree2 + 1))
    call compute_edge_nodes( &
         num_nodes2, 2, nodes2, degree2, &
         edges_second(1)%nodes, edges_second(2)%nodes, edges_second(3)%nodes)

    num_intersections = 0
    all_types = 0
    do index1 = 1, 3
       do index2 = 1, 3
          call all_intersections( &
               degree1 + 1, edges_first(index1)%nodes, &
               degree2 + 1, edges_second(index2)%nodes, &
               INTERSECTIONS_WORKSPACE, num_st_vals, coincident, status)
          if (coincident) then
             ! NOTE: This assumes, but doesn't check, that ``num_st_vals == 2``
             !       in the coincident case.
             ! The parameters are ``(s1, t1)`` and ``(s2, t2)`` and if
             ! ``s1 >= s2`` or ``t1 >= t2`` then the curves are moving in
             ! opposite directions, hence don't define an interior of an
             ! intersection.
             if (INTERSECTIONS_WORKSPACE(1, 1) >= &
                  INTERSECTIONS_WORKSPACE(1, 2) .OR. &
                  INTERSECTIONS_WORKSPACE(2, 1) >= &
                  INTERSECTIONS_WORKSPACE(2, 2)) then
                enum_ = IntersectionClassification_COINCIDENT_UNUSED
             else
                enum_ = IntersectionClassification_COINCIDENT
             end if
          else
             enum_ = IntersectionClassification_UNSET
          end if
          if (status == Status_SUCCESS) then
             if (num_st_vals > 0) then
                call add_st_vals( &
                     edges_first, edges_second, &
                     num_st_vals, INTERSECTIONS_WORKSPACE(:, :num_st_vals), &
                     enum_, index1, index2, intersections, &
                     num_intersections, status)
                if (status /= Status_SUCCESS) then
                   return  ! LCOV_EXCL_LINE
                end if
             end if
          else
             return
          end if
       end do
    end do

    ! After considering all 9 edge pairs, we go through ``intersections``
    ! and remove any intersections classified as ``COINCIDENT_UNUSED``.
    index1 = 1
    do while (index1 <= num_intersections)
       ! First, update the ``all_types`` "set" with the encountered
       ! classification (whether or not we "keep" the intersection).
       enum_ = intersections(index1)%interior_curve
       ! NOTE: This assumes, but does not check, that ``enum_`` is in
       !       {0, 1, 2, 3, 4, 5, 6, 7, 8} (should be an enum value from
       !       ``IntersectionClassification``) which limits the value of
       !       ``all_types`` to [0, 511] (inclusive).
       all_types = ior(all_types, 2**enum_)
       if (should_keep(intersections(index1))) then
          index1 = index1 + 1
       else
          ! "Discard" the intersection.
          intersections(index1:num_intersections - 1) = ( &
               intersections(index1 + 1:num_intersections))
          num_intersections = num_intersections - 1
       end if
    end do

  end subroutine triangles_intersection_points

  subroutine no_intersections( &
       num_nodes1, nodes1, degree1, &
       num_nodes2, nodes2, degree2, contained)

    ! NOTE: This is a helper for ``triangles_intersect()``.

    integer(c_int), intent(in) :: num_nodes1
    real(c_double), intent(in) :: nodes1(2, num_nodes1)
    integer(c_int), intent(in) :: degree1
    integer(c_int), intent(in) :: num_nodes2
    real(c_double), intent(in) :: nodes2(2, num_nodes2)
    integer(c_int), intent(in) :: degree2
    integer(c_int), intent(out) :: contained
    ! Variables outside of signature.
    real(c_double) :: s_val, t_val

    ! If the first corner of ``triangle1`` is contained in ``triangle2``,
    ! then the whole triangle must be since there are no intersections.
    call locate_point( &
         num_nodes2, nodes2, degree2, &
         nodes1(1, 1), nodes1(2, 1), s_val, t_val)
    if (s_val /= LOCATE_MISS) then
       contained = TriangleContained_FIRST
       return
    end if

    ! If the first corner of ``triangle2`` is contained in ``triangle1``,
    ! then the whole triangle must be since there are no intersections.
    call locate_point( &
         num_nodes1, nodes1, degree1, &
         nodes2(1, 1), nodes2(2, 1), s_val, t_val)
    if (s_val /= LOCATE_MISS) then
       contained = TriangleContained_SECOND
       return
    end if

    ! If neither corner is contained, then there is no intersection.
    contained = TriangleContained_NEITHER

  end subroutine no_intersections

  subroutine remove_node(node, values, remaining)

    ! Removes a value from a list, if it is contained there.
    ! For example, if ``node == 4``, ``values == [1, 2, 4, 7, ...]`` and
    ! ``remainining == 4``, then after this subroutine will update to
    ! ``values == [1, 2, 7, ...]`` and ``remainining == 3``.
    ! NOTE: This assumes the values in ``values`` are in ascending order
    !       and unique.
    ! NOTE: This assumes that ``remaining`` does not exceed ``size(values)``

    integer(c_int), intent(in) :: node
    integer(c_int), intent(inout) :: values(:)
    integer(c_int), intent(inout) :: remaining
    ! Variables outside of signature.
    integer(c_int) :: i

    ! NOTE: Since we assume the values are in ascending order and unique, a
    !       binary search could speed this up. In practice, ``values``
    !       will likely be too small for this to matter.
    do i = 1, remaining
       if (values(i) == node) then
          ! Remove ``values(i)`` by shifting down all remaining values.
          values(i:remaining - 1) = values(i + 1:remaining)
          remaining = remaining - 1
          return
       end if
    end do

  end subroutine remove_node

  logical(c_bool) function is_first(enum_) result(predicate)

    ! NOTE: This function is not part of the C ABI for this module,
    !       but it is (for now) public, so that it can be tested.

    integer(c_int), intent(in) :: enum_

    predicate = ( &
         enum_ == IntersectionClassification_FIRST .OR. &
         enum_ == IntersectionClassification_TANGENT_FIRST)

  end function is_first

  logical(c_bool) function is_second(enum_) result(predicate)

    ! NOTE: This function is not part of the C ABI for this module,
    !       but it is (for now) public, so that it can be tested.

    integer(c_int), intent(in) :: enum_

    predicate = ( &
         enum_ == IntersectionClassification_SECOND .OR. &
         enum_ == IntersectionClassification_TANGENT_SECOND)

  end function is_second

  subroutine get_next( &
       num_intersections, intersections, unused, remaining, &
       start, curr_node, next_node, at_start)

    ! NOTE: This subroutine is not meant to be part of the interface for this
    !       module, but it is (for now) public, so that it can be tested.

    integer(c_int), intent(in) :: num_intersections
    type(Intersection), intent(in) :: intersections(num_intersections)
    ! ``unused`` contains the indices of intersections that have not yet been
    ! used as a node.
    integer(c_int), intent(inout) :: unused(:)
    integer(c_int), intent(inout) :: remaining
    integer(c_int), intent(in) :: start
    type(Intersection), intent(in) :: curr_node
    type(Intersection), intent(out) :: next_node
    logical(c_bool), intent(out) :: at_start
    ! Variables outside of signature.
    real(c_double) :: edge_param
    integer(c_int) :: i, intersection_index

    intersection_index = -1
    at_start = .FALSE.
    if (is_first(curr_node%interior_curve)) then
       do i = 1, num_intersections
          if ( &
               intersections(i)%index_first == curr_node%index_first .AND. &
               intersections(i)%s > curr_node%s) then
             if (intersection_index == -1) then
                intersection_index = i
                edge_param = intersections(i)%s
             else
                if (intersections(i)%s < edge_param) then
                   intersection_index = i
                   edge_param = intersections(i)%s
                end if
             end if
          end if
       end do

       ! If there is no other intersection on the edge, just return
       ! the segment end.
       if (intersection_index == -1) then
          ! NOTE: We **explicitly** do not set ``t`` or ``index_second``.
          next_node%index_first = curr_node%index_first
          next_node%s = 1.0_dp
          next_node%interior_curve = IntersectionClassification_FIRST
       else
          next_node = intersections(intersection_index)
          at_start = (intersection_index == start)
          ! Remove the index from the set of ``unused`` intersections, if
          ! it is contained there.
          call remove_node(intersection_index, unused, remaining)
       end if
    else if (is_second(curr_node%interior_curve)) then
       do i = 1, num_intersections
          if ( &
               intersections(i)%index_second == curr_node%index_second .AND. &
               intersections(i)%t > curr_node%t) then
             if (intersection_index == -1) then
                intersection_index = i
                edge_param = intersections(i)%t
             else
                if (intersections(i)%t < edge_param) then
                   intersection_index = i
                   edge_param = intersections(i)%t
                end if
             end if
          end if
       end do

       ! If there is no other intersection on the edge, just return
       ! the segment end.
       if (intersection_index == -1) then
          ! NOTE: We **explicitly** do not set ``s`` or ``index_first``.
          next_node%index_second = curr_node%index_second
          next_node%t = 1.0_dp
          next_node%interior_curve = IntersectionClassification_SECOND
       else
          next_node = intersections(intersection_index)
          at_start = (intersection_index == start)
          ! Remove the index from the set of ``unused`` intersections, if
          ! it is contained there.
          call remove_node(intersection_index, unused, remaining)
       end if
    else
       ! NOTE: This assumes but does not check that
       !       ``curr_node%interior_curve`` is ``COINCIDENT``.
       ! Moving along the first or second edge will produce the same result,
       ! but since we "rotate" all intersections to the beginning of an edge,
       ! the index may not match the first or second (or both).
       do i = 1, num_intersections
          if ( &
               intersections(i)%index_first == curr_node%index_first .AND. &
               intersections(i)%s > curr_node%s) then
             if (intersection_index == -1) then
                intersection_index = i
                edge_param = intersections(i)%s
             else
                if (intersections(i)%s < edge_param) then
                   intersection_index = i
                   edge_param = intersections(i)%s
                end if
             end if
          end if
       end do

       if (intersection_index /= -1) then
          next_node = intersections(intersection_index)
          at_start = (intersection_index == start)
          ! Remove the index from the set of ``unused`` intersections, if
          ! it is contained there.
          call remove_node(intersection_index, unused, remaining)
          return
       end if

       ! If there is no other intersection on the first edge, try the
       ! second edge.
       do i = 1, num_intersections
          if ( &
               intersections(i)%index_second == curr_node%index_second .AND. &
               intersections(i)%t > curr_node%t) then
             if (intersection_index == -1) then
                intersection_index = i
                edge_param = intersections(i)%t
             else
                if (intersections(i)%t < edge_param) then
                   intersection_index = i
                   edge_param = intersections(i)%t
                end if
             end if
          end if
       end do

       if (intersection_index /= -1) then
          next_node = intersections(intersection_index)
          at_start = (intersection_index == start)
          ! Remove the index from the set of ``unused`` intersections, if
          ! it is contained there.
          call remove_node(intersection_index, unused, remaining)
          return
       end if

       ! If there is no other intersection on either edge, just return
       ! the end of both segments.
       next_node%index_first = curr_node%index_first
       next_node%s = 1.0_dp
       next_node%index_second = curr_node%index_second
       next_node%t = 1.0_dp
       next_node%interior_curve = IntersectionClassification_COINCIDENT
    end if

  end subroutine get_next

  subroutine to_front( &
       num_intersections, intersections, unused, remaining, &
       start, curr_node, next_node, at_start)

    ! NOTE: This subroutine is not meant to be part of the interface for this
    !       module, but it is (for now) public, so that it can be tested.

    ! This assumes (but does not check) that all intersections at the "end" of
    ! an edge (i.e. with ``s == 1.0`` or ``t == 1.0``) have been pruned from
    ! ``intersections`` (see e.g. ``add_st_vals()``). Therefore, if
    ! ``curr_node`` **is** at the end of an edge, it must be one of the
    ! artificial nodes created by ``get_next()``.

    integer(c_int), intent(in) :: num_intersections
    type(Intersection), intent(in) :: intersections(num_intersections)
    ! ``unused`` contains the indices of intersections that have not yet been
    ! used as a node.
    integer(c_int), intent(inout) :: unused(:)
    integer(c_int), intent(inout) :: remaining
    integer(c_int), intent(in) :: start
    type(Intersection), intent(in) :: curr_node
    type(Intersection), intent(out) :: next_node
    logical(c_bool), intent(out) :: at_start
    ! Variables outside of signature.
    integer(c_int) :: i, index

    at_start = .FALSE.
    if (curr_node%s == 1.0_dp) then
       ! This means ``curr_node`` is an "artificial" corner.
       index = 1 + modulo(curr_node%index_first, 3)
       ! First check if the intersection exists when "rotated" to the
       ! next edge.
       do i = 1, num_intersections
          if ( &
               intersections(i)%s == 0.0_dp .AND. &
               intersections(i)%index_first == index) then
             next_node = intersections(i)
             at_start = (i == start)
             ! Remove the index from the set of ``unused`` intersections, if
             ! it is contained there.
             call remove_node(i, unused, remaining)
             return
          end if
       end do

       ! If we didn't match an existing intersection, create another artificial
       ! intersection.
       next_node%s = 0.0_dp
       next_node%index_first = index
       next_node%interior_curve = IntersectionClassification_FIRST
    else if (curr_node%t == 1.0_dp) then
       ! NOTE: We assume, but do not verify, that ``s == 1`` and ``t == 1``
       !       are mutually exclusive since each **must** correspond to an
       !       artificial node.
       ! This means ``curr_node`` is an "artificial" corner.
       index = 1 + modulo(curr_node%index_second, 3)
       do i = 1, num_intersections
          if ( &
               intersections(i)%t == 0.0_dp .AND. &
               intersections(i)%index_second == index) then
             next_node = intersections(i)
             at_start = (i == start)
             ! Remove the index from the set of ``unused`` intersections, if
             ! it is contained there.
             call remove_node(i, unused, remaining)
             return
          end if
       end do

       ! If we didn't match an existing intersection, create another artificial
       ! intersection.
       next_node%t = 0.0_dp
       next_node%index_second = index
       next_node%interior_curve = IntersectionClassification_SECOND
    else
       ! The node doesn't need to be moved to the front of the edge.
       next_node = curr_node
       return
    end if

  end subroutine to_front

  subroutine add_segment(curr_node, next_node, count, segments)

    ! NOTE: This subroutine is not meant to be part of the interface for this
    !       module, but it is (for now) public, so that it can be tested.
    ! NOTE: We assume, but do not check, that ``curr_node%interior_curve``
    !       is either ``FIRST`` or ``SECOND``.

    type(Intersection), intent(in) :: curr_node, next_node
    integer(c_int), intent(inout) :: count
    type(CurvedPolygonSegment), allocatable, intent(inout) :: segments(:)
    ! Variables outside of signature.
    integer(c_int) :: curr_size
    type(CurvedPolygonSegment), allocatable :: segments_swap(:)

    ! Update the count (assumes caller will start with zero).
    count = count + 1

    ! First, make sure we have enough space.
    if (allocated(segments)) then
       curr_size = size(segments)
       if (curr_size < count) then
          allocate(segments_swap(count))
          segments_swap(:curr_size) = segments(:curr_size)
          call move_alloc(segments_swap, segments)
       end if
    else
       allocate(segments(count))
    end if

    if (is_first(curr_node%interior_curve)) then
       segments(count)%start = curr_node%s
       segments(count)%end_ = next_node%s
       ! NOTE: This **assumes**, but does not check that ``index_first``
       !       is the same for both ``curr_node`` and ``next_node``.
       segments(count)%edge_index = curr_node%index_first
    else if (is_second(curr_node%interior_curve)) then
       segments(count)%start = curr_node%t
       segments(count)%end_ = next_node%t
       ! NOTE: This **assumes**, but does not check that ``index_second``
       !       is the same for both ``curr_node`` and ``next_node``.
       segments(count)%edge_index = curr_node%index_second + 3
    else
       ! NOTE: This assumes but does not check that
       !       ``curr_node%interior_curve`` is ``COINCIDENT``.
       if (curr_node%index_first == next_node%index_first) then
          segments(count)%start = curr_node%s
          segments(count)%end_ = next_node%s
          segments(count)%edge_index = curr_node%index_first
       else
          ! NOTE: This **assumes**, but does not check that ``index_second``
          !       is the same for both ``curr_node`` and ``next_node``.
          segments(count)%start = curr_node%t
          segments(count)%end_ = next_node%t
          segments(count)%edge_index = curr_node%index_second + 3
       end if
    end if

  end subroutine add_segment

  subroutine finalize_segment(segment_ends, num_intersected, count)

    integer(c_int), allocatable, intent(inout) :: segment_ends(:)
    integer(c_int), intent(inout) :: num_intersected
    integer(c_int), intent(in) :: count
    ! Variables outside of signature.
    integer(c_int) :: curr_size
    integer(c_int), allocatable :: segment_ends_swap(:)

    ! Update the number intersected (assumes caller will start with zero).
    num_intersected = num_intersected + 1

    if (allocated(segment_ends)) then
       curr_size = size(segment_ends)
       if (curr_size < num_intersected) then
          allocate(segment_ends_swap(num_intersected))
          segment_ends_swap(:curr_size) = segment_ends(:curr_size)
          call move_alloc(segment_ends_swap, segment_ends)
       end if
    else
       allocate(segment_ends(num_intersected))
    end if

    segment_ends(num_intersected) = count

  end subroutine finalize_segment

  subroutine check_contained( &
       num_intersected, segment_ends, segments, contained)

    integer(c_int), intent(inout) :: num_intersected
    integer(c_int), intent(in) :: segment_ends(:)
    type(CurvedPolygonSegment), intent(in) :: segments(:)
    integer(c_int), intent(out) :: contained

    contained = TriangleContained_NEITHER

    ! Only consider cases where there is exactly one curved polygon.
    if (num_intersected /= 1) then
       return
    end if

    ! Only consider cases where the curved polygon has 3 edges.
    if (segment_ends(1) /= 3) then
       return
    end if

    ! NOTE: This assumes, but does not check, that if ``segment_ends == [3]``
    !       then ``segments`` is allocated and at least length 3.
    ! Only consider cases where the **entire** edge is used (no roundoff).
    if ( &
         any(segments(:3)%start /= 0.0_dp) .OR. &
         any(segments(:3)%end_ /= 1.0_dp)) then
       return
    end if

    ! Finally, check if the edges all come from the same triangle.
    if ( &
         all(segments(:3)%edge_index == [1, 2, 3]) .OR. &
         all(segments(:3)%edge_index == [2, 3, 1]) .OR. &
         all(segments(:3)%edge_index == [3, 1, 2])) then
       num_intersected = 0
       contained = TriangleContained_FIRST
    else if ( &
         all(segments(:3)%edge_index == [4, 5, 6]) .OR. &
         all(segments(:3)%edge_index == [5, 6, 4]) .OR. &
         all(segments(:3)%edge_index == [6, 4, 5])) then
       num_intersected = 0
       contained = TriangleContained_SECOND
    end if

  end subroutine check_contained

  subroutine interior_combine( &
       num_intersections, intersections, &
       num_intersected, segment_ends, segments, &
       contained, status)

    ! NOTE: This subroutine is not meant to be part of the interface for this
    !       module, but it is (for now) public, so that it can be tested.
    ! NOTE: ``num_intersected`` will be the **actual** size of
    !       ``segment_ends``. The size is de-coupled from the **actual**
    !       size since allocatable and we want to allow re-use.
    ! NOTE: This assumes, but does not check, that ``num_intersections > 0``.
    ! NOTE: If ``segments`` is already allocated / with data, the data will be
    !       overwritten in place.

    ! Possible error states:
    ! * Status_SUCCESS     : On success.
    ! * Status_BAD_INTERIOR: If a curved polygon requires more than
    !                        ``MAX_EDGES`` sides. (This could be due to either
    !                        a particular complex intersection or a programming
    !                        error which causes ``at_start`` to never be true.)

    integer(c_int), intent(in) :: num_intersections
    type(Intersection), intent(in) :: intersections(num_intersections)
    integer(c_int), intent(out) :: num_intersected
    integer(c_int), allocatable, intent(inout) :: segment_ends(:)
    type(CurvedPolygonSegment), allocatable, intent(inout) :: segments(:)
    integer(c_int), intent(out) :: contained
    integer(c_int), intent(out) :: status
    ! Variables outside of signature.
    integer(c_int) :: unused(num_intersections)
    integer(c_int) :: segment_index
    integer(c_int) :: remaining, i, start
    type(Intersection) :: curr_node, next_node
    logical(c_bool) :: at_start

    ! In this case, we know we'll have at least ``num_intersections`` segments
    ! (and may have more due to corners).
    if (allocated(segments)) then
       if (size(segments) < num_intersections) then
          deallocate(segments)
          allocate(segments(num_intersections))
       end if
    else
       allocate(segments(num_intersections))
    end if

    status = Status_SUCCESS
    contained = TriangleContained_NEITHER

    ! Set all of the unused indices.
    unused = [ (i, i = 1, num_intersections) ]
    remaining = num_intersections
    segment_index = 0  ! Last written index.
    num_intersected = 0
    do while (remaining > 0)
       ! "Pop" off intersection from the end to start a curved polygon.
       start = unused(remaining)
       remaining = remaining - 1

       curr_node = intersections(start)
       at_start = .FALSE.
       ! Now move around the edge segments until the curved polygon's
       ! entire boundary has been traversed.
       edge_loop: do i = 1, MAX_EDGES
          ! Follow along the current edge to the next node.
          call get_next( &
               num_intersections, intersections, unused, remaining, &
               start, curr_node, next_node, at_start)
          call add_segment(curr_node, next_node, segment_index, segments)
          ! After adding the segment, check if we are back where we started.
          if (at_start) then
             exit edge_loop
          end if

          ! Now the ``next_node`` becomes the current node, but we may
          ! need to "rotate" it to the next edge if on a corner.
          call to_front( &
               num_intersections, intersections, unused, remaining, &
               start, next_node, curr_node, at_start)
          ! After "rotating" to the next edge, check if we are back where
          ! we started.
          if (at_start) then
             exit edge_loop
          end if
       end do edge_loop

       if (at_start) then
          call finalize_segment( &
               segment_ends, num_intersected, segment_index)
       else
          ! If the loop terminated without reaching the start node, then
          ! we have encountered an error.
          status = Status_BAD_INTERIOR  ! LCOV_EXCL_LINE
          return  ! LCOV_EXCL_LINE
       end if
    end do

    ! As a final pass, check if the intersection is one of the two triangles.
    call check_contained(num_intersected, segment_ends, segments, contained)

  end subroutine interior_combine

  subroutine triangles_intersect( &
       num_nodes1, nodes1, degree1, &
       num_nodes2, nodes2, degree2, &
       segment_ends, segments, &
       num_intersected, contained, status)

    ! NOTE: ``contained`` will be a ``TriangleContained`` enum.
    ! NOTE: ``num_intersected`` will be the **actual** size of
    !       ``segment_ends``. The size is de-coupled from the allocated
    !       size since we want to allow re-use.
    ! NOTE: ``segment_ends`` will contain the indices that split
    !       ``segments`` into distinct curved polygons. For example,
    !       if the first 3 segments correspond to one curved polygon
    !       and the second 4 segments correspond to another, then
    !       ``segment_ends`` will be ``[3, 7]``.

    ! Possible error states:
    ! * Status_SUCCESS         : On success.
    ! * Status_UNKNOWN         : If all of the intersections are classified
    !                            as ``OPPOSED / IGNORED_CORNER / TANGENT_*``
    !                            but not uniquely one type. (This should
    !                            never occur).
    ! * Status_NO_CONVERGE     : Via ``triangles_intersection_points()``.
    ! * (N >= MAX_CANDIDATES)  : Via ``triangles_intersection_points()``.
    ! * Status_BAD_MULTIPLICITY: Via ``triangles_intersection_points()``.
    ! * Status_EDGE_END        : Via ``triangles_intersection_points()``.
    ! * Status_SAME_CURVATURE  : Via ``triangles_intersection_points()``.
    ! * Status_BAD_INTERIOR    : Via ``interior_combine()``.

    integer(c_int), intent(in) :: num_nodes1
    real(c_double), intent(in) :: nodes1(2, num_nodes1)
    integer(c_int), intent(in) :: degree1
    integer(c_int), intent(in) :: num_nodes2
    real(c_double), intent(in) :: nodes2(2, num_nodes2)
    integer(c_int), intent(in) :: degree2
    integer(c_int), allocatable, intent(inout) :: segment_ends(:)
    type(CurvedPolygonSegment), allocatable, intent(inout) :: segments(:)
    integer(c_int), intent(out) :: num_intersected
    integer(c_int), intent(out) :: contained
    integer(c_int), intent(out) :: status
    ! Variables outside of signature.
    integer(c_int) :: bbox_int
    type(Intersection), allocatable :: intersections(:)
    integer(c_int) :: num_intersections, all_types

    num_intersected = 0
    contained = TriangleContained_NEITHER
    status = Status_SUCCESS

    ! If the bounded boxes do not intersect, the triangles cannot.
    call bbox_intersect( &
         num_nodes1, nodes1, num_nodes2, nodes2, bbox_int)
    if (bbox_int /= BoxIntersectionType_INTERSECTION) then
       return
    end if

    call triangles_intersection_points( &
         num_nodes1, nodes1, degree1, &
         num_nodes2, nodes2, degree2, &
         intersections, num_intersections, all_types, status)
    if (status /= Status_SUCCESS) then
       return
    end if

    if (num_intersections == 0) then
       if (all_types == 0) then
          call no_intersections( &
               num_nodes1, nodes1, degree1, &
               num_nodes2, nodes2, degree2, contained)
          return
       else if (all_types == 2**IntersectionClassification_OPPOSED) then
          return
       else if (all_types == 2**IntersectionClassification_IGNORED_CORNER) then
          return
       else if (all_types == 2**IntersectionClassification_TANGENT_FIRST) then
          contained = TriangleContained_FIRST
          return
       else if (all_types == 2**IntersectionClassification_TANGENT_SECOND) then
          contained = TriangleContained_SECOND
          return
       else if (all_types == &
            2**IntersectionClassification_COINCIDENT_UNUSED) then
          return
       else
          ! NOTE: We "exclude" this block from ``lcov`` because it **should**
          !       never occur. In the case that **none** of the intersections
          !       are ``FIRST`` or ``SECOND``, then they all **should** fall
          !       into the exact same category (which would be one of the
          !       four states above).
          ! LCOV_EXCL_START
          status = Status_UNKNOWN
          return
          ! LCOV_EXCL_STOP
       end if
    end if

    call interior_combine( &
         num_intersections, intersections(:num_intersections), &
         num_intersected, segment_ends, segments, contained, status)

  end subroutine triangles_intersect

  subroutine triangles_intersect_abi( &
       num_nodes1, nodes1, degree1, &
       num_nodes2, nodes2, degree2, &
       segment_ends_size, segment_ends, segments_size, segments, &
       num_intersected, contained, status) &
       bind(c, name='BEZ_triangle_intersections')

    ! NOTE: The number of intersections cannot be known beforehand. If
    !       ``segment_ends`` is not large enough, then it will not be
    !       populated and ``status`` will be set to ``INSUFFICIENT_SPACE``.
    !       However, the value of ``num_intersected`` will be accurate and
    !       ``segment_ends`` should be re-sized by the caller to accommodate.
    !       Additionally, the final element of ``segment_ends`` determines
    !       the number of segments and this may exceed ``segments_size``.
    !       In this case, the ``status`` will also be ``INSUFFICIENT_SPACE``
    !       but the size can be determined by the final element of
    !       ``segment_ends`` and the caller can resize ``segments``
    !       accordingly.

    ! Possible error states:
    ! * Status_SUCCESS           : On success.
    ! * Status_INSUFFICIENT_SPACE: If ``segment_ends_size`` is smaller than
    !                              ``num_intersected`` **OR** if
    !                              ``segments_size`` is smaller than the number
    !                              of segments.
    ! * Status_UNKNOWN           : Via ``triangles_intersect()``.
    ! * Status_NO_CONVERGE       : Via ``triangles_intersect()``.
    ! * (N >= MAX_CANDIDATES)    : Via ``triangles_intersect()``.
    ! * Status_BAD_MULTIPLICITY  : Via ``triangles_intersect()``.
    ! * Status_EDGE_END          : Via ``triangles_intersect()``.
    ! * Status_SAME_CURVATURE    : Via ``triangles_intersect()``.
    ! * Status_BAD_INTERIOR      : Via ``triangles_intersect()``.

    integer(c_int), intent(in) :: num_nodes1
    real(c_double), intent(in) :: nodes1(2, num_nodes1)
    integer(c_int), intent(in) :: degree1
    integer(c_int), intent(in) :: num_nodes2
    real(c_double), intent(in) :: nodes2(2, num_nodes2)
    integer(c_int), intent(in) :: degree2
    integer(c_int), intent(in) :: segment_ends_size
    integer(c_int), intent(out) :: segment_ends(segment_ends_size)
    integer(c_int), intent(in) :: segments_size
    type(CurvedPolygonSegment), intent(out) :: segments(segments_size)
    integer(c_int), intent(out) :: num_intersected
    integer(c_int), intent(out) :: contained
    integer(c_int), intent(out) :: status
    ! Variables outside of signature.
    integer(c_int) :: num_segments

    call triangles_intersect( &
         num_nodes1, nodes1, degree1, &
         num_nodes2, nodes2, degree2, &
         SEGMENT_ENDS_WORKSPACE, SEGMENTS_WORKSPACE, num_intersected, &
         contained, status)

    if (status /= Status_SUCCESS) then
       return
    end if

    if (num_intersected == 0) then
       return
    end if

    if (num_intersected > segment_ends_size) then
       status = Status_INSUFFICIENT_SPACE
       return
    end if

    segment_ends(:num_intersected) = ( &
         SEGMENT_ENDS_WORKSPACE(:num_intersected))
    num_segments = segment_ends(num_intersected)
    if (num_segments > segments_size) then
       status = Status_INSUFFICIENT_SPACE
       return
    end if

    segments(:num_segments) = SEGMENTS_WORKSPACE(:num_segments)

  end subroutine triangles_intersect_abi

  subroutine free_triangle_intersections_workspace() &
       bind(c, name='BEZ_free_triangle_intersections_workspace')

    ! NOTE: This **should** be run during clean-up for any code which
    !       invokes ``triangles_intersect_abi()``.

    if (allocated(SEGMENT_ENDS_WORKSPACE)) then
       deallocate(SEGMENT_ENDS_WORKSPACE)
    end if

    if (allocated(SEGMENTS_WORKSPACE)) then
       deallocate(SEGMENTS_WORKSPACE)
    end if

  end subroutine free_triangle_intersections_workspace

end module triangle_intersection

! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     https://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

module curve

  use iso_c_binding, only: c_double, c_int
  use types, only: dp
  implicit none
  private
  public &
       evaluate_curve_barycentric, evaluate_multi, specialize_curve_generic, &
       specialize_curve_quadratic, specialize_curve, evaluate_hodograph

contains

  subroutine evaluate_curve_barycentric( &
       degree, dimension_, nodes, num_vals, lambda1, lambda2, evaluated) &
       bind(c, name='evaluate_curve_barycentric')

    ! NOTE: This is evaluate_multi_barycentric for a Bezier curve.

    integer(c_int), intent(in) :: degree, dimension_
    real(c_double), intent(in) :: nodes(degree + 1, dimension_)
    integer(c_int), intent(in) :: num_vals
    real(c_double), intent(in) :: lambda1(num_vals)
    real(c_double), intent(in) :: lambda2(num_vals)
    real(c_double), intent(out) :: evaluated(num_vals, dimension_)
    ! Variables outside of signature.
    integer(c_int) :: i, j
    real(c_double) :: lambda2_pow(num_vals)
    integer(c_int) :: binom_val

    lambda2_pow = 1.0_dp
    binom_val = 1

    forall (i = 1:num_vals)
       evaluated(i, :) = lambda1(i) * nodes(1, :)
    end forall

    do i = 2, degree
       lambda2_pow = lambda2_pow * lambda2
       binom_val = (binom_val * (degree - i + 2)) / (i - 1)
       forall (j = 1:num_vals)
          evaluated(j, :) = ( &
               evaluated(j, :) + &
               binom_val * lambda2_pow(j) * nodes(i, :)) * lambda1(j)
       end forall
    end do

    forall (i = 1:num_vals)
       evaluated(i, :) = ( &
            evaluated(i, :) + &
            lambda2_pow(i) * lambda2(i) * nodes(degree + 1, :))
    end forall

  end subroutine evaluate_curve_barycentric

  subroutine evaluate_multi( &
       degree, dimension_, nodes, num_vals, s_vals, evaluated) &
       bind(c, name='evaluate_multi')

    ! NOTE: This is evaluate_multi for a Bezier curve.

    integer(c_int), intent(in) :: degree, dimension_
    real(c_double), intent(in) :: nodes(degree + 1, dimension_)
    integer(c_int), intent(in) :: num_vals
    real(c_double), intent(in) :: s_vals(num_vals)
    real(c_double), intent(out) :: evaluated(num_vals, dimension_)
    ! Variables outside of signature.
    real(c_double) :: one_less(num_vals)

    one_less = 1.0_dp - s_vals
    call evaluate_curve_barycentric( &
         degree, dimension_, nodes, num_vals, one_less, s_vals, evaluated)
  end subroutine evaluate_multi

  subroutine specialize_curve_generic( &
       degree, dimension_, nodes, start, end_, new_nodes) &
       bind(c, name='specialize_curve_generic')

    ! NOTE: This is a helper for ``specialize_curve`` that works on any degree.

    integer(c_int), intent(in) :: degree, dimension_
    real(c_double), intent(in) :: nodes(degree + 1, dimension_)
    real(c_double), intent(in) :: start, end_
    real(c_double), intent(out) :: new_nodes(degree + 1, dimension_)
    ! Variables outside of signature.
    real(c_double) :: workspace(degree, dimension_, degree + 1)
    integer(c_int) :: index_, curr_size, j
    real(c_double) :: minus_start, minus_end

    minus_start = 1.0_dp - start
    minus_end = 1.0_dp - end_
    workspace(:, :, 1) = minus_start * nodes(:degree, :) + start * nodes(2:, :)
    workspace(:, :, 2) = minus_end * nodes(:degree, :) + end_ * nodes(2:, :)

    curr_size = degree
    do index_ = 3, degree + 1
       curr_size = curr_size - 1
       ! First add a new "column" (or whatever the 3rd dimension is called)
       ! at the end using ``end_``.
       workspace(:curr_size, :, index_) = ( &
            minus_end * workspace(:curr_size, :, index_ - 1) + &
            end_ * workspace(2:curr_size + 1, :, index_ - 1))
       ! Update all the values in place by using de Casteljau with the
       ! ``start`` parameter.
       forall (j = 1:index_ - 1)
          workspace(:curr_size, :, j) = ( &
               minus_start * workspace(:curr_size, :, j) + &
               start * workspace(2:curr_size + 1, :, j))
       end forall
    end do

    ! Move the final "column" (or whatever the 3rd dimension is called)
    ! of the workspace into ``new_nodes``.
    forall (index_ = 1:degree + 1)
       new_nodes(index_, :) = workspace(1, :, index_)
    end forall

  end subroutine specialize_curve_generic

  subroutine specialize_curve_quadratic( &
       dimension_, nodes, start, end_, new_nodes) &
       bind(c, name='specialize_curve_quadratic')

    integer(c_int), intent(in) :: dimension_
    real(c_double), intent(in) :: nodes(3, dimension_)
    real(c_double), intent(in) :: start, end_
    real(c_double), intent(out) :: new_nodes(3, dimension_)
    ! Variables outside of signature.
    real(c_double) :: minus_start, minus_end, prod_both

    minus_start = 1.0_dp - start
    minus_end = 1.0_dp - end_
    prod_both = start * end_

    new_nodes(1, :) = ( &
         minus_start * minus_start * nodes(1, :) + &
         2.0_dp * start * minus_start * nodes(2, :) + &
         start * start * nodes(3, :))
    new_nodes(2, :) = ( &
         minus_start * minus_end * nodes(1, :) + &
         (end_ + start - 2.0_dp * prod_both) * nodes(2, :) + &
         prod_both * nodes(3, :))
    new_nodes(3, :) = ( &
         minus_end * minus_end * nodes(1, :) + &
         2.0_dp * end_ * minus_end * nodes(2, :) + &
         end_ * end_ * nodes(3, :))

  end subroutine specialize_curve_quadratic

  subroutine specialize_curve( &
       degree, dimension_, nodes, start, end_, curve_start, curve_end, &
       new_nodes, true_start, true_end) &
       bind(c, name='specialize_curve')

    integer(c_int), intent(in) :: degree, dimension_
    real(c_double), intent(in) :: nodes(degree + 1, dimension_)
    real(c_double), intent(in) :: start, end_, curve_start, curve_end
    real(c_double), intent(out) :: new_nodes(degree + 1, dimension_)
    real(c_double), intent(out) :: true_start, true_end
    ! Variables outside of signature.
    real(c_double) :: interval_delta

    if (degree == 1) then
       new_nodes(1, :) = (1.0_dp - start) * nodes(1, :) + start * nodes(2, :)
       new_nodes(2, :) = (1.0_dp - end_) * nodes(1, :) + end_ * nodes(2, :)
    else if (degree == 2) then
       call specialize_curve_quadratic( &
            dimension_, nodes, start, end_, new_nodes)
    else
       call specialize_curve_generic( &
            degree, dimension_, nodes, start, end_, new_nodes)
    end if

    ! Now, compute the new interval.
    interval_delta = curve_end - curve_start
    true_start = curve_start + start * interval_delta
    true_end = curve_start + end_ * interval_delta

  end subroutine specialize_curve

  subroutine evaluate_hodograph( &
       s, degree, dimension_, nodes, hodograph) &
       bind(c, name='evaluate_hodograph')

    real(c_double), intent(in) :: s
    integer(c_int), intent(in) :: degree, dimension_
    real(c_double), intent(in) :: nodes(degree + 1, dimension_)
    real(c_double), intent(out) :: hodograph(1, dimension_)
    ! Variables outside of signature.
    real(c_double) :: first_deriv(degree, dimension_)
    real(c_double) :: param(1)

    first_deriv = nodes(2:, :) - nodes(:degree, :)
    param = s
    call evaluate_multi( &
         degree - 1, dimension_, first_deriv, 1, param, hodograph)
    hodograph = degree * hodograph

  end subroutine evaluate_hodograph

end module curve

! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     https://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

module curve

  use, intrinsic :: iso_c_binding, only: c_double, c_int, c_bool
  use types, only: dp
  use helpers, only: cross_product, contains_nd
  implicit none
  private &
       MAX_LOCATE_SUBDIVISIONS, LOCATE_STD_CAP, &
       SQRT_PREC, REDUCE_THRESHOLD, scalar_func, dqagse, &
       specialize_curve_generic, specialize_curve_quadratic, &
       subdivide_nodes_generic, split_candidate, allocate_candidates, &
       update_candidates, projection_error, can_reduce
  public &
       CurveData, LOCATE_MISS, LOCATE_INVALID, evaluate_curve_barycentric, &
       evaluate_multi, specialize_curve, evaluate_hodograph, subdivide_nodes, &
       newton_refine, locate_point, elevate_nodes, get_curvature, &
       reduce_pseudo_inverse, full_reduce, compute_length, curves_equal, &
       subdivide_curve

  ! NOTE: This (for now) is not meant to be C-interoperable. This is mostly
  !       because the shape is encoded in ``nodes``, so it would be wasteful to
  !       also store ``num_nodes`` and ``dimension``. In addition,
  !       ``allocatable`` (rather than ``type(c_ptr)``) is used for the
  !       ``nodes`` so that the data is scoped with the ``CurveData`` instance
  !       and we don't need to worry about memory management.
  type :: CurveData
     real(c_double) :: start = 0.0_dp
     real(c_double) :: end_ = 1.0_dp
     real(c_double), allocatable :: nodes(:, :)
  end type CurveData

  ! NOTE: These values are also defined in equivalent Python source.
  integer(c_int), parameter :: MAX_LOCATE_SUBDIVISIONS = 20
  real(c_double), parameter :: LOCATE_STD_CAP = 0.5_dp**20
  ! NOTE: Should probably use ``d1mach`` to determine ``SQRT_PREC``.
  real(c_double), parameter :: SQRT_PREC = 0.5_dp**26
  real(c_double), parameter :: REDUCE_THRESHOLD = SQRT_PREC
  real(c_double), parameter :: LOCATE_MISS = -1
  real(c_double), parameter :: LOCATE_INVALID = -2

  ! Interface blocks for QUADPACK:dqagse
  abstract interface
     ! f: real(c_double) --> real(c_double)
     real(c_double) function scalar_func(x)
       use, intrinsic :: iso_c_binding, only: c_double
       implicit none

       real(c_double), intent(in) :: x
     end function scalar_func
  end interface

  interface
     ! D - double precision
     ! Q - quadrature
     ! A - adaptive
     ! G - General integrand (i.e. INT f(x), not weighted INT w(x) f(x))
     ! S - Singularities handled
     ! E - Extended
     ! See: https://en.wikipedia.org/wiki/QUADPACK
     ! QUADPACK is "Public Domain"
     subroutine dqagse( &
          f, a, b, epsabs, epsrel, limit, result_, &
          abserr, neval, ier, alist, blist, rlist, &
          elist, iord, last)
       use, intrinsic :: iso_c_binding, only: c_double, c_int
       implicit none

       procedure(scalar_func) :: f
       real(c_double), intent(in) :: a, b
       real(c_double), intent(in) :: epsabs, epsrel
       integer(c_int), intent(in) :: limit
       real(c_double), intent(out) :: result_, abserr
       integer(c_int), intent(out) :: neval, ier
       real(c_double), intent(out) :: alist(limit)
       real(c_double), intent(out) :: blist(limit)
       real(c_double), intent(out) :: rlist(limit)
       real(c_double), intent(out) :: elist(limit)
       integer(c_int), intent(out) :: iord(limit)
       integer(c_int), intent(out) :: last

     end subroutine dqagse
  end interface

contains

  subroutine evaluate_curve_barycentric( &
       num_nodes, dimension_, nodes, num_vals, lambda1, lambda2, evaluated) &
       bind(c, name='BEZ_evaluate_curve_barycentric')

    ! NOTE: This is evaluate_multi_barycentric for a Bezier curve.

    integer(c_int), intent(in) :: num_nodes, dimension_
    real(c_double), intent(in) :: nodes(dimension_, num_nodes)
    integer(c_int), intent(in) :: num_vals
    real(c_double), intent(in) :: lambda1(num_vals)
    real(c_double), intent(in) :: lambda2(num_vals)
    real(c_double), intent(out) :: evaluated(dimension_, num_vals)
    ! Variables outside of signature.
    integer(c_int) :: i, j
    real(c_double) :: lambda2_pow(num_vals)
    real(c_double) :: binom_val

    lambda2_pow = 1.0_dp
    binom_val = 1

    forall (i = 1:num_vals)
       evaluated(:, i) = lambda1(i) * nodes(:, 1)
    end forall

    do i = 2, num_nodes - 1
       lambda2_pow = lambda2_pow * lambda2
       binom_val = (binom_val * (num_nodes - i + 1)) / (i - 1)
       forall (j = 1:num_vals)
          evaluated(:, j) = ( &
               evaluated(:, j) + &
               binom_val * lambda2_pow(j) * nodes(:, i)) * lambda1(j)
       end forall
    end do

    forall (i = 1:num_vals)
       evaluated(:, i) = ( &
            evaluated(:, i) + &
            lambda2_pow(i) * lambda2(i) * nodes(:, num_nodes))
    end forall

  end subroutine evaluate_curve_barycentric

  subroutine evaluate_multi( &
       num_nodes, dimension_, nodes, num_vals, s_vals, evaluated) &
       bind(c, name='BEZ_evaluate_multi')

    ! NOTE: This is evaluate_multi for a Bezier curve.

    integer(c_int), intent(in) :: num_nodes, dimension_
    real(c_double), intent(in) :: nodes(dimension_, num_nodes)
    integer(c_int), intent(in) :: num_vals
    real(c_double), intent(in) :: s_vals(num_vals)
    real(c_double), intent(out) :: evaluated(dimension_, num_vals)
    ! Variables outside of signature.
    real(c_double) :: one_less(num_vals)

    one_less = 1.0_dp - s_vals
    call evaluate_curve_barycentric( &
         num_nodes, dimension_, nodes, num_vals, one_less, s_vals, evaluated)
  end subroutine evaluate_multi

  subroutine specialize_curve_generic( &
       num_nodes, dimension_, nodes, start, end_, new_nodes)

    ! NOTE: This is a helper for ``specialize_curve`` that works on any degree.

    integer(c_int), intent(in) :: num_nodes, dimension_
    real(c_double), intent(in) :: nodes(dimension_, num_nodes)
    real(c_double), intent(in) :: start, end_
    real(c_double), intent(out) :: new_nodes(dimension_, num_nodes)
    ! Variables outside of signature.
    real(c_double) :: workspace(dimension_, num_nodes - 1, num_nodes)
    integer(c_int) :: index_, curr_size, j
    real(c_double) :: minus_start, minus_end

    minus_start = 1.0_dp - start
    minus_end = 1.0_dp - end_
    workspace(:, :, 1) = ( &
         minus_start * nodes(:, :num_nodes - 1) + start * nodes(:, 2:))
    workspace(:, :, 2) = ( &
         minus_end * nodes(:, :num_nodes - 1) + end_ * nodes(:, 2:))

    curr_size = num_nodes - 1
    do index_ = 3, num_nodes
       curr_size = curr_size - 1
       ! First add a new "column" (or whatever the 3rd dimension is called)
       ! at the end using ``end_``.
       workspace(:, :curr_size, index_) = ( &
            minus_end * workspace(:, :curr_size, index_ - 1) + &
            end_ * workspace(:, 2:curr_size + 1, index_ - 1))
       ! Update all the values in place by using de Casteljau with the
       ! ``start`` parameter.
       forall (j = 1:index_ - 1)
          workspace(:, :curr_size, j) = ( &
               minus_start * workspace(:, :curr_size, j) + &
               start * workspace(:, 2:curr_size + 1, j))
       end forall
    end do

    ! Move the final "column" (or whatever the 3rd dimension is called)
    ! of the workspace into ``new_nodes``.
    forall (index_ = 1:num_nodes)
       new_nodes(:, index_) = workspace(:, 1, index_)
    end forall

  end subroutine specialize_curve_generic

  subroutine specialize_curve_quadratic( &
       dimension_, nodes, start, end_, new_nodes)

    integer(c_int), intent(in) :: dimension_
    real(c_double), intent(in) :: nodes(dimension_, 3)
    real(c_double), intent(in) :: start, end_
    real(c_double), intent(out) :: new_nodes(dimension_, 3)
    ! Variables outside of signature.
    real(c_double) :: minus_start, minus_end, prod_both

    minus_start = 1.0_dp - start
    minus_end = 1.0_dp - end_
    prod_both = start * end_

    new_nodes(:, 1) = ( &
         minus_start * minus_start * nodes(:, 1) + &
         2.0_dp * start * minus_start * nodes(:, 2) + &
         start * start * nodes(:, 3))
    new_nodes(:, 2) = ( &
         minus_start * minus_end * nodes(:, 1) + &
         (end_ + start - 2.0_dp * prod_both) * nodes(:, 2) + &
         prod_both * nodes(:, 3))
    new_nodes(:, 3) = ( &
         minus_end * minus_end * nodes(:, 1) + &
         2.0_dp * end_ * minus_end * nodes(:, 2) + &
         end_ * end_ * nodes(:, 3))

  end subroutine specialize_curve_quadratic

  subroutine specialize_curve( &
       num_nodes, dimension_, nodes, start, end_, new_nodes) &
       bind(c, name='BEZ_specialize_curve')

    integer(c_int), intent(in) :: num_nodes, dimension_
    real(c_double), intent(in) :: nodes(dimension_, num_nodes)
    real(c_double), intent(in) :: start, end_
    real(c_double), intent(out) :: new_nodes(dimension_, num_nodes)

    if (num_nodes == 2) then
       new_nodes(:, 1) = (1.0_dp - start) * nodes(:, 1) + start * nodes(:, 2)
       new_nodes(:, 2) = (1.0_dp - end_) * nodes(:, 1) + end_ * nodes(:, 2)
    else if (num_nodes == 3) then
       call specialize_curve_quadratic( &
            dimension_, nodes, start, end_, new_nodes)
    else
       call specialize_curve_generic( &
            num_nodes, dimension_, nodes, start, end_, new_nodes)
    end if

  end subroutine specialize_curve

  subroutine evaluate_hodograph( &
       s, num_nodes, dimension_, nodes, hodograph) &
       bind(c, name='BEZ_evaluate_hodograph')

    real(c_double), intent(in) :: s
    integer(c_int), intent(in) :: num_nodes, dimension_
    real(c_double), intent(in) :: nodes(dimension_, num_nodes)
    real(c_double), intent(out) :: hodograph(dimension_, 1)
    ! Variables outside of signature.
    real(c_double) :: first_deriv(dimension_, num_nodes - 1)

    first_deriv = nodes(:, 2:) - nodes(:, :num_nodes - 1)
    call evaluate_multi( &
         num_nodes - 1, dimension_, first_deriv, 1, [s], hodograph)
    hodograph = (num_nodes - 1) * hodograph

  end subroutine evaluate_hodograph

  subroutine subdivide_nodes_generic( &
       num_nodes, dimension_, nodes, left_nodes, right_nodes)

    integer(c_int), intent(in) :: num_nodes, dimension_
    real(c_double), intent(in) :: nodes(dimension_, num_nodes)
    real(c_double), intent(out) :: left_nodes(dimension_, num_nodes)
    real(c_double), intent(out) :: right_nodes(dimension_, num_nodes)
    ! Variables outside of signature.
    real(c_double) :: pascals_triangle(num_nodes)
    integer(c_int) :: elt_index, pascal_index

    pascals_triangle = 0  ! Make sure all zero.
    pascals_triangle(1) = 1

    do elt_index = 1, num_nodes
       ! Update Pascal's triangle (intentionally at beginning, not end).
       if (elt_index > 1) then
          pascals_triangle(:elt_index) = 0.5_dp * ( &
               pascals_triangle(:elt_index) + pascals_triangle(elt_index:1:-1))
       end if

       left_nodes(:, elt_index) = 0
       right_nodes(:, num_nodes + 1 - elt_index) = 0
       do pascal_index = 1, elt_index
          left_nodes(:, elt_index) = ( &
               left_nodes(:, elt_index) + &
               pascals_triangle(pascal_index) * nodes(:, pascal_index))
          right_nodes(:, num_nodes + 1 - elt_index) = ( &
               right_nodes(:, num_nodes + 1 - elt_index) + &
               pascals_triangle(pascal_index) * &
               nodes(:, num_nodes + 1 - pascal_index))
       end do
    end do

  end subroutine subdivide_nodes_generic

  subroutine subdivide_nodes( &
       num_nodes, dimension_, nodes, left_nodes, right_nodes) &
       bind(c, name='BEZ_subdivide_nodes_curve')

    integer(c_int), intent(in) :: num_nodes, dimension_
    real(c_double), intent(in) :: nodes(dimension_, num_nodes)
    real(c_double), intent(out) :: left_nodes(dimension_, num_nodes)
    real(c_double), intent(out) :: right_nodes(dimension_, num_nodes)

    if (num_nodes == 2) then
       left_nodes(:, 1) = nodes(:, 1)
       left_nodes(:, 2) = 0.5_dp * (nodes(:, 1) + nodes(:, 2))
       right_nodes(:, 1) = left_nodes(:, 2)
       right_nodes(:, 2) = nodes(:, 2)
    else if (num_nodes == 3) then
       left_nodes(:, 1) = nodes(:, 1)
       left_nodes(:, 2) = 0.5_dp * (nodes(:, 1) + nodes(:, 2))
       left_nodes(:, 3) = 0.25_dp * ( &
            nodes(:, 1) + 2 * nodes(:, 2) + nodes(:, 3))
       right_nodes(:, 1) = left_nodes(:, 3)
       right_nodes(:, 2) = 0.5_dp * (nodes(:, 2) + nodes(:, 3))
       right_nodes(:, 3) = nodes(:, 3)
    else if (num_nodes == 4) then
       left_nodes(:, 1) = nodes(:, 1)
       left_nodes(:, 2) = 0.5_dp * (nodes(:, 1) + nodes(:, 2))
       left_nodes(:, 3) = 0.25_dp * ( &
            nodes(:, 1) + 2 * nodes(:, 2) + nodes(:, 3))
       left_nodes(:, 4) = 0.125_dp * ( &
            nodes(:, 1) + 3 * nodes(:, 2) + 3 * nodes(:, 3) + nodes(:, 4))
       right_nodes(:, 1) = left_nodes(:, 4)
       right_nodes(:, 2) = 0.25_dp * ( &
            nodes(:, 2) + 2 * nodes(:, 3) + nodes(:, 4))
       right_nodes(:, 3) = 0.5_dp * (nodes(:, 3) + nodes(:, 4))
       right_nodes(:, 4) = nodes(:, 4)
    else
       call subdivide_nodes_generic( &
            num_nodes, dimension_, nodes, left_nodes, right_nodes)
    end if

  end subroutine subdivide_nodes

  subroutine newton_refine( &
       num_nodes, dimension_, nodes, point, s, updated_s) &
       bind(c, name='BEZ_newton_refine_curve')

    integer(c_int), intent(in) :: num_nodes, dimension_
    real(c_double), intent(in) :: nodes(dimension_, num_nodes)
    real(c_double), intent(in) :: point(dimension_, 1)
    real(c_double), intent(in) :: s
    real(c_double), intent(out) :: updated_s
    ! Variables outside of signature.
    real(c_double) :: pt_delta(dimension_, 1)
    real(c_double) :: derivative(dimension_, 1)

    call evaluate_multi( &
         num_nodes, dimension_, nodes, 1, [s], pt_delta)
    pt_delta = point - pt_delta
    ! At this point `pt_delta` is `p - B(s)`.
    call evaluate_hodograph( &
         s, num_nodes, dimension_, nodes, derivative)

    updated_s = ( &
         s + &
         (dot_product(pt_delta(:, 1), derivative(:, 1)) / &
         dot_product(derivative(:, 1), derivative(:, 1))))

  end subroutine newton_refine

  subroutine split_candidate( &
       num_nodes, dimension_, candidate, num_next_candidates, next_candidates)

    integer(c_int), intent(in) :: num_nodes, dimension_
    type(CurveData), intent(in) :: candidate
    integer(c_int), intent(in) :: num_next_candidates
    type(CurveData), intent(inout) :: next_candidates(:)

    ! Allocate the new nodes and call sub-divide.
    ! NOTE: This **assumes** but does not check that if the nodes are
    !       allocated, they are also the correct shape.
    if (.NOT. allocated(next_candidates(num_next_candidates - 1)%nodes)) then
       allocate(next_candidates(num_next_candidates - 1)%nodes(dimension_, num_nodes))
    end if
    if (.NOT. allocated(next_candidates(num_next_candidates)%nodes)) then
       allocate(next_candidates(num_next_candidates)%nodes(dimension_, num_nodes))
    end if

    call subdivide_nodes( &
         num_nodes, dimension_, candidate%nodes, &
         next_candidates(num_next_candidates - 1)%nodes, &
         next_candidates(num_next_candidates)%nodes)

    ! Left half.
    next_candidates(num_next_candidates - 1)%start = candidate%start
    next_candidates(num_next_candidates - 1)%end_ = ( &
         0.5_dp * (candidate%start + candidate%end_))
    ! Right half.
    next_candidates(num_next_candidates)%start = ( &
         next_candidates(num_next_candidates - 1)%end_)
    next_candidates(num_next_candidates)%end_ = candidate%end_

  end subroutine split_candidate

  subroutine allocate_candidates(num_candidates, next_candidates)
    integer(c_int), intent(in) :: num_candidates
    type(CurveData), allocatable, intent(inout) :: next_candidates(:)

    if (allocated(next_candidates)) then
       if (size(next_candidates) < 2 * num_candidates) then
          deallocate(next_candidates)
          allocate(next_candidates(2 * num_candidates))
       end if
    else
       allocate(next_candidates(2 * num_candidates))
    end if

  end subroutine allocate_candidates

  subroutine update_candidates( &
       num_nodes, dimension_, point, num_candidates, candidates, &
       num_next_candidates, next_candidates)

    integer(c_int), intent(in) :: num_nodes, dimension_
    real(c_double), intent(in) :: point(dimension_, 1)
    integer(c_int), intent(in) :: num_candidates
    type(CurveData), intent(in) :: candidates(:)
    integer(c_int), intent(inout) :: num_next_candidates
    type(CurveData), allocatable, intent(inout) :: next_candidates(:)
    ! Variables outside of signature.
    integer(c_int) :: cand_index
    logical(c_bool) :: predicate

    ! Allocate maximum amount of space needed.
    call allocate_candidates(num_candidates, next_candidates)

    do cand_index = 1, num_candidates
       call contains_nd( &
            num_nodes, dimension_, candidates(cand_index)%nodes, &
            point(:, 1), predicate)
       if (predicate) then
          num_next_candidates = num_next_candidates + 2
          call split_candidate( &
               num_nodes, dimension_, candidates(cand_index), &
               num_next_candidates, next_candidates)
       end if
    end do

  end subroutine update_candidates

  subroutine locate_point( &
       num_nodes, dimension_, nodes, point, s_approx) &
       bind(c, name='BEZ_locate_point_curve')

    ! NOTE: This returns ``-1`` (``LOCATE_MISS``) as a signal for "point is
    !       not on the curve" and ``-2`` (``LOCATE_INVALID``) for "point is
    !       on separate segments" (i.e. the standard deviation of the
    !       parameters is too large).

    integer(c_int), intent(in) :: num_nodes, dimension_
    real(c_double), intent(in) :: nodes(dimension_, num_nodes)
    real(c_double), intent(in) :: point(dimension_, 1)
    real(c_double), intent(out) :: s_approx
    ! Variables outside of signature.
    integer(c_int) :: sub_index
    integer(c_int) :: num_candidates, num_next_candidates
    type(CurveData), allocatable :: candidates_odd(:), candidates_even(:)
    real(c_double), allocatable :: s_params(:)
    real(c_double) :: std_dev
    logical(c_bool) :: is_even

    ! Start out with the full curve.
    allocate(candidates_odd(1))  ! First iteration is odd.
    candidates_odd(1) = CurveData(0.0_dp, 1.0_dp, nodes)
    ! NOTE: `num_candidates` will be tracked separately
    !       from `size(candidates)`.
    num_candidates = 1
    s_approx = LOCATE_MISS

    is_even = .TRUE.  ! At zero.
    do sub_index = 1, MAX_LOCATE_SUBDIVISIONS + 1
       is_even = .NOT. is_even  ! Switch parity.
       num_next_candidates = 0

       if (is_even) then
          ! Read from even, write to odd.
          call update_candidates( &
               num_nodes, dimension_, point, num_candidates, candidates_even, &
               num_next_candidates, candidates_odd)
       else
          ! Read from odd, write to even.
          call update_candidates( &
               num_nodes, dimension_, point, num_candidates, candidates_odd, &
               num_next_candidates, candidates_even)
       end if

       ! If there are no more candidates, we are done.
       if (num_next_candidates == 0) then
          return
       end if

       num_candidates = num_next_candidates

    end do

    ! Compute the s-parameter as the mean of the **start** and
    ! **end** parameters.
    allocate(s_params(2 * num_candidates))
    if (is_even) then
       ! NOTE: We "exclude" this block from ``lcov`` because it can never
       !       be invoked while ``MAX_LOCATE_SUBDIVISIONS`` is even.
       ! LCOV_EXCL_START
       s_params(:num_candidates) = ( &
            candidates_odd(:num_candidates)%start)
       s_params(num_candidates + 1:) = ( &
            candidates_odd(:num_candidates)%end_)
       ! LCOV_EXCL_STOP
    else
       s_params(:num_candidates) = candidates_even(:num_candidates)%start
       s_params(num_candidates + 1:) = candidates_even(:num_candidates)%end_
    end if
    s_approx = sum(s_params) / (2 * num_candidates)

    std_dev = sqrt(sum((s_params - s_approx)**2) / (2 * num_candidates))
    if (std_dev > LOCATE_STD_CAP) then
       s_approx = LOCATE_INVALID
       return
    end if

    ! NOTE: Use ``std_dev`` variable as a "placeholder" for the update.
    call newton_refine( &
         num_nodes, dimension_, nodes, point, s_approx, std_dev)
    ! NOTE: Since ``mean(s_params)`` must be in ``[0, 1]`` it's
    !       "safe" to push the Newton-refined value back into the unit
    !       interval.
    if (std_dev < 0.0_dp) then
       s_approx = 0.0_dp
    else if (std_dev > 1.0_dp) then
       s_approx = 1.0_dp
    else
       s_approx = std_dev
    end if

  end subroutine locate_point

  subroutine elevate_nodes( &
       num_nodes, dimension_, nodes, elevated) &
       bind(c, name='BEZ_elevate_nodes_curve')

    integer(c_int), intent(in) :: num_nodes, dimension_
    real(c_double), intent(in) :: nodes(dimension_, num_nodes)
    real(c_double), intent(out) :: elevated(dimension_, num_nodes + 1)
    ! Variables outside of signature.
    integer(c_int) :: i

    elevated(:, 1) = nodes(:, 1)
    forall (i = 1:num_nodes - 1)
       elevated(:, i + 1) = ( &
            i * nodes(:, i) + (num_nodes - i) * nodes(:, i + 1)) / num_nodes
    end forall
    elevated(:, num_nodes + 1) = nodes(:, num_nodes)

  end subroutine elevate_nodes

  subroutine get_curvature( &
       num_nodes, nodes, tangent_vec, s, curvature) &
       bind(c, name='BEZ_get_curvature')

    ! NOTE: This **only** computes curvature for plane curves (i.e. curves
    !       in R^2). An equivalent notion of curvature exists for space
    !       curves, but support for that is not implemented here.

    integer(c_int), intent(in) :: num_nodes
    real(c_double), intent(in) :: nodes(2, num_nodes)
    real(c_double), intent(in) :: tangent_vec(2, 1)
    real(c_double), intent(in) :: s
    real(c_double), intent(out) :: curvature
    ! Variables outside of signature.
    real(c_double) :: work(2, num_nodes - 1)
    real(c_double) :: concavity(2, 1)

    if (num_nodes == 2) then
       curvature = 0
       return
    end if

    ! NOTE: We somewhat replicate code in ``evaluate_hodograph()`` here.

    ! First derivative:
    work = nodes(:, 2:) - nodes(:, :num_nodes - 1)
    ! Second derivative (no need for last element of work array):
    work(:, :num_nodes - 2) = work(:, 2:) - work(:, :num_nodes - 2)

    ! NOTE: The degree being evaluated is ``degree - 2 == num_nodes - 3``.
    call evaluate_multi( &
         num_nodes - 2, 2, work(:, :num_nodes - 2), 1, [s], concavity)
    ! B''(s) = d (d - 1) D(s) where D(s) is defined by the "double hodograph".
    concavity = concavity * (num_nodes - 1) * (num_nodes - 2)

    call cross_product(tangent_vec, concavity, curvature)
    curvature = curvature / norm2(tangent_vec)**3

  end subroutine get_curvature

  subroutine reduce_pseudo_inverse( &
       num_nodes, dimension_, nodes, reduced, not_implemented) &
       bind(c, name='BEZ_reduce_pseudo_inverse')

    integer(c_int), intent(in) :: num_nodes, dimension_
    real(c_double), intent(in) :: nodes(dimension_, num_nodes)
    real(c_double), intent(out) :: reduced(dimension_, num_nodes - 1)
    logical(c_bool), intent(out) :: not_implemented

    not_implemented = .FALSE.
    if (num_nodes == 2) then
       reduced(:, 1) = 0.5_dp * (nodes(:, 1) + nodes(:, 2))
    else if (num_nodes == 3) then
       reduced(:, 1) = (5 * nodes(:, 1) + 2 * nodes(:, 2) - nodes(:, 3)) / 6
       reduced(:, 2) = (-nodes(:, 1) + 2 * nodes(:, 2) + 5 * nodes(:, 3)) / 6
    else if (num_nodes == 4) then
       reduced(:, 1) = ( &
            19 * nodes(:, 1) + 3 * nodes(:, 2) - &
            3 * nodes(:, 3) + nodes(:, 4)) / 20
       reduced(:, 2) = 0.25_dp * ( &
            -nodes(:, 1) + 3 * nodes(:, 2) + &
            3 * nodes(:, 3) - nodes(:, 4))
       reduced(:, 3) = ( &
            nodes(:, 1) - 3 * nodes(:, 2) + &
            3 * nodes(:, 3) + 19 * nodes(:, 4)) / 20
    else if (num_nodes == 5) then
       reduced(:, 1) = ( &
            69 * nodes(:, 1) + 4 * nodes(:, 2) - 6 * nodes(:, 3) + &
            4 * nodes(:, 4) - nodes(:, 5)) / 70
       reduced(:, 2) = ( &
            -53 * nodes(:, 1) + 212 * nodes(:, 2) + 102 * nodes(:, 3) - &
            68 * nodes(:, 4) + 17 * nodes(:, 5)) / 210
       reduced(:, 3) = ( &
            17 * nodes(:, 1) - 68 * nodes(:, 2) + 102 * nodes(:, 3) + &
            212 * nodes(:, 4) - 53 * nodes(:, 5)) / 210
       reduced(:, 4) = ( &
            -nodes(:, 1) + 4 * nodes(:, 2) - 6 * nodes(:, 3) + &
            4 * nodes(:, 4) + 69 * nodes(:, 5)) / 70
    else
       not_implemented = .TRUE.
    end if

  end subroutine reduce_pseudo_inverse

  subroutine projection_error( &
       num_nodes, dimension_, nodes, projected, error)

    integer(c_int), intent(in) :: num_nodes, dimension_
    real(c_double), intent(in) :: nodes(dimension_, num_nodes)
    real(c_double), intent(in) :: projected(dimension_, num_nodes)
    real(c_double), intent(out) :: error

    ! If "dim" is not passed to ``norm2``, will be Frobenius norm.
    error = norm2(nodes - projected)
    if (error == 0.0_dp) then
       return
    end if

    ! Make the error relative (in Frobenius norm).
    error = error / norm2(nodes)

  end subroutine projection_error

  subroutine can_reduce( &
       num_nodes, dimension_, nodes, success)

    ! NOTE: This returns ``success = 0`` for "Failure", ``success = 1`` for
    !       "Success" and ``success = -1`` for "Not Implemented".
    ! NOTE: This subroutine is not part of the C ABI for this module,
    !       but it is (for now) public, so that it can be tested.

    integer(c_int), intent(in) :: num_nodes, dimension_
    real(c_double), intent(in) :: nodes(dimension_, num_nodes)
    integer(c_int), intent(out) :: success
    ! Variables outside of signature.
    real(c_double) :: reduced(dimension_, num_nodes)
    real(c_double) :: relative_err

    if (num_nodes < 2 .OR. num_nodes > 5) then
       ! The only caller `full_reduce` will never try to reduce a point
       ! (i.e. `num_nodes == `). So these cases (along with higher degre
       ! than quartics) are "Not Implemented".
       success = -1
       return
    end if

    ! First, put the "projection" in ``reduced``.
    if (num_nodes == 2) then
       reduced(:, 1) = 0.5_dp * (nodes(:, 1) + nodes(:, 2))
       reduced(:, 2) = reduced(:, 1)
    else if (num_nodes == 3) then
       reduced(:, 1) = (5 * nodes(:, 1) + 2 * nodes(:, 2) - nodes(:, 3)) / 6
       reduced(:, 2) = (nodes(:, 1) + nodes(:, 2) + nodes(:, 3)) / 3
       reduced(:, 3) = (-nodes(:, 1) + 2 * nodes(:, 2) + 5 * nodes(:, 3)) / 6
    else if (num_nodes == 4) then
       reduced(:, 1) = ( &
            19 * nodes(:, 1) + 3 * nodes(:, 2) - &
            3 * nodes(:, 3) + nodes(:, 4)) / 20
       reduced(:, 2) = ( &
            3 * nodes(:, 1) + 11 * nodes(:, 2) + &
            9 * nodes(:, 3) - 3 * nodes(:, 4)) / 20
       reduced(:, 3) = ( &
            -3 * nodes(:, 1) + 9 * nodes(:, 2) + &
            11 * nodes(:, 3) + 3 * nodes(:, 4)) / 20
       reduced(:, 4) = ( &
            nodes(:, 1) - 3 * nodes(:, 2) + &
            3 * nodes(:, 3) + 19 * nodes(:, 4)) / 20
    else if (num_nodes == 5) then
       reduced(:, 1) = ( &
            69 * nodes(:, 1) + 4 * nodes(:, 2) - 6 * nodes(:, 3) + &
            4 * nodes(:, 4) - nodes(:, 5)) / 70
       reduced(:, 2) = ( &
            2 * nodes(:, 1) + 27 * nodes(:, 2) + 12 * nodes(:, 3) - &
            8 * nodes(:, 4) + 2 * nodes(:, 5)) / 35
       reduced(:, 3) = ( &
            -3 * nodes(:, 1) + 12 * nodes(:, 2) + 17 * nodes(:, 3) + &
            12 * nodes(:, 4) - 3 * nodes(:, 5)) / 35
       reduced(:, 4) = ( &
            2 * nodes(:, 1) - 8 * nodes(:, 2) + 12 * nodes(:, 3) + &
            27 * nodes(:, 4) + 2 * nodes(:, 5)) / 35
       reduced(:, 5) = ( &
            -nodes(:, 1) + 4 * nodes(:, 2) - 6 * nodes(:, 3) + &
            4 * nodes(:, 4) + 69 * nodes(:, 5)) / 70
    end if

    call projection_error(num_nodes, dimension_, nodes, reduced, relative_err)
    if (relative_err < REDUCE_THRESHOLD) then
       success = 1
    else
       success = 0
    end if

  end subroutine can_reduce

  subroutine full_reduce( &
       num_nodes, dimension_, nodes, num_reduced_nodes, &
       reduced, not_implemented) &
       bind(c, name='BEZ_full_reduce')

    ! NOTE: The size of ``reduced`` represents the **maximum** possible
    !       size, but ``num_reduced_nodes`` actually reflects the number
    !       of nodes in the fully reduced nodes.

    integer(c_int), intent(in) :: num_nodes, dimension_
    real(c_double), intent(in) :: nodes(dimension_, num_nodes)
    integer(c_int), intent(out) :: num_reduced_nodes
    real(c_double), intent(out) :: reduced(dimension_, num_nodes)
    logical(c_bool), intent(out) :: not_implemented
    ! Variables outside of signature.
    integer(c_int) :: i, cr_success
    real(c_double) :: work(dimension_, num_nodes - 1)

    reduced = nodes
    num_reduced_nodes = num_nodes
    not_implemented = .FALSE.
    ! We can make at most ``num_nodes - 1`` reductions since
    ! we can't reduce past one node (i.e. degree zero).
    do i = 1, num_nodes - 1
       call can_reduce( &
            num_reduced_nodes, dimension_, &
            reduced(:, :num_reduced_nodes), cr_success)

       if (cr_success == 1) then
          ! Actually reduce the nodes.
          call reduce_pseudo_inverse( &
               num_reduced_nodes, dimension_, reduced(:, :num_reduced_nodes), &
               work(:, :num_reduced_nodes - 1), not_implemented)
          if (not_implemented) then
             return  ! LCOV_EXCL_LINE
          else
             num_reduced_nodes = num_reduced_nodes - 1
             ! Update `reduced` based on the **new** number of nodes.
             reduced(:, :num_reduced_nodes) = work(:, :num_reduced_nodes)
          end if
       else if (cr_success == 0) then
          return
       else
          ! ``cr_success == -1`` means "Not Implemented"
          not_implemented = .TRUE.
          return
       end if
    end do

  end subroutine full_reduce

  subroutine compute_length( &
       num_nodes, dimension_, nodes, length, error_val) &
       bind(c, name='BEZ_compute_length')

    integer(c_int), intent(in) :: num_nodes, dimension_
    real(c_double), intent(in) :: nodes(dimension_, num_nodes)
    real(c_double), intent(out) :: length
    integer(c_int), intent(out) :: error_val
    ! Variables outside of signature.
    real(c_double) :: first_deriv(dimension_, num_nodes - 1)
    real(c_double) :: abserr
    integer(c_int) :: neval
    real(c_double) :: alist(50)
    real(c_double) :: blist(50)
    real(c_double) :: rlist(50)
    real(c_double) :: elist(50)
    integer(c_int) :: iord(50)
    integer(c_int) :: last

    ! NOTE: We somewhat replicate code in ``evaluate_hodograph()``
    !       here. This is so we don't re-compute the nodes for the first
    !       derivative every time it is evaluated.
    first_deriv = (num_nodes - 1) * (nodes(:, 2:) - nodes(:, :num_nodes - 1))
    if (num_nodes == 0) then
       error_val = -1
       return
    else if (num_nodes == 1) then
       length = 0.0
       error_val = 0
       return
    else if (num_nodes == 2) then
       length = norm2(first_deriv)
       error_val = 0
       return
    end if

    call dqagse( &
         vec_size, 0.0_dp, 1.0_dp, SQRT_PREC, SQRT_PREC, 50, length, &
         abserr, neval, error_val, alist, blist, rlist, &
         elist, iord, last)

  contains

    ! Define a closure that evaluates ||B'(s)||_2 where ``s``
    ! is the argument and ``B'(s)`` is parameterized by ``first_deriv``.
    real(c_double) function vec_size(s_val) result(norm_)
      real(c_double), intent(in) :: s_val
      ! Variables outside of signature.
      real(c_double) :: evaluated(dimension_, 1)

      ! ``evaluate_multi`` takes degree, which is one less than the number
      ! of nodes, so our derivative is one less than that.
      call evaluate_multi( &
           num_nodes - 1, dimension_, first_deriv, 1, [s_val], evaluated)
      norm_ = norm2(evaluated)

    end function vec_size

  end subroutine compute_length

  logical(c_bool) function curves_equal(curve1, curve2) result(same)

    ! NOTE: This is **explicitly** not intended for C inter-op.
    ! NOTE: This is really intended to be used by diagnostic / test code
    !       and not during the course of computation.

    type(CurveData), intent(in) :: curve1, curve2

    same = .TRUE.

    ! First, check the scalars.
    if (curve1%start /= curve2%start .OR. curve1%end_ /= curve2%end_) then
       same = .FALSE.
       return
    end if

    ! Then, check the nodes.
    if (allocated(curve1%nodes)) then
       if (allocated(curve2%nodes)) then
          if (all(shape(curve1%nodes) == shape(curve2%nodes))) then
             ! Here, since the same shape, we only exit early
             ! if the nodes aren't identical.
             if (.NOT. all(curve1%nodes == curve2%nodes)) then
                same = .FALSE.
                return
             end if
          else
             ! Different shapes can't be equal.
             same = .FALSE.
             return
          end if
       else
          ! nodes1 are allocated, nodes2 are not, can't be equal.
          same = .FALSE.
          return
       end if
    else
       if (allocated(curve2%nodes)) then
          ! nodes2 are allocated, nodes1 are not, can't be equal.
          same = .FALSE.
          return
       end if
       ! In the implicit ``else`` branch here, both sets of nots are
       ! un-allocated, hence they are the "same".
    end if

  end function curves_equal

  subroutine subdivide_curve(curve_data, left, right)

    ! NOTE: This is **explicitly** not intended for C inter-op.
    ! NOTE: This **assumes** but does not check that ``curve_data%nodes``
    !       is allocated.

    type(CurveData), intent(in) :: curve_data
    type(CurveData), intent(out) :: left, right
    ! Variables outside of signature.
    integer(c_int) :: num_nodes, dimension_

    num_nodes = size(curve_data%nodes, 2)
    dimension_ = size(curve_data%nodes, 1)

    left%start = curve_data%start
    left%end_ = 0.5_dp * (curve_data%start + curve_data%end_)
    allocate(left%nodes(dimension_, num_nodes))

    right%start = left%end_
    right%end_ = curve_data%end_
    allocate(right%nodes(dimension_, num_nodes))

    call subdivide_nodes( &
         num_nodes, dimension_, curve_data%nodes, left%nodes, right%nodes)

  end subroutine subdivide_curve

end module curve

! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     https://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

module helpers

  use, intrinsic :: iso_c_binding, only: c_double, c_int, c_bool
  use types, only: dp
  implicit none
  private min_index, sort_in_place, is_separating
  public &
       WIGGLE, VECTOR_CLOSE_EPS, cross_product, bbox, wiggle_interval, &
       contains_nd, vector_close, in_interval, in_sorted, convex_hull, &
       polygon_collide, solve2x2

  real(c_double), parameter :: WIGGLE = 0.5_dp**44
  ! NOTE: This is intended to be used as the default value for ``eps``
  !       in ``vector_close``.
  real(c_double), parameter :: VECTOR_CLOSE_EPS = 0.5_dp**40

contains

  pure subroutine cross_product( &
       vec0, vec1, result_) &
       bind(c, name='BEZ_cross_product')

    real(c_double), intent(in) :: vec0(2)
    real(c_double), intent(in) :: vec1(2)
    real(c_double), intent(out) :: result_

    result_ = vec0(1) * vec1(2) - vec0(2) * vec1(1)

  end subroutine cross_product

  subroutine bbox( &
       num_nodes, nodes, left, right, bottom, top) &
       bind(c, name='BEZ_bbox')

    integer(c_int), intent(in) :: num_nodes
    real(c_double), intent(in) :: nodes(2, num_nodes)
    real(c_double), intent(out) :: left, right, bottom, top
    ! Variables outside of signature.
    real(c_double) :: workspace(2)

    workspace = minval(nodes, 2)
    left = workspace(1)
    bottom = workspace(2)
    workspace = maxval(nodes, 2)
    right = workspace(1)
    top = workspace(2)

  end subroutine bbox

  subroutine wiggle_interval( &
       value_, result_, success) &
       bind(c, name='BEZ_wiggle_interval')

    real(c_double), intent(in) :: value_
    real(c_double), intent(out) :: result_
    logical(c_bool), intent(out) :: success

    success = .TRUE.
    if (-WIGGLE < value_ .AND. value_ < WIGGLE) then
       result_ = 0.0_dp
    else if (WIGGLE <= value_ .AND. value_ <= 1.0_dp - WIGGLE) then
       result_ = value_
    else if ( &
         1.0_dp - WIGGLE < value_ .AND. value_ < 1.0_dp + WIGGLE) then
       result_ = 1.0_dp
    else
       success = .FALSE.
    end if

  end subroutine wiggle_interval

  pure subroutine contains_nd( &
       num_nodes, dimension_, nodes, point, predicate) &
       bind(c, name='BEZ_contains_nd')

    integer(c_int), intent(in) :: num_nodes, dimension_
    real(c_double), intent(in) :: nodes(dimension_, num_nodes)
    real(c_double), intent(in) :: point(dimension_)
    logical(c_bool), intent(out) :: predicate

    if (any(point < minval(nodes, 2))) then
       predicate = .FALSE.
    else if (any(maxval(nodes, 2) < point)) then
       predicate = .FALSE.
    else
       predicate = .TRUE.
    end if

  end subroutine contains_nd

  logical(c_bool) pure function vector_close( &
       num_values, vec1, vec2, eps) result(is_close) &
       bind(c, name='BEZ_vector_close')

    integer(c_int), intent(in) :: num_values
    real(c_double), intent(in) :: vec1(num_values)
    real(c_double), intent(in) :: vec2(num_values)
    real(c_double), intent(in) :: eps
    ! Variables outside of signature.
    real(c_double) :: size1, size2

    size1 = norm2(vec1)
    size2 = norm2(vec2)
    if (size1 == 0.0_dp) then
       is_close = size2 <= eps
    else if (size2 == 0.0_dp) then
       is_close = size1 <= eps
    else
       ! This is the most common path.
       is_close = norm2(vec1 - vec2) <= eps * min(size1, size2)
    end if

  end function vector_close

  pure function in_interval( &
       value_, start, end) result(predicate) &
       bind(c, name='BEZ_in_interval')

    real(c_double), intent(in) :: value_, start, end
    logical(c_bool) :: predicate

    predicate = (start <= value_) .AND. (value_ <= end)

  end function in_interval

  subroutine min_index(num_points, points, match)

    ! Finds the minimum point when sorting first by ``x`` then by
    ! ``y`` coordinate (in the case of a tie in ``x``).

    ! NOTE: This is a helper for ``sort_in_place``.
    ! NOTE: This assumes, but does not check, that ``num_points > 0``.

    integer(c_int), intent(in) :: num_points
    real(c_double), intent(inout) :: points(2, num_points)
    integer(c_int), intent(out) :: match
    ! Variables outside of signature.
    integer(c_int) :: i

    match = 1
    do i = 2, num_points
       if (points(1, i) < points(1, match)) then
          match = i
       else if (points(1, i) == points(1, match)) then
          if (points(2, i) < points(2, match)) then
             match = i
          end if
       end if
    end do

  end subroutine min_index

  subroutine sort_in_place(num_points, points, num_uniques)

    ! NOTE: This is a helper for ``convex_hull``. This does a simple quadratic
    !       sort (i.e. it is suboptimal) because it expects the number of
    !       points to be small. It **also** makes sure the values are unique
    !       to exact precision.

    integer(c_int), intent(in) :: num_points
    real(c_double), intent(inout) :: points(2, num_points)
    integer(c_int), intent(out) :: num_uniques
    ! Variables outside of signature.
    integer(c_int) :: i, match
    real(c_double) :: swap(2)

    num_uniques = num_points
    ! Place the "smallest" point first (since it can't be a duplicate).
    call min_index(num_points, points, match)
    if (match /= 1) then
       swap = points(:, match)
       points(:, match) = points(:, 1)
       points(:, 1) = swap
    end if

    i = 2
    do while (i <= num_uniques)
       call min_index(num_uniques + 1 - i, points(:, i:num_uniques), match)
       ! Shift ``match`` based on the slice ``points(:, i:...)``.
       match = match + i - 1
       if (match /= i) then
          swap = points(:, match)
          if (all(swap == points(:, i - 1))) then
             ! This means ``match`` is a duplicate.
             points(:, match) = points(:, num_uniques)
             points(:, num_uniques) = swap
             num_uniques = num_uniques - 1
          else
             points(:, match) = points(:, i)
             points(:, i) = swap
          end if
       end if
       ! Increment for next iteration.
       i = i + 1
    end do

  end subroutine sort_in_place

  logical(c_bool) pure function in_sorted( &
       num_values, values, value_) result(contained)

    ! NOTE: This assumes ``num_values >= 1``.
    ! NOTE: This subroutine is not part of the C ABI for this module,
    !       but it is (for now) public, so that it can be tested.

    integer(c_int), intent(in) :: num_values
    integer(c_int), intent(in) :: values(num_values)
    integer(c_int), intent(in) :: value_
    ! Variables outside of signature.
    integer(c_int) :: left, right, midpoint

    left = 1
    right = num_values

    do while (left < right)
       midpoint = (left + right) / 2
       if (value_ == values(midpoint)) then
          contained = .TRUE.
          return
       else if (value_ < values(midpoint)) then
          right = midpoint - 1
       else
          left = midpoint + 1
       end if
    end do

    contained = values(left) == value_

  end function in_sorted

  subroutine convex_hull( &
       num_points, points, polygon_size, polygon) &
       bind(c, name='BEZ_simple_convex_hull')

    ! NOTE: This uses Andrew's monotone chain convex hull algorithm and used
    !       (https://en.wikibooks.org/wiki/Algorithm_Implementation/
    !        Geometry/Convex_hull/Monotone_chain)
    !       as motivation. The code there is licensed CC BY-SA 3.0.

    ! NOTE: The "standard" implementation for this is in Qhull, but for now
    !       that is avoided as an extra dependency.

    integer(c_int), intent(in) :: num_points
    real(c_double), intent(in) :: points(2, num_points)
    integer(c_int), intent(out) :: polygon_size
    real(c_double), intent(out) :: polygon(2, num_points)
    ! Variables outside of signature.
    real(c_double) :: point1(2), point2(2), point3(2)
    integer(c_int) :: num_uniques
    real(c_double) :: uniques(2, num_points)
    integer(c_int) :: num_lower, num_upper
    integer(c_int) :: lower(num_points), upper(num_points)
    integer(c_int) :: i
    real(c_double) :: result_

    uniques = points
    call sort_in_place(num_points, uniques, num_uniques)

    ! In the "boring" case that we have fewer than 2 points, return.
    if (num_uniques == 0) then
       polygon_size = 0
       return
    else if (num_uniques < 3) then
       polygon_size = num_uniques
       polygon(:, :num_uniques) = uniques(:, :num_uniques)
       return
    end if

    ! First create a "lower" convex hull
    num_lower = 2  ! We know ``num_uniques >= 3``.
    lower(:2) = [1, 2]
    do i = 3, num_uniques
       point3 = uniques(:, i)
       result_ = -1.0_dp  ! Dummy value that is ``<= 0.0``.
       do while (num_lower > 1 .AND. result_ <= 0.0_dp)
          point1 = uniques(:, lower(num_lower - 1))
          point2 = uniques(:, lower(num_lower))
          ! If ``point3`` (the one we are considering) is more "inside"
          ! of ``point1`` than ``point2`` is, then we drop ``point2``.
          call cross_product(point2 - point1, point3 - point1, result_)
          if (result_ <= 0.0_dp) then
             num_lower = num_lower - 1
          end if
       end do
       num_lower = num_lower + 1
       lower(num_lower) = i
    end do

    ! Then create an "upper" convex hull
    num_upper = 1
    upper(1) = num_uniques
    upper_loop: do i = num_uniques - 1, 1, -1
       ! Don't consider indices from the lower hull (other than the ends).
       if (i > 1 .AND. in_sorted(num_lower, lower(:num_lower), i)) then
          cycle upper_loop
       end if
       point3 = uniques(:, i)
       result_ = -1.0_dp  ! Dummy value that is ``<= 0.0``.
       do while (num_upper > 1 .AND. result_ <= 0.0_dp)
          point1 = uniques(:, upper(num_upper - 1))
          point2 = uniques(:, upper(num_upper))
          ! If ``point3`` (the one we are considering) is more "inside"
          ! of ``point1`` than ``point2`` is, then we drop ``point2``.
          call cross_product(point2 - point1, point3 - point1, result_)
          if (result_ <= 0.0_dp) then
             num_upper = num_upper - 1
          end if
       end do
       num_upper = num_upper + 1
       upper(num_upper) = i
    end do upper_loop

    ! The endpoints are **both** double counted, so we skip the "end"
    ! of each hull (lower and upper).
    polygon_size = 0
    do i = 1, num_lower - 1
       polygon_size = polygon_size + 1
       polygon(:, polygon_size) = uniques(:, lower(i))
    end do
    do i = 1, num_upper - 1
       polygon_size = polygon_size + 1
       polygon(:, polygon_size) = uniques(:, upper(i))
    end do

  end subroutine convex_hull

  logical(c_bool) pure function is_separating( &
       edge_direction, polygon_size1, polygon1, polygon_size2, polygon2) &
       result(predicate)

    ! NOTE: This assumes, but does not check, that ``polygon_sizeX`` is
    !       at least two.
    real(c_double), intent(in) :: edge_direction(2)
    integer(c_int), intent(in) :: polygon_size1
    real(c_double), intent(in) :: polygon1(2, polygon_size1)
    integer(c_int), intent(in) :: polygon_size2
    real(c_double), intent(in) :: polygon2(2, polygon_size2)
    ! Variables outside of signature.
    real(c_double) :: vertex(2), norm_squared, cp_result, param
    real(c_double) :: min_param1, max_param1
    real(c_double) :: min_param2, max_param2
    integer(c_int) :: i

    ! NOTE: We assume throughout that ``norm_squared != 0``. If it **were**
    !       zero that would mean the ``edge_direction`` corresponds to an
    !       invalid edge.
    norm_squared = dot_product(edge_direction, edge_direction)

    ! Compute the parameters along the "separating axis" for the vertices
    ! of the first polygon.
    vertex = polygon1(:, 1)
    call cross_product(edge_direction, vertex, cp_result)
    param = cp_result / norm_squared
    min_param1 = param
    max_param1 = param
    do i = 2, polygon_size1
       vertex = polygon1(:, i)
       call cross_product(edge_direction, vertex, cp_result)
       param = cp_result / norm_squared
       min_param1 = min(min_param1, param)
       max_param1 = max(max_param1, param)
    end do

    ! Compute the parameters along the "separating axis" for the vertices
    ! of the first polygon.
    vertex = polygon2(:, 1)
    call cross_product(edge_direction, vertex, cp_result)
    param = cp_result / norm_squared
    min_param2 = param
    max_param2 = param
    do i = 2, polygon_size2
       vertex = polygon2(:, i)
       call cross_product(edge_direction, vertex, cp_result)
       param = cp_result / norm_squared
       min_param2 = min(min_param2, param)
       max_param2 = max(max_param2, param)
    end do

    ! Determine if [min_param1, max_param1] and [min_param2, max_param2]
    ! are disjoint intervals.
    predicate = (min_param1 > max_param2 .OR. max_param1 < min_param2)

  end function is_separating

  subroutine polygon_collide( &
       polygon_size1, polygon1, polygon_size2, polygon2, collision) &
       bind(c, name='BEZ_polygon_collide')

    ! This determines if two **convex** polygons collide. The polygons
    ! are given as ``2 x N`` arrays of ``x-y`` points (one per column)
    ! in order they appear (the first and last node are **not** the same
    ! as is sometimes expected for closed polygons).

    ! This code uses the Separating axis theorem (SAT) [1] [2] to quickly
    ! determine if the polygons intersect.
    ! [1]: https://en.wikipedia.org/wiki/Hyperplane_separation_theorem
    ! [2]: https://hackmd.io/s/ryFmIZrsl

    ! A "standard" implementation for this is in GEOS [3], but for now
    ! that is avoided as an extra dependency.
    ! [3]: https://trac.osgeo.org/geos

    integer(c_int), intent(in) :: polygon_size1
    real(c_double), intent(in) :: polygon1(2, polygon_size1)
    integer(c_int), intent(in) :: polygon_size2
    real(c_double), intent(in) :: polygon2(2, polygon_size2)
    logical(c_bool), intent(out) :: collision
    ! Variables outside of signature.
    real(c_double) :: edge_direction(2)
    integer(c_int) :: i

    collision = .TRUE.

    ! First handle the "wrap-around" edge from polygon1.
    edge_direction = polygon1(:, 1) - polygon1(:, polygon_size1)
    if (is_separating( &
         edge_direction, polygon_size1, polygon1, &
         polygon_size2, polygon2)) then
       collision = .FALSE.
       return
    end if

    ! Then, check all other edges from polygon1.
    do i = 2, polygon_size1
       edge_direction = polygon1(:, i) - polygon1(:, i - 1)
       if (is_separating( &
            edge_direction, polygon_size1, polygon1, &
            polygon_size2, polygon2)) then
          collision = .FALSE.
          return
       end if
    end do

    ! Then, handle the "wrap-around" edge from polygon2.
    edge_direction = polygon2(:, 1) - polygon2(:, polygon_size2)
    if (is_separating( &
         edge_direction, polygon_size1, polygon1, &
         polygon_size2, polygon2)) then
       collision = .FALSE.
       return
    end if

    ! Then, check all other edges from polygon1.
    do i = 2, polygon_size2
       edge_direction = polygon2(:, i) - polygon2(:, i - 1)
       if (is_separating( &
            edge_direction, polygon_size1, polygon1, &
            polygon_size2, polygon2)) then
          collision = .FALSE.
          return
       end if
    end do

  end subroutine polygon_collide

  subroutine solve2x2(lhs, rhs, singular, x_val, y_val)

    real(c_double), intent(in) :: lhs(2, 2)
    real(c_double), intent(in) :: rhs(2)
    logical(c_bool), intent(out) :: singular
    real(c_double), intent(out) :: x_val
    real(c_double), intent(out) :: y_val
    ! Variables outside of signature.
    real(c_double) :: ratio, denominator

    ! A <--> lhs(1, 1)
    ! B <--> lhs(1, 2)
    ! C <--> lhs(2, 1)
    ! D <--> lhs(2, 2)
    ! E <--> rhs(1)
    ! F <--> rhs(2)
    if (abs(lhs(2, 1)) > abs(lhs(1, 1))) then
       ! NOTE: We know there is no division by zero here since ``C``
       !       is **strictly** bigger than **some** value (in magnitude).
       ! [A | B][x] = [E]
       ! [C | D][y]   [F]
       ratio = lhs(1, 1) / lhs(2, 1)
       ! r = A / C
       ! [A - rC | B - rD][x]   [E - rF]
       ! [C      | D     ][y] = [F     ]
       ! ==> 0x + (B - rD) y = E - rF
       denominator = lhs(1, 2) - ratio * lhs(2, 2)
       if (denominator == 0.0_dp) then
          singular = .TRUE.
          return
       end if

       y_val = (rhs(1) - ratio * rhs(2)) / denominator
       ! Cx + Dy = F ==> x = (F - Dy) / C
       x_val = (rhs(2) - lhs(2, 2) * y_val) / lhs(2, 1)
       singular = .FALSE.
    else
       if (lhs(1, 1) == 0.0_dp) then
          singular = .TRUE.
          return
       end if
       ! [A | B][x] = [E]
       ! [C | D][y]   [F]
       ratio = lhs(2, 1) / lhs(1, 1)
       ! r = C / A
       ! [A      | B     ][x] = [E     ]
       ! [C - rA | D - rB][y]   [F - rE]
       ! ==> 0x + (D - rB) y = F - rE
       denominator = lhs(2, 2) - ratio * lhs(1, 2)
       if (denominator == 0.0_dp) then
          singular = .TRUE.
          return
       end if

       y_val = (rhs(2) - ratio * rhs(1)) / denominator
       ! Ax + By = E ==> x = (E - B y) / A
       x_val = (rhs(1) - lhs(1, 2) * y_val) / lhs(1, 1)
       singular = .FALSE.
    end if

  end subroutine solve2x2

end module helpers

! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     https://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

module status

  use, intrinsic :: iso_c_binding, only: c_int
  implicit none
  private
  public &
       Status_SUCCESS, Status_BAD_MULTIPLICITY, Status_NO_CONVERGE, &
       Status_INSUFFICIENT_SPACE, Status_SAME_CURVATURE, Status_BAD_INTERIOR, &
       Status_EDGE_END, Status_SINGULAR, Status_UNKNOWN

  ! Values of Status enum:
  ! SUCCESS: Procedure exited with no error.
  integer(c_int), parameter :: Status_SUCCESS = 0
  ! BAD_MULTIPLICITY: An iterative method (e.g. Newton's method) failed to
  !                   converge because it encountered a solution with an
  !                   unsupported multiplicity (i.e. it was a triple root or
  !                   higher). The multiplicity is detected by the observed
  !                   rate of convergence. (Used by
  !                   ``curve_intersection.full_newton_nonzero()``.)
  integer(c_int), parameter :: Status_BAD_MULTIPLICITY = 1
  ! NO_CONVERGE: An iterative method failed to converge in the maximum allowed
  !              number of iterations. (Used by
  !              ``curve_intersection.all_intersections()``.)
  integer(c_int), parameter :: Status_NO_CONVERGE = 2
  ! INSUFFICIENT_SPACE: Intended to be used by ABI versions of procedures. This
  !                     will be used when the caller has not allocated enough
  !                     space for the output values. (On the Fortran side, an
  !                     ``allocatable`` array can be resized, but in the ABI,
  !                     we can only use what the caller has passed.)
  integer(c_int), parameter :: Status_INSUFFICIENT_SPACE = 3
  ! SAME_CURVATURE: Classification of a curve-curve intersection failed due to
  !                 two curves having identical at a tangent intersection.
  integer(c_int), parameter :: Status_SAME_CURVATURE = 4
  ! BAD_INTERIOR: Caused by a failure during the process of triangle-triangle
  !               intersection. Occurs when the corners and edge-edge
  !               intersections can't be converted into the curved polygon(s)
  !               that make up the intersection of the two triangles.
  integer(c_int), parameter :: Status_BAD_INTERIOR = 5
  ! EDGE_END: A triangle-triangle intersection point occurs at the **end** of
  !           an edge (only intersections at the beginning of an edge should
  !           be used).
  integer(c_int), parameter :: Status_EDGE_END = 6
  ! SINGULAR: Signifies that an attempt was made to solve a linear system
  !           that was singular.
  integer(c_int), parameter :: Status_SINGULAR = 7
  ! UNKNOWN: Signifies a block of code reached an "impossible" state. Either
  !          the code has violated some mathematical invariant or the author
  !          of that block of code misunderstood the possible states of the
  !          system.
  integer(c_int), parameter :: Status_UNKNOWN = 999

end module status

! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     https://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

module types

  implicit none
  private
  public dp

  integer, parameter :: dp = kind(0.d0)

end module types

! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     https://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

module curve_intersection

  use, intrinsic :: iso_c_binding, only: &
       c_double, c_int, c_bool, c_f_pointer, c_loc
  use types, only: dp
  use status, only: &
       Status_SUCCESS, Status_BAD_MULTIPLICITY, Status_NO_CONVERGE, &
       Status_INSUFFICIENT_SPACE, Status_SINGULAR
  use helpers, only: &
       VECTOR_CLOSE_EPS, cross_product, bbox, wiggle_interval, &
       vector_close, in_interval, convex_hull, polygon_collide, &
       solve2x2
  use curve, only: &
       CurveData, LOCATE_MISS, LOCATE_INVALID, evaluate_multi, &
       specialize_curve, evaluate_hodograph, locate_point, elevate_nodes, &
       subdivide_curve
  implicit none
  private &
       newton_routine, MAX_INTERSECT_SUBDIVISIONS, MIN_INTERVAL_WIDTH, &
       MAX_CANDIDATES, ZERO_THRESHOLD, NEWTON_ERROR_RATIO, &
       CANDIDATES_ODD, CANDIDATES_EVEN, &
       POLYGON1, POLYGON2, make_candidates, prune_candidates, elevate_helper
  public &
       BoxIntersectionType_INTERSECTION, BoxIntersectionType_TANGENT, &
       BoxIntersectionType_DISJOINT, Subdivide_FIRST, Subdivide_SECOND, &
       Subdivide_BOTH, Subdivide_NEITHER, LINEARIZATION_THRESHOLD, &
       INTERSECTIONS_WORKSPACE, linearization_error, segment_intersection, &
       newton_refine_intersect, bbox_intersect, parallel_lines_parameters, &
       line_line_collide, convex_hull_collide, newton_simple_root, &
       newton_double_root, newton_iterate, full_newton_nonzero, full_newton, &
       from_linearized, &
       bbox_line_intersect, check_lines, add_intersection, &
       add_from_linearized, endpoint_check, tangent_bbox_intersection, &
       add_candidates, intersect_one_round, make_same_degree, &
       add_coincident_parameters, all_intersections, all_intersections_abi, &
       free_curve_intersections_workspace

  ! Interface for ``newton_iterate()``.
  abstract interface
     subroutine newton_routine(s, t, jacobian, func_val)
       use, intrinsic :: iso_c_binding, only: c_double
       implicit none

       real(c_double), intent(in) :: s
       real(c_double), intent(in) :: t
       real(c_double), intent(out) :: jacobian(2, 2)
       real(c_double), intent(out) :: func_val(2, 1)
     end subroutine newton_routine
  end interface

  ! Values of BoxIntersectionType enum:
  integer(c_int), parameter :: BoxIntersectionType_INTERSECTION = 0
  integer(c_int), parameter :: BoxIntersectionType_TANGENT = 1
  integer(c_int), parameter :: BoxIntersectionType_DISJOINT = 2
  ! Values of Subdivide enum:
  integer(c_int), parameter :: Subdivide_FIRST = 0
  integer(c_int), parameter :: Subdivide_SECOND = 1
  integer(c_int), parameter :: Subdivide_BOTH = 2
  integer(c_int), parameter :: Subdivide_NEITHER = -1
  ! Set the threshold for linearization error at half the bits available.
  real(c_double), parameter :: LINEARIZATION_THRESHOLD = 0.5_dp**26
  integer(c_int), parameter :: MAX_INTERSECT_SUBDIVISIONS = 20
  real(c_double), parameter :: MIN_INTERVAL_WIDTH = 0.5_dp**40
  ! Run-time parameters that can be modified. If multiple threads are used,
  ! these **should** be thread-local (though it's expected that callers will
  ! update these values **before** beginning computation).
  integer(c_int), parameter :: MAX_CANDIDATES = 64
  ! Point under which values are considered to be "near zero".
  real(c_double), parameter :: ZERO_THRESHOLD = 0.5_dp**10
  real(c_double), parameter :: NEWTON_ERROR_RATIO = 0.5_dp**36
  ! Long-lived workspaces for ``all_intersections()`` and
  ! ``all_intersections_abi()``. If multiple threads are used, each of these
  ! **should** be thread-local.
  type(CurveData), allocatable :: CANDIDATES_ODD(:, :)
  type(CurveData), allocatable :: CANDIDATES_EVEN(:, :)
  real(c_double), allocatable :: INTERSECTIONS_WORKSPACE(:, :)
  real(c_double), allocatable :: POLYGON1(:, :)
  real(c_double), allocatable :: POLYGON2(:, :)

contains

  subroutine linearization_error( &
       num_nodes, dimension_, nodes, error)

    integer(c_int), intent(in) :: num_nodes, dimension_
    real(c_double), intent(in) :: nodes(dimension_, num_nodes)
    real(c_double), intent(out) :: error
    ! Variables outside of signature.
    real(c_double) :: second_deriv(dimension_, num_nodes - 2)
    real(c_double) :: worst_case(dimension_)

    ! A line has no linearization error.
    if (num_nodes == 2) then
       error = 0.0_dp
       return
    end if

    second_deriv = ( &
         nodes(:, :num_nodes - 2) - &
         2.0_dp * nodes(:, 2:num_nodes - 1) + &
         nodes(:, 3:))
    worst_case = maxval(abs(second_deriv), 2)
    error = 0.125_dp * (num_nodes - 1) * (num_nodes - 2) * norm2(worst_case)

  end subroutine linearization_error

  subroutine segment_intersection( &
       start0, end0, start1, end1, s, t, success)

    real(c_double), intent(in) :: start0(2)
    real(c_double), intent(in) :: end0(2)
    real(c_double), intent(in) :: start1(2)
    real(c_double), intent(in) :: end1(2)
    real(c_double), intent(out) :: s, t
    logical(c_bool), intent(out) :: success
    ! Variables outside of signature.
    real(c_double) :: delta0(2)
    real(c_double) :: delta1(2)
    real(c_double) :: start_delta(2)
    real(c_double) :: cross_d0_d1
    real(c_double) :: other_cross

    delta0 = end0 - start0
    delta1 = end1 - start1
    call cross_product(delta0, delta1, cross_d0_d1)

    if (cross_d0_d1 == 0.0_dp) then
       success = .FALSE.
    else
       start_delta = start1 - start0
       call cross_product(start_delta, delta1, other_cross)
       s = other_cross / cross_d0_d1
       call cross_product(start_delta, delta0, other_cross)
       t = other_cross / cross_d0_d1
       success = .TRUE.
    end if

  end subroutine segment_intersection

  subroutine newton_refine_intersect( &
       s, num_nodes1, nodes1, t, num_nodes2, nodes2, new_s, new_t, status) &
       bind(c, name='BEZ_newton_refine_curve_intersect')

    ! Possible error states:
    ! * Status_SUCCESS : On success.
    ! * Status_SINGULAR: If the computed Jacobian is singular.

    real(c_double), intent(in) :: s
    integer(c_int), intent(in) :: num_nodes1
    real(c_double), intent(in) :: nodes1(2, num_nodes1)
    real(c_double), intent(in) :: t
    integer(c_int), intent(in) :: num_nodes2
    real(c_double), intent(in) :: nodes2(2, num_nodes2)
    real(c_double), intent(out) :: new_s
    real(c_double), intent(out) :: new_t
    integer(c_int), intent(out) :: status
    ! Variables outside of signature.
    real(c_double) :: func_val(2, 1)
    real(c_double) :: workspace(2, 1)
    real(c_double) :: jac_mat(2, 2)
    real(c_double) :: delta_s, delta_t
    logical(c_bool) :: singular

    call evaluate_multi( &
         num_nodes2, 2, nodes2, 1, [t], func_val)
    call evaluate_multi( &
         num_nodes1, 2, nodes1, 1, [s], workspace)
    func_val = func_val - workspace

    if (all(func_val == 0.0_dp)) then
       new_s = s
       new_t = t
       return
    end if

    call evaluate_hodograph(s, num_nodes1, 2, nodes1, jac_mat(:, 1:1))
    call evaluate_hodograph(t, num_nodes2, 2, nodes2, jac_mat(:, 2:2))
    jac_mat(:, 2) = -jac_mat(:, 2)

    call solve2x2(jac_mat, func_val(:, 1), singular, delta_s, delta_t)
    if (singular) then
       status = Status_SINGULAR
    else
       status = Status_SUCCESS
       new_s = s + delta_s
       new_t = t + delta_t
    end if

  end subroutine newton_refine_intersect

  subroutine bbox_intersect( &
       num_nodes1, nodes1, num_nodes2, nodes2, enum_) &
       bind(c, name='BEZ_bbox_intersect')

    integer(c_int), intent(in) :: num_nodes1
    real(c_double), intent(in) :: nodes1(2, num_nodes1)
    integer(c_int), intent(in) :: num_nodes2
    real(c_double), intent(in) :: nodes2(2, num_nodes2)
    integer(c_int), intent(out) :: enum_
    ! Variables outside of signature.
    real(c_double) :: left1, right1, bottom1, top1
    real(c_double) :: left2, right2, bottom2, top2

    call bbox(num_nodes1, nodes1, left1, right1, bottom1, top1)
    call bbox(num_nodes2, nodes2, left2, right2, bottom2, top2)

    if ( &
         right2 < left1 .OR. right1 < left2 .OR. &
         top2 < bottom1 .OR. top1 < bottom2) then
       enum_ = BoxIntersectionType_DISJOINT
    else if ( &
         right2 == left1 .OR. right1 == left2 .OR. &
         top2 == bottom1 .OR. top1 == bottom2) then
       enum_ = BoxIntersectionType_TANGENT
    else
       enum_ = BoxIntersectionType_INTERSECTION
    end if

  end subroutine bbox_intersect

  subroutine parallel_lines_parameters( &
       start0, end0, start1, end1, disjoint, parameters)

    real(c_double), intent(in) :: start0(2)
    real(c_double), intent(in) :: end0(2)
    real(c_double), intent(in) :: start1(2)
    real(c_double), intent(in) :: end1(2)
    logical(c_bool), intent(out) :: disjoint
    real(c_double), intent(out) :: parameters(2, 2)
    ! Variables outside of signature.
    real(c_double) :: delta0(2)
    real(c_double) :: norm0_sq, s_val0, s_val1

    delta0 = end0 - start0
    ! NOTE: We use the variable ``norm0_sq`` as "workspace" like
    !       ``line0_const`` (in the Python version) and ``s_val0``
    !       acts like ``start1_against``.
    call cross_product(start0, delta0, norm0_sq)
    call cross_product(start1, delta0, s_val0)

    if (norm0_sq /= s_val0) then
       disjoint = .TRUE.
       return
    end if

    norm0_sq = dot_product(delta0, delta0)
    !                S1 = L1(0) = S0 + sA D0
    ! <==>        sA D0 = S1 - S0
    !  ==> sA (D0^T D0) = D0^T (S1 - S0)
    s_val0 = dot_product(start1 - start0, delta0) / norm0_sq
    !                E1 = L1(1) = S0 + sB D0
    ! <==>        sB D0 = E1 - S0
    !  ==> sB (D0^T D0) = D0^T (E1 - S0)
    s_val1 = dot_product(end1 - start0, delta0) / norm0_sq

    ! s = s_val0 + t (s_val1 - s_val0)
    ! t = 0                                <==> s = s_val0
    ! t = 1                                <==> s = s_val1
    ! t = -s_val0 / (s_val1 - s_val0)      <==> s = 0
    ! t = (1 - s_val0) / (s_val1 - s_val0) <==> s = 1
    ! NOTE: We have the relationship:
    !         start_s <--> parameters(1, 1)
    !           end_s <--> parameters(1, 2)
    !         start_t <--> parameters(2, 1)
    !           end_t <--> parameters(2, 2)
    if (s_val0 <= s_val1) then
       ! In this branch the segments are moving in the same direction, i.e.
       ! (t=0<-->s=s_val0) are both less than (t=1<-->s_val1).
       if (1.0_dp < s_val0) then
          disjoint = .TRUE.
          return
       else if (s_val0 < 0.0_dp) then
          parameters(1, 1) = 0.0_dp
          parameters(2, 1) = -s_val0 / (s_val1 - s_val0)
       else
          parameters(1, 1) = s_val0
          parameters(2, 1) = 0.0_dp
       end if

       if (s_val1 < 0.0_dp) then
          disjoint = .TRUE.
          return
       else if (1.0_dp < s_val1) then
          parameters(1, 2) = 1.0_dp
          parameters(2, 2) = (1.0_dp - s_val0) / (s_val1 - s_val0)
       else
          parameters(1, 2) = s_val1
          parameters(2, 2) = 1.0_dp
       end if
    else
       ! In this branch the segments are moving in opposite directions, i.e.
       ! in (t=0<-->s=s_val0) and (t=1<-->s_val1) we have 0 < 1
       ! but ``s_val0 > s_val1``.
       if (s_val0 < 0.0_dp) then
          disjoint = .TRUE.
          return
       else if (1.0_dp < s_val0) then
          parameters(1, 1) = 1.0_dp
          parameters(2, 1) = (s_val0 - 1.0_dp) / (s_val0 - s_val1)
       else
          parameters(1, 1) = s_val0
          parameters(2, 1) = 0.0_dp
       end if

       if (1.0_dp < s_val1) then
          disjoint = .TRUE.
          return
       else if (s_val1 < 0.0_dp) then
          parameters(1, 2) = 0.0_dp
          parameters(2, 2) = s_val0 / (s_val0 - s_val1)
       else
          parameters(1, 2) = s_val1
          parameters(2, 2) = 1.0_dp
       end if
    end if

    ! If we have not ``return``-ed, then the lines overlap.
    disjoint = .FALSE.

  end subroutine parallel_lines_parameters

  subroutine line_line_collide(line1, line2, collision)

    ! NOTE: This subroutine is not part of the C ABI for this module,
    !       but it is (for now) public, so that it can be tested.

    real(c_double), intent(in) :: line1(2, 2)
    real(c_double), intent(in) :: line2(2, 2)
    logical(c_bool), intent(out) :: collision
    ! Variables outside of signature.
    real(c_double) :: s, t, unused_parameters(2, 2)
    logical(c_bool) :: success

    call segment_intersection( &
         line1(:, 1), line1(:, 2), line2(:, 1), line2(:, 2), s, t, success)
    if (success) then
       collision = ( &
            in_interval(s, 0.0_dp, 1.0_dp) .AND. &
            in_interval(t, 0.0_dp, 1.0_dp))
    else
       ! NOTE: We use ``success`` as a stand-in for ``disjoint``.
       call parallel_lines_parameters( &
            line1(:, 1), line1(:, 2), line2(:, 1), line2(:, 2), &
            success, unused_parameters)
       collision = .NOT. success
    end if

  end subroutine line_line_collide

  subroutine convex_hull_collide( &
       num_nodes1, nodes1, polygon1, &
       num_nodes2, nodes2, polygon2, collision)

    ! NOTE: This subroutine is not part of the C ABI for this module,
    !       but it is (for now) public, so that it can be tested.

    integer(c_int), intent(in) :: num_nodes1
    real(c_double), intent(in) :: nodes1(2, num_nodes1)
    real(c_double), allocatable, intent(inout) :: polygon1(:, :)
    integer(c_int), intent(in) :: num_nodes2
    real(c_double), intent(in) :: nodes2(2, num_nodes2)
    real(c_double), allocatable, intent(inout) :: polygon2(:, :)
    logical(c_bool), intent(out) :: collision
    ! Variables outside of signature.
    integer(c_int) :: polygon_size1, polygon_size2

    if (allocated(polygon1)) then
       if (size(polygon1, 2) < num_nodes1) then
          deallocate(polygon1)
          allocate(polygon1(2, num_nodes1))
       end if
    else
       allocate(polygon1(2, num_nodes1))
    end if

    if (allocated(polygon2)) then
       if (size(polygon2, 2) < num_nodes2) then
          deallocate(polygon2)
          allocate(polygon2(2, num_nodes2))
       end if
    else
       allocate(polygon2(2, num_nodes2))
    end if

    call convex_hull( &
         num_nodes1, nodes1, polygon_size1, polygon1)
    call convex_hull( &
         num_nodes2, nodes2, polygon_size2, polygon2)

    if (polygon_size1 == 2 .AND. polygon_size2 == 2) then
       call line_line_collide(polygon1(:, :2), polygon2(:, :2), collision)
    else
       call polygon_collide( &
            polygon_size1, polygon1(:, :polygon_size1), &
            polygon_size2, polygon2(:, :polygon_size2), &
            collision)
    end if

  end subroutine convex_hull_collide

  subroutine newton_simple_root( &
       s, num_nodes1, nodes1, first_deriv1, &
       t, num_nodes2, nodes2, first_deriv2, jacobian, func_val)

    ! NOTE: This subroutine is not part of the C ABI for this module,
    !       but it is (for now) public, so that it can be tested.

    ! Evaluate F(s, t) = B1(s) - B2(t) and compute the Jacobian
    ! DF(s, t) at that point. This is **very** similar to
    ! ``newton_refine_intersect`` but it
    ! 1. Assumes ``first_deriv1`` and ``first_deriv2`` have already
    !    been computed rather than re-computing them in
    !    ``evaluate_hodograph()``
    ! 2. Does not try to solve ``J [ds, dt] = -F``.

    real(c_double), intent(in) :: s
    integer(c_int), intent(in) :: num_nodes1
    real(c_double), intent(in) :: nodes1(2, num_nodes1)
    real(c_double), intent(in) :: first_deriv1(2, num_nodes1 - 1)
    real(c_double), intent(in) :: t
    integer(c_int), intent(in) :: num_nodes2
    real(c_double), intent(in) :: nodes2(2, num_nodes2)
    real(c_double), intent(in) :: first_deriv2(2, num_nodes2 - 1)
    real(c_double), intent(out) :: jacobian(2, 2)
    real(c_double), intent(out) :: func_val(2, 1)
    ! Variables outside of signature.
    real(c_double) :: workspace(2, 1)

    call evaluate_multi( &
         num_nodes1, 2, nodes1, 1, [s], func_val)
    call evaluate_multi( &
         num_nodes2, 2, nodes2, 1, [t], workspace)
    func_val = func_val - workspace

    ! Only compute the Jacobian if ``F(s, t) != [0, 0]``.
    if (all(func_val == 0.0_dp)) then
       return
    end if

    ! NOTE: We somewhat replicate code in ``evaluate_hodograph()`` here.
    !       This is because we have already been provided the nodes for the
    !       derivative.
    call evaluate_multi( &
         num_nodes1 - 1, 2, first_deriv1, 1, [s], jacobian(:, 1:1))
    call evaluate_multi( &
         num_nodes2 - 1, 2, first_deriv2, 1, [t], jacobian(:, 2:2))
    jacobian(:, 2) = -jacobian(:, 2)

  end subroutine newton_simple_root

  subroutine newton_double_root( &
       s, num_nodes1, nodes1, first_deriv1, second_deriv1, &
       t, num_nodes2, nodes2, first_deriv2, second_deriv2, &
       modified_lhs, modified_rhs)

    ! NOTE: This subroutine is not part of the C ABI for this module,
    !       but it is (for now) public, so that it can be tested.

    ! Evaluate G(s, t) which has B1(s) - B2(t) in the first two slots
    ! and B1'(s) x B2'(t) in the third and compute the Jacobian
    ! DG(s, t) at that point. After doing so, make the overdetermined
    ! system square by returning DG^T DG and DG^T G.

    real(c_double), intent(in) :: s
    integer(c_int), intent(in) :: num_nodes1
    real(c_double), intent(in) :: nodes1(2, num_nodes1)
    real(c_double), intent(in) :: first_deriv1(2, num_nodes1 - 1)
    real(c_double), intent(in) :: second_deriv1(2, num_nodes1 - 2)
    real(c_double), intent(in) :: t
    integer(c_int), intent(in) :: num_nodes2
    real(c_double), intent(in) :: nodes2(2, num_nodes2)
    real(c_double), intent(in) :: first_deriv2(2, num_nodes2 - 1)
    real(c_double), intent(in) :: second_deriv2(2, num_nodes2 - 2)
    real(c_double), intent(out) :: modified_lhs(2, 2)
    real(c_double), intent(out) :: modified_rhs(2, 1)
    ! Variables outside of signature.
    real(c_double) :: jacobian(3, 2)
    real(c_double) :: func_val(3, 1)
    real(c_double) :: workspace(2, 1)
    real(c_double) :: b1_ds(2, 1), b2_dt(2, 1)

    call evaluate_multi( &
         num_nodes1, 2, nodes1, 1, [s], workspace)
    func_val(:2, :) = workspace
    call evaluate_multi( &
         num_nodes2, 2, nodes2, 1, [t], workspace)
    func_val(:2, :) = func_val(:2, :) - workspace

    call evaluate_multi( &
         num_nodes1 - 1, 2, first_deriv1, 1, [s], b1_ds)
    call evaluate_multi( &
         num_nodes2 - 1, 2, first_deriv2, 1, [t], b2_dt)
    call cross_product(b1_ds(:, 1), b2_dt(:, 1), func_val(3, 1))

    ! Only compute the Jacobian if ``G(s, t) != [0, 0, 0]``.
    if (all(func_val == 0.0_dp)) then
       modified_rhs = 0.0_dp
       return
    end if

    jacobian(:2, 1:1) = b1_ds
    jacobian(:2, 2:2) = -b2_dt
    ! Here, we use ``workspace`` for ``B1''(s)``.
    if (num_nodes1 > 2) then
       call evaluate_multi( &
            num_nodes1 - 2, 2, second_deriv1, 1, [s], workspace)
       call cross_product(workspace(:, 1), b2_dt(:, 1), jacobian(3, 1))
    else
       jacobian(3, 1) = 0.0_dp
    end if

    ! Here, we use ``workspace`` for ``B2''(t)``.
    if (num_nodes2 > 2) then
       call evaluate_multi( &
            num_nodes2 - 2, 2, second_deriv2, 1, [t], workspace)
       call cross_product(b1_ds(:, 1), workspace(:, 1), jacobian(3, 2))
    else
       jacobian(3, 2) = 0.0_dp
    end if

    modified_lhs = matmul(transpose(jacobian), jacobian)
    modified_rhs = matmul(transpose(jacobian), func_val)

  end subroutine newton_double_root

  subroutine newton_iterate(evaluate_fn, s, t, new_s, new_t, converged)

    ! NOTE: This subroutine is not part of the C ABI for this module,
    !       but it is (for now) public, so that it can be tested.

    ! See ``_intersection_helpers.py::newton_iterate()`` for details on
    ! this implementation.

    procedure(newton_routine) :: evaluate_fn
    real(c_double), intent(in) :: s
    real(c_double), intent(in) :: t
    real(c_double), intent(out) :: new_s
    real(c_double), intent(out) :: new_t
    logical(c_bool), intent(out) :: converged
    ! Variables outside of signature.
    real(c_double) :: jacobian(2, 2), func_val(2, 1)
    real(c_double) :: delta_s, delta_t
    real(c_double) :: norm_update_prev, norm_update, norm_soln
    integer(c_int) :: i, linear_updates

    linear_updates = 0
    new_s = s
    new_t = t

    newton_loop: do i = 1, 10
       call evaluate_fn(new_s, new_t, jacobian, func_val)
       if (all(func_val == 0.0_dp)) then
          converged = .TRUE.
          return
       end if

       ! NOTE: We use ``converged`` as a stand-in for ``singular``.
       call solve2x2(jacobian, func_val(:, 1), converged, delta_s, delta_t)
       if (converged) then
          ! i.e. ``jacobian`` is singular.
          exit newton_loop
       end if

       norm_update_prev = norm_update
       norm_update = norm2([delta_s, delta_t])
       ! If ||p{n} - p{n-1}|| > 0.25 ||p{n-1} - p{n-2}||, then that means
       ! our convergence is acting linear at the current step.
       if (i > 1 .AND. norm_update > 0.25 * norm_update_prev) then
          linear_updates = linear_updates + 1
       end if
       ! If ``>=2/3`` of the updates have been linear, we are near a
       ! non-simple root. (Make sure at least 5 updates have occurred.)
       if (i >= 5 .AND. 3 * linear_updates >= 2 * i) then
          exit newton_loop
       end if

       ! Determine the norm of the "old" solution before updating.
       norm_soln = norm2([new_s, new_t])
       new_s = new_s - delta_s
       new_t = new_t - delta_t

       if (norm_update < NEWTON_ERROR_RATIO * norm_soln) then
          converged = .TRUE.
          return
       end if

    end do newton_loop

    converged = .FALSE.

  end subroutine newton_iterate

  subroutine full_newton_nonzero( &
       s, num_nodes1, nodes1, t, num_nodes2, nodes2, new_s, new_t, status)

    ! NOTE: This subroutine is not part of the C ABI for this module,
    !       but it is (for now) public, so that it can be tested.

    ! Does a "full" Newton's method until convergence.
    ! NOTE: This assumes ``s, t`` are sufficiently far from ``0.0``.

    ! Possible error states:
    ! * Status_SUCCESS         : On success.
    ! * Status_BAD_MULTIPLICITY: If the method doesn't converge to either a
    !                            simple or double root.

    real(c_double), intent(in) :: s
    integer(c_int), intent(in) :: num_nodes1
    real(c_double), intent(in) :: nodes1(2, num_nodes1)
    real(c_double), intent(in) :: t
    integer(c_int), intent(in) :: num_nodes2
    real(c_double), intent(in) :: nodes2(2, num_nodes2)
    real(c_double), intent(out) :: new_s
    real(c_double), intent(out) :: new_t
    integer(c_int), intent(out) :: status
    ! Variables outside of signature.
    real(c_double) :: first_deriv1(2, num_nodes1 - 1)
    real(c_double) :: first_deriv2(2, num_nodes2 - 1)
    logical(c_bool) :: converged
    real(c_double) :: second_deriv1(2, num_nodes1 - 2)
    real(c_double) :: second_deriv2(2, num_nodes2 - 2)
    real(c_double) :: current_s, current_t

    status = Status_SUCCESS

    first_deriv1 = (num_nodes1 - 1) * ( &
         nodes1(:, 2:) - nodes1(:, :num_nodes1 - 1))
    first_deriv2 = (num_nodes2 - 1) * ( &
         nodes2(:, 2:) - nodes2(:, :num_nodes2 - 1))

    call newton_iterate(f_simple, s, t, current_s, current_t, converged)
    if (converged) then
       new_s = current_s
       new_t = current_t
       return
    end if

    if (num_nodes1 > 2) then
       second_deriv1 = (num_nodes1 - 2) * ( &
            first_deriv1(:, 2:) - first_deriv1(:, :num_nodes1 - 2))
    end if
    if (num_nodes2 > 2) then
       second_deriv2 = (num_nodes2 - 2) * ( &
            first_deriv2(:, 2:) - first_deriv2(:, :num_nodes2 - 2))
    end if

    call newton_iterate( &
         f_double, current_s, current_t, new_s, new_t, converged)
    if (converged) then
       return
    end if

    status = Status_BAD_MULTIPLICITY

  contains

    ! NOTE: This is a closure around several variables in the scope above:
    !       * ``num_nodes1``
    !       * ``nodes1``
    !       * ``first_deriv1``
    !       * ``num_nodes2``
    !       * ``nodes2``
    !       * ``first_deriv2``
    subroutine f_simple(s, t, jacobian, func_val)
      real(c_double), intent(in) :: s
      real(c_double), intent(in) :: t
      real(c_double), intent(out) :: jacobian(2, 2)
      real(c_double), intent(out) :: func_val(2, 1)

      call newton_simple_root( &
           s, num_nodes1, nodes1, first_deriv1, &
           t, num_nodes2, nodes2, first_deriv2, jacobian, func_val)

    end subroutine f_simple

    ! NOTE: This is a closure around several variables in the scope above:
    !       * ``num_nodes1``
    !       * ``nodes1``
    !       * ``first_deriv1``
    !       * ``second_deriv1``
    !       * ``num_nodes2``
    !       * ``nodes2``
    !       * ``first_deriv2``
    !       * ``second_deriv2``
    subroutine f_double(s, t, jacobian, func_val)
      real(c_double), intent(in) :: s
      real(c_double), intent(in) :: t
      real(c_double), intent(out) :: jacobian(2, 2)
      real(c_double), intent(out) :: func_val(2, 1)

      call newton_double_root( &
           s, num_nodes1, nodes1, first_deriv1, second_deriv1, &
           t, num_nodes2, nodes2, first_deriv2, second_deriv2, &
           jacobian, func_val)

    end subroutine f_double

  end subroutine full_newton_nonzero

  subroutine full_newton( &
       s, num_nodes1, nodes1, t, num_nodes2, nodes2, new_s, new_t, status)

    ! NOTE: This subroutine is not part of the C ABI for this module,
    !       but it is (for now) public, so that it can be tested.

    ! This is a "wrapper" for ``full_newton_nonzero`` that checks if
    ! ``s`` or ``t`` is below a zero threshold (``2^{-10} ~= 1e-3`` and then
    ! reverses the direction of the curve(s) if the parameter is below. This is
    ! done to avoid round-off issues near ``0.0``.

    ! Possible error states:
    ! * Status_SUCCESS         : On success.
    ! * Status_BAD_MULTIPLICITY: Via ``full_newton_nonzero()``.

    real(c_double), intent(in) :: s
    integer(c_int), intent(in) :: num_nodes1
    real(c_double), intent(in) :: nodes1(2, num_nodes1)
    real(c_double), intent(in) :: t
    integer(c_int), intent(in) :: num_nodes2
    real(c_double), intent(in) :: nodes2(2, num_nodes2)
    real(c_double), intent(out) :: new_s
    real(c_double), intent(out) :: new_t
    integer(c_int), intent(out) :: status
    ! Variables outside of signature.
    real(c_double) :: reversed1(2, num_nodes1)
    real(c_double) :: reversed2(2, num_nodes2)

    if (s < ZERO_THRESHOLD) then
       reversed1 = nodes1(:, num_nodes1:1:-1)
       if (t < ZERO_THRESHOLD) then
          ! s ~= 0, t ~= 0.
          reversed2 = nodes2(:, num_nodes2:1:-1)
          call full_newton_nonzero( &
               1.0_dp - s, num_nodes1, reversed1, &
               1.0_dp - t, num_nodes2, reversed2, &
               new_s, new_t, status)
          new_s = 1.0_dp - new_s
          new_t = 1.0_dp - new_t
       else
          ! s ~= 0, t >> 0.
          call full_newton_nonzero( &
               1.0_dp - s, num_nodes1, reversed1, &
               t, num_nodes2, nodes2, &
               new_s, new_t, status)
          new_s = 1.0_dp - new_s
       end if
    else
       if (t < ZERO_THRESHOLD) then
          ! s >> 0, t ~= 0.
          reversed2 = nodes2(:, num_nodes2:1:-1)
          call full_newton_nonzero( &
               s, num_nodes1, nodes1, &
               1.0_dp - t, num_nodes2, reversed2, &
               new_s, new_t, status)
          new_t = 1.0_dp - new_t
       else
          ! s >> 0, t >> 0.
          call full_newton_nonzero( &
               s, num_nodes1, nodes1, &
               t, num_nodes2, nodes2, new_s, new_t, status)
       end if
    end if

  end subroutine full_newton

  subroutine from_linearized( &
       curve1, num_nodes1, root_nodes1, &
       curve2, num_nodes2, root_nodes2, &
       refined_s, refined_t, does_intersect, status)

    ! NOTE: This assumes that at least one of ``curve1`` and ``curve2`` is
    !       not a line. The line-line case should be handled "early"
    !       by ``check_lines()``.

    ! NOTE: This assumes the caller has verified that the bounding boxes
    !       for ``curve1`` and ``curve2`` actually intersect.

    ! Possible error states:
    ! * Status_SUCCESS         : On success.
    ! * Status_BAD_MULTIPLICITY: Via ``full_newton()``.

    type(CurveData), intent(in) :: curve1
    integer(c_int), intent(in) :: num_nodes1
    real(c_double), intent(in) :: root_nodes1(2, num_nodes1)
    type(CurveData), intent(in) :: curve2
    integer(c_int), intent(in) :: num_nodes2
    real(c_double), intent(in) :: root_nodes2(2, num_nodes2)
    real(c_double), intent(out) :: refined_s, refined_t
    logical(c_bool), intent(out) :: does_intersect
    integer(c_int), intent(out) :: status
    ! Variables outside of signature.
    real(c_double) :: s, t
    logical(c_bool) :: success, bad_parameters

    status = Status_SUCCESS
    does_intersect = .FALSE.  ! Default value.

    call segment_intersection( &
         curve1%nodes(:, 1), curve1%nodes(:, num_nodes1), &
         curve2%nodes(:, 1), curve2%nodes(:, num_nodes2), &
         s, t, success)

    bad_parameters = .FALSE.
    if (success) then
       if (.NOT. ( &
            in_interval(s, 0.0_dp, 1.0_dp) .AND. &
            in_interval(t, 0.0_dp, 1.0_dp))) then
          bad_parameters = .TRUE.
       end if
    else
       ! NOTE: If both curves are lines, the intersection should have
       !       been computed already via ``check_lines()``.

       ! Just fall back to a full Newton iteration starting in the middle of
       ! the given intervals.
       bad_parameters = .TRUE.
       s = 0.5_dp
       t = 0.5_dp
    end if

    if (bad_parameters) then
       call convex_hull_collide( &
            num_nodes1, curve1%nodes, POLYGON1, &
            num_nodes2, curve2%nodes, POLYGON2, success)
       ! In the unlikely case that we have parallel segments or segments
       ! that intersect outside of [0, 1] x [0, 1], we can still exit
       ! if the convex hulls don't intersect.
       if (.NOT. success) then
          return
       end if
    end if

    ! Now, promote ``s`` and ``t`` onto the original curves.
    s = (1.0_dp - s) * curve1%start + s * curve1%end_  ! orig_s
    t = (1.0_dp - t) * curve2%start + t * curve2%end_  ! orig_t

    call full_newton( &
         s, num_nodes1, root_nodes1, &
         t, num_nodes2, root_nodes2, &
         refined_s, refined_t, status)

    if (status /= Status_SUCCESS) then
       return
    end if

    call wiggle_interval(refined_s, s, success)
    if (.NOT. success) then
       return
    end if

    call wiggle_interval(refined_t, t, success)
    if (.NOT. success) then
       return
    end if

    does_intersect = .TRUE.
    refined_s = s
    refined_t = t

  end subroutine from_linearized

  subroutine bbox_line_intersect( &
       num_nodes, nodes, line_start, line_end, enum_)

    integer(c_int), intent(in) :: num_nodes
    real(c_double), intent(in) :: nodes(2, num_nodes)
    real(c_double), intent(in) :: line_start(2)
    real(c_double), intent(in) :: line_end(2)
    integer(c_int), intent(out) :: enum_
    ! Variables outside of signature.
    real(c_double) :: left, right, bottom, top
    real(c_double) :: segment_start(2)
    real(c_double) :: segment_end(2)
    real(c_double) :: s_curr, t_curr
    logical(c_bool) :: success

    call bbox(num_nodes, nodes, left, right, bottom, top)

    ! Check if line start is inside the bounding box.
    if ( &
         in_interval(line_start(1), left, right) .AND. &
         in_interval(line_start(2), bottom, top)) then
       enum_ = BoxIntersectionType_INTERSECTION
       return
    end if

    ! Check if line end is inside the bounding box.
    if ( &
         in_interval(line_end(1), left, right) .AND. &
         in_interval(line_end(2), bottom, top)) then
       enum_ = BoxIntersectionType_INTERSECTION
       return
    end if

    ! NOTE: We allow ``segment_intersection`` to fail below (i.e.
    !       ``success=False``). At first, this may appear to "ignore"
    !       some potential intersections of parallel lines. However,
    !       no intersections will be missed. If parallel lines don't
    !       overlap, then there is nothing to miss. If they do overlap,
    !       then either the segment will have endpoints on the box (already
    !       covered by the checks above) or the segment will contain an
    !       entire side of the box, which will force it to intersect the 3
    !       edges that meet at the two ends of those sides. The parallel
    !       edge will be skipped, but the other two will be covered.

    ! Bottom Edge
    segment_start(1) = left
    segment_start(2) = bottom
    segment_end(1) = right
    segment_end(2) = bottom
    call segment_intersection( &
         segment_start, segment_end, line_start, line_end, &
         s_curr, t_curr, success)
    if ( &
         success .AND. &
         in_interval(s_curr, 0.0_dp, 1.0_dp) .AND. &
         in_interval(t_curr, 0.0_dp, 1.0_dp)) then
       enum_ = BoxIntersectionType_INTERSECTION
       return
    end if

    ! Right Edge
    segment_start(1) = right
    segment_start(2) = bottom
    segment_end(1) = right
    segment_end(2) = top
    call segment_intersection( &
         segment_start, segment_end, line_start, line_end, &
         s_curr, t_curr, success)
    if ( &
         success .AND. &
         in_interval(s_curr, 0.0_dp, 1.0_dp) .AND. &
         in_interval(t_curr, 0.0_dp, 1.0_dp)) then
       enum_ = BoxIntersectionType_INTERSECTION
       return
    end if

    ! Top Edge
    segment_start(1) = right
    segment_start(2) = top
    segment_end(1) = left
    segment_end(2) = top
    call segment_intersection( &
         segment_start, segment_end, line_start, line_end, &
         s_curr, t_curr, success)
    if ( &
         success .AND. &
         in_interval(s_curr, 0.0_dp, 1.0_dp) .AND. &
         in_interval(t_curr, 0.0_dp, 1.0_dp)) then
       enum_ = BoxIntersectionType_INTERSECTION
       return
    end if

    ! NOTE: We skip the "last" edge. This is because any curve
    !       that doesn't have an endpoint on a curve must cross
    !       at least two, so we will have already covered such curves
    !       in one of the branches above.

    enum_ = BoxIntersectionType_DISJOINT

  end subroutine bbox_line_intersect

  subroutine check_lines( &
       num_nodes1, nodes1, num_nodes2, nodes2, &
       both_linear, coincident, intersections, num_intersections)

    ! NOTE: This subroutine is not part of the C ABI for this module,
    !       but it is (for now) public, so that it can be tested.

    integer(c_int), intent(in) :: num_nodes1
    real(c_double), intent(in) :: nodes1(2, num_nodes1)
    integer(c_int), intent(in) :: num_nodes2
    real(c_double), intent(in) :: nodes2(2, num_nodes2)
    logical(c_bool), intent(out) :: both_linear
    logical(c_bool), intent(out) :: coincident
    real(c_double), allocatable, intent(inout) :: intersections(:, :)
    integer(c_int), intent(out) :: num_intersections
    ! Variables outside of signature.
    real(c_double) :: value1, value2
    logical(c_bool) :: predicate

    num_intersections = 0
    coincident = .FALSE.
    ! NOTE: ``value1`` is a stand-in for ``error`.
    call linearization_error(num_nodes1, 2, nodes1, value1)
    if (value1 /= 0.0_dp) then
       both_linear = .FALSE.
       return
    end if
    ! NOTE: ``value1`` is a stand-in for ``error`.
    call linearization_error(num_nodes2, 2, nodes2, value1)
    if (value1 /= 0.0_dp) then
       both_linear = .FALSE.
       return
    end if

    both_linear = .TRUE.
    ! NOTE: ``value1`` / ``value2`` are stand-ins for ``s`` / ``t``.
    call segment_intersection( &
         nodes1(:, 1), nodes1(:, num_nodes1), &
         nodes2(:, 1), nodes2(:, num_nodes2), &
         value1, value2, predicate)
    ! Here, ``predicate`` is a stand-in for ``success`` of
    ! segment intersection.
    if (predicate) then
       if (in_interval(value1, 0.0_dp, 1.0_dp) .AND. &
            in_interval(value2, 0.0_dp, 1.0_dp)) then
          if (.NOT. allocated(intersections)) then
             ! NOTE: This assumes, but does not check, that if it is
             !       allocated, ``intersections`` has exactly 2 rows and at
             !       least 1 column.
             allocate(intersections(2, 1))
          end if
          intersections(1, 1) = value1
          intersections(2, 1) = value2
          num_intersections = 1
       end if
    else
       ! NOTE: This assumes these new parameters will be the first ones
       !       in ``intersections`` (i.e. if we deallocate we don't need
       !       to "swap"). It also may allocate ``intersections`` even
       !       if the space isn't needed. But over the long term this will
       !       not be a problem because the allocatable intersections
       !       will be re-used and large enough.
       if (allocated(intersections)) then
          if (size(intersections, 2) < 2) then
             deallocate(intersections)
             allocate(intersections(2, 2))
          end if
       else
          allocate(intersections(2, 2))
       end if
       ! Here, ``predicate`` is a stand-in for ``disjoint``.
       call parallel_lines_parameters( &
            nodes1(:, 1), nodes1(:, num_nodes1), &
            nodes2(:, 1), nodes2(:, num_nodes2), &
            predicate, intersections)
       if (.NOT. predicate) then
          ! I.e., ``disjoint == .FALSE.``
          coincident = .TRUE.
          num_intersections = 2
       end if
    end if

  end subroutine check_lines

  subroutine add_intersection( &
       s, t, num_intersections, intersections)

    ! Adds an intersection to list of ``intersections``.

    real(c_double), intent(in) :: s
    real(c_double), intent(in) :: t
    integer(c_int), intent(inout) :: num_intersections
    real(c_double), allocatable, intent(inout) :: intersections(:, :)
    ! Variables outside of signature.
    integer(c_int) :: curr_size, index_
    real(c_double), allocatable :: intersections_swap(:, :)
    real(c_double) :: workspace(2)
    real(c_double) :: norm_candidate

    ! First, determine what the actual candidate is, i.e. ``(s, t)`` vs.
    ! ``(1 - s , t)``, ``(s, 1 - t)`` or ``(1 - s, 1 - t)``.
    if (s < ZERO_THRESHOLD) then
       workspace(1) = 1.0_dp - s
    else
       workspace(1) = s
    end if
    if (t < ZERO_THRESHOLD) then
       workspace(2) = 1.0_dp - t
    else
       workspace(2) = t
    end if

    norm_candidate = norm2(workspace)
    ! First, check if the intersection is a duplicate (up to precision,
    ! determined by ``ulps_away``).
    do index_ = 1, num_intersections
       ! NOTE: |(1 - s1) - (1 - s2)| = |s1 - s2| in exact arithmetic, so
       !       we just compute ``s1 - s2`` rather than using
       !       ``candidate_s`` / ``candidate_t``. Due to round-off, these
       !       differences may be slightly different, but only up to machine
       !       precision.
       workspace(1) = s - intersections(1, index_)
       workspace(2) = t - intersections(2, index_)
       if (norm2(workspace) < NEWTON_ERROR_RATIO * norm_candidate) then
          return
       end if
    end do

    ! Update the number of intersections.
    num_intersections = num_intersections + 1

    if (allocated(intersections)) then
       curr_size = size(intersections, 2)
       if (curr_size < num_intersections) then
          allocate(intersections_swap(2, num_intersections))
          intersections_swap(:, :curr_size) = intersections(:, :curr_size)
          call move_alloc(intersections_swap, intersections)
       end if
    else
       allocate(intersections(2, num_intersections))
    end if

    intersections(1, num_intersections) = s
    intersections(2, num_intersections) = t

  end subroutine add_intersection

  subroutine add_from_linearized( &
       first, root_nodes1, second, root_nodes2, &
       num_intersections, intersections, status)

    ! Adds an intersection from two linearizations.
    !
    ! NOTE: This is **explicitly** not intended for C inter-op.

    ! Possible error states:
    ! * Status_SUCCESS         : On success.
    ! * Status_BAD_MULTIPLICITY: Via ``from_linearized()``.

    type(CurveData), intent(in) :: first
    real(c_double), intent(in) :: root_nodes1(:, :)
    type(CurveData), intent(in) :: second
    real(c_double), intent(in) :: root_nodes2(:, :)
    integer(c_int), intent(inout) :: num_intersections
    real(c_double), allocatable, intent(inout) :: intersections(:, :)
    integer(c_int), intent(out) :: status
    ! Variables outside of signature.
    integer(c_int) :: num_nodes1, num_nodes2
    real(c_double) :: refined_s, refined_t
    logical(c_bool) :: does_intersect

    num_nodes1 = size(first%nodes, 2)
    num_nodes2 = size(second%nodes, 2)

    call from_linearized( &
         first, num_nodes1, root_nodes1, &
         second, num_nodes2, root_nodes2, &
         refined_s, refined_t, does_intersect, status)

    if (status /= Status_SUCCESS) then
       return
    end if

    if (.NOT. does_intersect) then
       return
    end if

    call add_intersection( &
         refined_s, refined_t, num_intersections, intersections)

  end subroutine add_from_linearized

  subroutine endpoint_check( &
       first, node_first, s, second, node_second, t, &
       num_intersections, intersections)

    ! NOTE: This is **explicitly** not intended for C inter-op.

    type(CurveData), intent(in) :: first
    real(c_double), intent(in) :: node_first(2)
    real(c_double), intent(in) :: s
    type(CurveData), intent(in) :: second
    real(c_double), intent(in) :: node_second(2)
    real(c_double), intent(in) :: t
    integer(c_int), intent(inout) :: num_intersections
    real(c_double), allocatable, intent(inout) :: intersections(:, :)
    ! Variables outside of signature.
    real(c_double) :: orig_s, orig_t

    if (.NOT. vector_close(2, node_first, node_second, VECTOR_CLOSE_EPS)) then
       return
    end if

    orig_s = (1 - s) * first%start + s * first%end_
    orig_t = (1 - t) * second%start + t * second%end_
    call add_intersection(orig_s, orig_t, num_intersections, intersections)

  end subroutine endpoint_check

  subroutine tangent_bbox_intersection( &
       first, second, num_intersections, intersections)

    ! NOTE: This is **explicitly** not intended for C inter-op.

    type(CurveData), intent(in) :: first, second
    integer(c_int), intent(inout) :: num_intersections
    real(c_double), allocatable, intent(inout) :: intersections(:, :)
    ! Variables outside of signature.
    integer(c_int) :: num_nodes1, num_nodes2
    real(c_double) :: nodes1_start(2), nodes1_end(2)
    real(c_double) :: nodes2_start(2), nodes2_end(2)

    num_nodes1 = size(first%nodes, 2)
    nodes1_start = first%nodes(:2, 1)
    nodes2_start = first%nodes(:2, num_nodes1)

    num_nodes2 = size(second%nodes, 2)
    nodes1_end = second%nodes(:2, 1)
    nodes2_end = second%nodes(:2, num_nodes2)

    call endpoint_check( &
         first, nodes1_start, 0.0_dp, &
         second, nodes1_end, 0.0_dp, &
         num_intersections, intersections)
    call endpoint_check( &
         first, nodes1_start, 0.0_dp, &
         second, nodes2_end, 1.0_dp, &
         num_intersections, intersections)
    call endpoint_check( &
         first, nodes2_start, 1.0_dp, &
         second, nodes1_end, 0.0_dp, &
         num_intersections, intersections)
    call endpoint_check( &
         first, nodes2_start, 1.0_dp, &
         second, nodes2_end, 1.0_dp, &
         num_intersections, intersections)

  end subroutine tangent_bbox_intersection

  subroutine add_candidates( &
       candidates, num_candidates, first, second, enum_)

    ! Helper for ``intersect_one_round``.

    type(CurveData), allocatable, intent(inout) :: candidates(:, :)
    integer(c_int), intent(inout) :: num_candidates
    type(CurveData), intent(in) :: first, second
    integer(c_int), intent(in) :: enum_
    ! Variables outside of signature.
    integer(c_int) :: curr_size
    type(CurveData), allocatable :: candidates_swap(:, :)

    ! First, update the number of candidates.
    if (enum_ == Subdivide_FIRST .OR. enum_ == Subdivide_SECOND) then
       num_candidates = num_candidates + 2
    else if (enum_ == Subdivide_BOTH) then
       num_candidates = num_candidates + 4
    else
       return
    end if

    if (allocated(candidates)) then
       curr_size = size(candidates, 2)
       if (curr_size < num_candidates) then
          allocate(candidates_swap(2, num_candidates))
          ! NOTE: This assumes, but does not check ``candidates`` has two rows.
          candidates_swap(:, :curr_size) = candidates(:, :curr_size)
          call move_alloc(candidates_swap, candidates)
       end if
    else
       allocate(candidates(2, num_candidates))
    end if

    ! NOTE: This assumes, but does not check, that ``candidates`` is MxN with
    !       M == 2 and ``num_candidates`` <= N.

    if (enum_ == Subdivide_FIRST) then
       candidates(2, num_candidates - 1) = second
       candidates(2, num_candidates) = second
       call subdivide_curve( &
            first, &
            candidates(1, num_candidates - 1), &
            candidates(1, num_candidates))
    else if (enum_ == Subdivide_SECOND) then
       candidates(1, num_candidates - 1) = first
       candidates(1, num_candidates) = first
       call subdivide_curve( &
            second, &
            candidates(2, num_candidates - 1), &
            candidates(2, num_candidates))
    else if (enum_ == Subdivide_BOTH) then
       call subdivide_curve( &
            first, &
            candidates(1, num_candidates - 3), &
            candidates(1, num_candidates - 1))
       call subdivide_curve( &
            second, &
            candidates(2, num_candidates - 3), &
            candidates(2, num_candidates - 2))

       candidates(1, num_candidates - 2) = candidates(1, num_candidates - 3)
       candidates(2, num_candidates - 1) = candidates(2, num_candidates - 3)
       candidates(1, num_candidates) = candidates(1, num_candidates - 1)
       candidates(2, num_candidates) = candidates(2, num_candidates - 2)
    end if

  end subroutine add_candidates

  subroutine intersect_one_round( &
       root_nodes_first, root_nodes_second, num_candidates, candidates, &
       num_intersections, intersections, &
       next_candidates, num_next_candidates, status)

    ! NOTE: This is **explicitly** not intended for C inter-op.
    ! NOTE: This assumes, but does not check, that ``candidates`` has
    !       two rows and has at **least** ``num_candidates`` columns.

    ! Possible error states:
    ! * Status_SUCCESS         : On success.
    ! * Status_BAD_MULTIPLICITY: Via ``add_from_linearized()``.

    real(c_double), intent(in) :: root_nodes_first(:, :)
    real(c_double), intent(in) :: root_nodes_second(:, :)
    integer(c_int), intent(in) :: num_candidates
    type(CurveData), intent(in) :: candidates(:, :)
    integer(c_int), intent(inout) :: num_intersections
    real(c_double), allocatable, intent(inout) :: intersections(:, :)
    type(CurveData), allocatable, intent(inout) :: next_candidates(:, :)
    integer(c_int), intent(out) :: num_next_candidates
    integer(c_int), intent(out) :: status
    ! Variables outside of signature.
    type(CurveData) :: first, second
    real(c_double) :: linearization_error1, linearization_error2
    integer(c_int) :: bbox_int, index_, num_nodes1, num_nodes2
    integer(c_int) :: subdivide_enum

    num_next_candidates = 0
    status = Status_SUCCESS
    subdivide_loop: do index_ = 1, num_candidates
       ! NOTE: We **hope** that the compiler avoids turning this alias (for
       !       the sake of typing fewer characters) into a copy.
       first = candidates(1, index_)
       second = candidates(2, index_)
       ! Compute the linearization error for each curve.
       num_nodes1 = size(first%nodes, 2)
       num_nodes2 = size(second%nodes, 2)
       call linearization_error( &
            num_nodes1, 2, first%nodes, linearization_error1)
       call linearization_error( &
            num_nodes2, 2, second%nodes, linearization_error2)

       if (linearization_error1 < LINEARIZATION_THRESHOLD) then
          if (linearization_error2 < LINEARIZATION_THRESHOLD) then
             subdivide_enum = Subdivide_NEITHER
             call bbox_intersect( &
                  num_nodes1, first%nodes, num_nodes2, second%nodes, bbox_int)
          else
             subdivide_enum = Subdivide_SECOND
             call bbox_line_intersect( &
                  num_nodes2, second%nodes, &
                  first%nodes(:, 1), first%nodes(:, num_nodes1), bbox_int)
          end if
       else
          if (linearization_error2 < LINEARIZATION_THRESHOLD) then
             subdivide_enum = Subdivide_FIRST
             call bbox_line_intersect( &
                  num_nodes1, first%nodes, &
                  second%nodes(:, 1), second%nodes(:, num_nodes2), bbox_int)
          else
             subdivide_enum = Subdivide_BOTH
             ! If neither curve is close to a line, we can still reject the
             ! pair if the bounding boxes are disjoint.
             call bbox_intersect( &
                  num_nodes1, first%nodes, num_nodes2, second%nodes, bbox_int)
          end if
       end if

       ! Reject if the bounding boxes do not intersect.
       if (bbox_int == BoxIntersectionType_DISJOINT) then
          cycle subdivide_loop
       else if ( &
            bbox_int == BoxIntersectionType_TANGENT .AND. &
            subdivide_enum /= Subdivide_NEITHER) then
          ! NOTE: Ignore tangent bounding boxes in the linearized case
          !       because ``tangent_bbox_intersection()`` assumes that both
          !       curves are not linear.
          call tangent_bbox_intersection( &
               first, second, num_intersections, intersections)
          cycle subdivide_loop
       end if

       if (subdivide_enum == Subdivide_NEITHER) then
          ! If both ``first`` and ``second`` are linearizations, then
          ! we can (attempt to) intersect them immediately.
          call add_from_linearized( &
               first, root_nodes_first, second, root_nodes_second, &
               num_intersections, intersections, status)

          ! If there was a failure, exit this subroutine.
          if (status /= Status_SUCCESS) then
             return
          end if

          ! If there was no failure, move to the next iteration.
          cycle subdivide_loop
       end if

       ! If we haven't ``cycle``-d this iteration, add the
       ! ``next_candidates`` pair.
       call add_candidates( &
            next_candidates, num_next_candidates, &
            first, second, subdivide_enum)
    end do subdivide_loop

  end subroutine intersect_one_round

  subroutine make_candidates( &
       nodes_first, nodes_second, candidates)

    ! NOTE: This is a (private) helper for ``all_intersections``.

    real(c_double), intent(in) :: nodes_first(:, :)
    real(c_double), intent(in) :: nodes_second(:, :)
    type(CurveData), allocatable, intent(inout) :: candidates(:, :)

    ! NOTE: This assumes (but does not verify) that if ``candidates`` has
    !       been allocated, then it is ``2 x N`` with ``N > 0``.
    if (.NOT. allocated(candidates)) then
       allocate(candidates(2, 1))
    end if

    ! NOTE: Since we **might** be re-using ``candidates``, we can't rely on
    !       the default values of all fields being intact.
    candidates(1, 1)%start = 0.0_dp
    candidates(1, 1)%end_ = 1.0_dp
    candidates(1, 1)%nodes = nodes_first
    candidates(2, 1)%start = 0.0_dp
    candidates(2, 1)%end_ = 1.0_dp
    candidates(2, 1)%nodes = nodes_second

  end subroutine make_candidates

  subroutine prune_candidates(candidates, num_candidates)

    ! Uses more strict bounding box intersection predicate by forming the
    ! actual convex hull of each candidate curve segment and then checking
    ! if those convex hulls collide.

    type(CurveData), allocatable, intent(inout) :: candidates(:, :)
    integer(c_int), intent(inout) :: num_candidates
    ! Variables outside of signature.
    integer(c_int) :: accepted, i
    integer(c_int) :: num_nodes1, num_nodes2
    logical(c_bool) :: collision

    accepted = 0
    ! NOTE: This **assumes** but does not check that ``candidates`` is
    !       allocated and size ``2 x NC`` where ``NC >= num_candidates``.
    do i = 1, num_candidates
       ! NOTE: This **assumes** that ``%nodes`` is allocated and size
       !       ``N x 2``.
       num_nodes1 = size(candidates(1, i)%nodes, 2)
       ! NOTE: This **assumes** that ``%nodes`` is allocated and size
       !       ``N x 2``.
       num_nodes2 = size(candidates(2, i)%nodes, 2)
       call convex_hull_collide( &
            num_nodes1, candidates(1, i)%nodes, POLYGON1, &
            num_nodes2, candidates(2, i)%nodes, POLYGON2, collision)

       if (collision) then
          accepted = accepted + 1
          ! NOTE: This relies on the invariant ``accepted <= i``. In the
          !       ``accepted == i`` case, there is nothing to do.
          if (accepted < i) then
             candidates(1, accepted) = candidates(1, i)
             candidates(2, accepted) = candidates(2, i)
          end if
       end if
    end do
    num_candidates = accepted

  end subroutine prune_candidates

  subroutine elevate_helper( &
       curr_size, nodes, final_size, workspace, elevated)

    ! NOTE: This is a helper for ``make_same_degree``.
    ! NOTE: This assumes, but does not check, that ``final_size > curr_size``.

    integer(c_int), intent(in) :: curr_size
    real(c_double), intent(in) :: nodes(2, curr_size)
    integer(c_int), intent(in) :: final_size
    real(c_double), intent(inout) :: workspace(2, final_size)
    real(c_double), intent(inout) :: elevated(2, final_size)
    ! Variables outside of signature.
    logical(c_bool) :: to_workspace
    integer(c_int) :: i

    ! Elevate ``nodes`` by using both ``workspace`` and ``elevated`` as
    ! workspaces.
    if (mod(final_size - curr_size, 2) == 1) then
       ! If we have an odd number of steps, then we'll write to e1
       ! first, for example:
       ! 1 step : ws -> el
       ! 3 steps: ws -> el -> ws -> el
       workspace(:, :curr_size) = nodes
       to_workspace = .FALSE.
    else
       ! If we have an odd number of steps, then we'll write to ws
       ! first, for example:
       ! 2 steps: el -> ws -> el
       ! 4 steps: el -> ws -> el -> ws -> el
       elevated(:, :curr_size) = nodes
       to_workspace = .TRUE.
    end if

    do i = curr_size, final_size - 1
       if (to_workspace) then
          call elevate_nodes( &
               i, 2, elevated(:, :i), workspace(:, :i + 1))
       else
          call elevate_nodes( &
               i, 2, workspace(:, :i), elevated(:, :i + 1))
       end if

       to_workspace = .NOT. to_workspace  ! Switch parity.
    end do

  end subroutine elevate_helper

  subroutine make_same_degree( &
       num_nodes1, nodes1, num_nodes2, nodes2, &
       num_nodes, elevated1, elevated2)

    ! NOTE: This subroutine is not part of the C ABI for this module,
    !       but it is (for now) public, so that it can be tested.

    integer(c_int), intent(in) :: num_nodes1
    real(c_double), intent(in) :: nodes1(2, num_nodes1)
    integer(c_int), intent(in) :: num_nodes2
    real(c_double), intent(in) :: nodes2(2, num_nodes2)
    integer(c_int), intent(out) :: num_nodes
    real(c_double), allocatable, intent(out) :: elevated1(:, :)
    real(c_double), allocatable, intent(out) :: elevated2(:, :)

    if (num_nodes1 > num_nodes2) then
       num_nodes = num_nodes1
       allocate(elevated1(2, num_nodes1))
       allocate(elevated2(2, num_nodes1))
       ! Populate ``elevated2`` by elevating (using ``elevated1`` as a
       ! helper workspace).
       call elevate_helper( &
            num_nodes2, nodes2, num_nodes1, elevated1, elevated2)
       ! Populate ``elevated1`` without re-allocating it.
       elevated1(:, :) = nodes1
    else if (num_nodes2 > num_nodes1) then
       num_nodes = num_nodes2
       allocate(elevated1(2, num_nodes2))
       allocate(elevated2(2, num_nodes2))
       ! Populate ``elevated1`` by elevating (using ``elevated2`` as a
       ! helper workspace).
       call elevate_helper( &
            num_nodes1, nodes1, num_nodes2, elevated2, elevated1)
       ! Populate ``elevated2`` without re-allocating it.
       elevated2(:, :) = nodes2
    else
       num_nodes = num_nodes2
       elevated1 = nodes1
       elevated2 = nodes2
    end if

  end subroutine make_same_degree

  subroutine add_coincident_parameters( &
       num_nodes1, nodes1, num_nodes2, nodes2, &
       num_intersections, intersections, coincident)

    ! NOTE: This subroutine is not part of the C ABI for this module,
    !       but it is (for now) public, so that it can be tested.

    ! NOTE: If ``locate_point()`` fails with ``LOCATE_INVALID`` when trying
    !       to place **any** of the curve endpoints on the other segment,
    !       this method will just return ``coincident == FALSE``. This
    !       is "intentional" in the sense that callers (likely) won't benefit
    !       from a **different** error status than the one they are already
    !       trying to avoid by showing the curves are coincident.

    integer(c_int), intent(in) :: num_nodes1
    real(c_double), intent(in) :: nodes1(2, num_nodes1)
    integer(c_int), intent(in) :: num_nodes2
    real(c_double), intent(in) :: nodes2(2, num_nodes2)
    integer(c_int), intent(inout) :: num_intersections
    real(c_double), allocatable, intent(inout) :: intersections(:, :)
    logical(c_bool), intent(out) :: coincident
    ! Variables outside of signature.
    real(c_double), target, allocatable :: elevated1(:, :)
    real(c_double), target, allocatable :: elevated2(:, :)
    real(c_double), target, allocatable :: specialized(:, :)
    integer(c_int) :: num_nodes
    real(c_double) :: point(2)
    real(c_double) :: s_initial, s_final, t_initial, t_final
    real(c_double), pointer :: as_vec1(:), as_vec2(:)

    coincident = .FALSE.
    ! First, make sure the nodes are the same degree.
    call make_same_degree( &
         num_nodes1, nodes1, num_nodes2, nodes2, &
         num_nodes, elevated1, elevated2)

    point = nodes2(:, 1)
    call locate_point( &
         num_nodes, 2, elevated1, point, s_initial)
    point = nodes2(:, num_nodes2)
    call locate_point( &
         num_nodes, 2, elevated1, point, s_final)
    ! Bail out if the "locate" failed.
    if (s_initial == LOCATE_INVALID .OR. s_final == LOCATE_INVALID) then
       return
    end if

    if (s_initial /= LOCATE_MISS .AND. s_final /= LOCATE_MISS) then
       ! In this case, if the curves were coincident, then ``curve2``
       ! would be "fully" contained in ``curve1``, so we specialize
       ! ``curve1`` down to that interval to check.
       allocate(specialized(2, num_nodes))
       call specialize_curve( &
            num_nodes, 2, elevated1, s_initial, s_final, specialized)
       call c_f_pointer(c_loc(specialized), as_vec1, [2 * num_nodes])
       call c_f_pointer(c_loc(elevated2), as_vec2, [2 * num_nodes])

       if (vector_close( &
            2 * num_nodes, as_vec1, as_vec2, VECTOR_CLOSE_EPS)) then
          coincident = .TRUE.
          ! Empty out candidates since anything in there until now was
          ! "accidental".
          num_intersections = 0
          call add_intersection( &
               s_initial, 0.0_dp, num_intersections, intersections)
          call add_intersection( &
               s_final, 1.0_dp, num_intersections, intersections)
       end if

       ! In either case (``vector_close()`` or not), we are done.
       return
    end if

    point = nodes1(:, 1)
    call locate_point( &
         num_nodes, 2, elevated2, point, t_initial)
    point = nodes1(:, num_nodes1)
    call locate_point( &
         num_nodes, 2, elevated2, point, t_final)
    ! Bail out if the "locate" failed.
    if (t_initial == LOCATE_INVALID .OR. t_final == LOCATE_INVALID) then
       return
    end if

    if (t_initial == LOCATE_MISS .AND. t_final == LOCATE_MISS) then
       ! An overlap must have two endpoints and since at most one of the
       ! endpoints of ``curve2`` lies on ``curve1`` (as indicated by at
       ! least one of the ``s``-parameters being ``None``), we need (at least)
       ! one endpoint of ``curve1`` on ``curve2``.
       return
    end if

    if (t_initial /= LOCATE_MISS .AND. t_final /= LOCATE_MISS) then
       ! In this case, if the curves were coincident, then ``curve1``
       ! would be "fully" contained in ``curve2``, so we specialize
       ! ``curve2`` down to that interval to check.
       allocate(specialized(2, num_nodes))
       call specialize_curve( &
            num_nodes, 2, elevated2, t_initial, t_final, specialized)
       call c_f_pointer(c_loc(elevated1), as_vec1, [2 * num_nodes])
       call c_f_pointer(c_loc(specialized), as_vec2, [2 * num_nodes])

       if (vector_close( &
            2 * num_nodes, as_vec1, as_vec2, VECTOR_CLOSE_EPS)) then
          coincident = .TRUE.
          ! Empty out candidates since anything in there until now was
          ! "accidental".
          num_intersections = 0
          call add_intersection( &
               0.0_dp, t_initial, num_intersections, intersections)
          call add_intersection( &
               1.0_dp, t_final, num_intersections, intersections)
       end if

       ! In either case (``vector_close()`` or not), we are done.
       return
    end if

    if (s_initial == LOCATE_MISS .AND. s_final == LOCATE_MISS) then
       ! An overlap must have two endpoints and since exactly one of the
       ! endpoints of ``curve1`` lies on ``curve2`` (as indicated by exactly
       ! one of the ``t``-parameters being ``None``), we need (at least)
       ! one endpoint of ``curve1`` on ``curve2``.
       return
    end if

    ! At this point, we know exactly one of the ``s``-parameters and exactly
    ! one of the ``t``-parameters is not ``None``. So we fill in all four
    ! of ``(s|t)_(initial|final)`` with the known values.
    if (s_initial == LOCATE_MISS) then
       if (t_initial == LOCATE_MISS) then
          ! B1(s_final) = B2(1) AND B1(1) = B2(t_final)
          s_initial = s_final
          s_final = 1.0_dp
          t_initial = 1.0_dp
          ! t_final is fine as-is
       else
          ! B1(0) = B2(t_initial) AND B1(s_final) = B2(1)
          s_initial = 0.0_dp
          ! s_final is fine as-is
          ! t_initial is fine as-is
          t_final = 1.0_dp
       end if
    else
       if (t_initial == LOCATE_MISS) then
          ! B1(s_initial) = B2(0) AND B1(1 ) = B2(t_final)
          ! s_initial is fine as-is
          s_final = 1.0_dp
          t_initial = 0.0_dp
          ! t_final is fine as-is
       else
          ! B1(0) = B2(t_initial) AND B1(s_initial) = B2(0)
          s_final = s_initial
          s_initial = 0.0_dp
          ! t_initial is fine as-is
          t_final = 0.0_dp
       end if
    end if

    if ( &
         abs(s_initial - s_final) < MIN_INTERVAL_WIDTH .AND. &
         abs(t_initial - t_final) < MIN_INTERVAL_WIDTH) then
       return
    end if

    allocate(specialized(2, num_nodes))
    ! First specialize ``elevated1`` onto ``specialized``.
    call specialize_curve( &
         num_nodes, 2, elevated1, s_initial, s_final, specialized)
    ! Then specialize ``elevated2`` onto ``elevated1`` since we are
    ! done with it.
    call specialize_curve( &
         num_nodes, 2, elevated2, t_initial, t_final, elevated1)

    call c_f_pointer(c_loc(specialized), as_vec1, [2 * num_nodes])
    call c_f_pointer(c_loc(elevated1), as_vec2, [2 * num_nodes])

    if (vector_close( &
         2 * num_nodes, as_vec1, as_vec2, VECTOR_CLOSE_EPS)) then
       coincident = .TRUE.
       ! Empty out candidates since anything in there until now was
       ! "accidental".
       num_intersections = 0
       call add_intersection( &
            s_initial, t_initial, num_intersections, intersections)
       call add_intersection( &
            s_final, t_final, num_intersections, intersections)
    end if

  end subroutine add_coincident_parameters

  subroutine all_intersections( &
       num_nodes_first, nodes_first, num_nodes_second, nodes_second, &
       intersections, num_intersections, coincident, status)

    ! NOTE: This is **explicitly** not intended for C inter-op, but
    !       a C compatible interface is exposed as ``all_intersections_abi``.

    ! Possible error states:
    ! * Status_SUCCESS         : On success.
    ! * Status_NO_CONVERGE     : If the curves don't converge to linear after
    !                            ``MAX_INTERSECT_SUBDIVISIONS``.
    ! * (N >= MAX_CANDIDATES)  : The number of candidates if it exceeds the
    !                            limit ``MAX_CANDIDATES`` (64 is the default).
    ! * Status_BAD_MULTIPLICITY: Via ``intersect_one_round()``.

    integer(c_int), intent(in) :: num_nodes_first
    real(c_double), intent(in) :: nodes_first(2, num_nodes_first)
    integer(c_int), intent(in) :: num_nodes_second
    real(c_double), intent(in) :: nodes_second(2, num_nodes_second)
    real(c_double), allocatable, intent(inout) :: intersections(:, :)
    integer(c_int), intent(out) :: num_intersections
    logical(c_bool), intent(out) :: coincident
    integer(c_int), intent(out) :: status
    ! Variables outside of signature.
    integer(c_int) :: num_candidates, num_next_candidates
    integer(c_int) :: index_, intersect_status
    logical(c_bool) :: is_even

    status = Status_SUCCESS  ! Default.

    ! NOTE: Here, we use ``is_even`` as ``both_linear``.
    call check_lines( &
         num_nodes_first, nodes_first, num_nodes_second, nodes_second, &
         is_even, coincident, intersections, num_intersections)
    if (is_even) then
       ! I.e. if ``both_linear``.
       return
    end if

    num_intersections = 0
    coincident = .FALSE.
    ! First iteration is odd (i.e. ``index_ == 1``).
    num_candidates = 1
    call make_candidates( &
         nodes_first, nodes_second, CANDIDATES_ODD)

    is_even = .TRUE.  ! At zero.
    do index_ = 1, MAX_INTERSECT_SUBDIVISIONS
       is_even = .NOT. is_even  ! Switch parity.

       if (is_even) then
          ! Since ``index_`` is even, we READ from ``CANDIDATES_EVEN``
          ! and WRITE to ``CANDIDATES_ODD``.
          call intersect_one_round( &
               nodes_first, nodes_second, &
               num_candidates, CANDIDATES_EVEN, &
               num_intersections, intersections, &
               CANDIDATES_ODD, num_next_candidates, intersect_status)
       else
          ! Since ``index_`` is odd, we READ from ``CANDIDATES_ODD``
          ! and WRITE to ``CANDIDATES_EVEN``.
          call intersect_one_round( &
               nodes_first, nodes_second, &
               num_candidates, CANDIDATES_ODD, &
               num_intersections, intersections, &
               CANDIDATES_EVEN, num_next_candidates, intersect_status)
       end if

       ! NOTE: This only checks for two error statuses from
       !       ``intersect_one_round()``, so it is inherently brittle
       !       to changes there.
       if (intersect_status /= Status_SUCCESS) then
          status = intersect_status
          return
       end if

       ! Update the number of candidates.
       num_candidates = num_next_candidates

       ! Bail out of there are too many candidates.
       if (num_candidates > MAX_CANDIDATES) then
          if (is_even) then
             call prune_candidates(CANDIDATES_ODD, num_candidates)
          else
             call prune_candidates(CANDIDATES_EVEN, num_candidates)
          end if
          ! If pruning didn't fix anything, we check if the curves are
          ! coincident and "fail" if they aren't.
          if (num_candidates > MAX_CANDIDATES) then
             call add_coincident_parameters( &
                  num_nodes_first, nodes_first, &
                  num_nodes_second, nodes_second, &
                  num_intersections, intersections, coincident)
             if (.NOT. coincident) then
                ! NOTE: This assumes that all of the status enum values are
                !       less than ``MAX_CANDIDATES + 1``.
                ! NOTE: This line is very difficult to trigger due to the
                !       ``prune_candidates()`` and coincident check
                !       mitigations. As a result, there is no unit test
                !       to trigger this line (no case has been discovered
                !       yet).
                status = num_candidates
             end if
             ! Return either way since pruning didn't "fix" anything.
             return
          end if
       end if

       ! If none of the candidate pairs have been accepted, then there are
       ! no more intersections to find.
       if (num_candidates == 0) then
          return
       end if
    end do

    ! If we've reached this point, then the curve intersection failed to
    ! converge to "approximately linear" subdivided curves after
    ! ``MAX_INTERSECT_SUBDIVISIONS``.
    status = Status_NO_CONVERGE

  end subroutine all_intersections

  subroutine all_intersections_abi( &
       num_nodes_first, nodes_first, num_nodes_second, nodes_second, &
       intersections_size, intersections, num_intersections, &
       coincident, status) &
       bind(c, name='BEZ_curve_intersections')

    ! NOTE: The number of intersections cannot be known beforehand (though it
    !       will be **at most** the product of the degrees of the two curves,
    !       by Bezout's theorem). If ``intersections`` is not large enough
    !       (i.e. if ``intersections_size`` < num_intersections``), then
    !       ``intersections`` will not be populated and the ``status`` will be
    !       set to ``Status_INSUFFICIENT_SPACE``. However, the value of
    !       ``num_intersections`` will be accurate and ``intersections``
    !       should be re-sized by the caller to accommodate.

    ! Possible error states:
    ! * Status_SUCCESS           : On success.
    ! * Status_INSUFFICIENT_SPACE: If ``intersections_size`` is smaller than
    !                              the number of intersections.
    ! * Status_NO_CONVERGE       : Via ``all_intersections()``.
    ! * (N >= MAX_CANDIDATES)    : Via ``all_intersections()``.
    ! * Status_BAD_MULTIPLICITY  : Via ``all_intersections()``.

    integer(c_int), intent(in) :: num_nodes_first
    real(c_double), intent(in) :: nodes_first(2, num_nodes_first)
    integer(c_int), intent(in) :: num_nodes_second
    real(c_double), intent(in) :: nodes_second(2, num_nodes_second)
    integer(c_int), intent(in) :: intersections_size
    real(c_double), intent(out) :: intersections(2, intersections_size)
    integer(c_int), intent(out) :: num_intersections
    logical(c_bool), intent(out) :: coincident
    integer(c_int), intent(out) :: status

    call all_intersections( &
         num_nodes_first, nodes_first, num_nodes_second, nodes_second, &
         INTERSECTIONS_WORKSPACE, num_intersections, coincident, status)

    if (status /= Status_SUCCESS) then
       return
    end if

    if (num_intersections > intersections_size) then
       status = Status_INSUFFICIENT_SPACE
    else if (num_intersections > 0) then
       ! NOTE: This assumes, but doesn't check that
       !       ``INTERSECTIONS_WORKSPACE`` has been allocated
       !       and that is has 2 rows, just like ``intersections``.
       intersections(:, :num_intersections) = ( &
            INTERSECTIONS_WORKSPACE(:, :num_intersections))
    end if

  end subroutine all_intersections_abi

  subroutine free_curve_intersections_workspace() &
       bind(c, name='BEZ_free_curve_intersections_workspace')

    ! NOTE: This **should** be run during clean-up for any code which
    !       invokes ``all_intersections()``.

    if (allocated(CANDIDATES_ODD)) then
       deallocate(CANDIDATES_ODD)
    end if

    if (allocated(CANDIDATES_EVEN)) then
       deallocate(CANDIDATES_EVEN)
    end if

    if (allocated(INTERSECTIONS_WORKSPACE)) then
       deallocate(INTERSECTIONS_WORKSPACE)
    end if

    if (allocated(POLYGON1)) then
       deallocate(POLYGON1)
    end if

    if (allocated(POLYGON2)) then
       deallocate(POLYGON2)
    end if

  end subroutine free_curve_intersections_workspace

end module curve_intersection

! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     https://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

module surface

  use, intrinsic :: iso_c_binding, only: c_double, c_int, c_bool
  use types, only: dp
  use curve, only: evaluate_curve_barycentric
  implicit none
  private specialize_workspace_sizes, specialize_surface_one_round
  public &
       de_casteljau_one_round, evaluate_barycentric, &
       evaluate_barycentric_multi, evaluate_cartesian_multi, jacobian_both, &
       jacobian_det, specialize_surface, subdivide_nodes, compute_edge_nodes

contains

  subroutine de_casteljau_one_round( &
       num_nodes, dimension_, nodes, degree, &
       lambda1, lambda2, lambda3, new_nodes) &
       bind(c, name='de_casteljau_one_round')

    ! NOTE: This is de Casteljau on a Bezier surface / triangle.

    integer(c_int), intent(in) :: num_nodes, dimension_
    real(c_double), intent(in) :: nodes(num_nodes, dimension_)
    integer(c_int), intent(in) :: degree
    real(c_double), intent(in) :: lambda1
    real(c_double), intent(in) :: lambda2
    real(c_double), intent(in) :: lambda3
    real(c_double), intent(out) :: &
         new_nodes(num_nodes - degree - 1, dimension_)
    ! Variables outside of signature.
    integer(c_int) :: index_
    integer(c_int) :: parent_i1, parent_i2, parent_i3
    integer(c_int) :: k, j

    index_ = 1
    parent_i1 = 1
    parent_i2 = 2
    parent_i3 = degree + 2
    ! NOTE: Throughout for index_ <--> (i, j, k) in the (degree - 1)
    !       triangle, we have parent_i1 = index_ + k <--> (i + 1, j, k),
    !       parent_i2 = index_ + k + 1 <--> (i, j + 1, k) and
    !       parent_i3 = index_ + degree + 1 <--> (i, j, k + 1).
    do k = 0, degree - 1
       do j = 0, degree - k - 1
          ! NOTE: i = (degree - 1) - j - k
          new_nodes(index_, :) = ( &
               lambda1 * nodes(parent_i1, :) + &
               lambda2 * nodes(parent_i2, :) + &
               lambda3 * nodes(parent_i3, :))
          ! Update all the indices.
          parent_i1 = parent_i1 + 1
          parent_i2 = parent_i2 + 1
          parent_i3 = parent_i3 + 1
          index_ = index_ + 1
       end do
       ! Update the indices that depend on k.
       parent_i1 = parent_i1 + 1
       parent_i2 = parent_i2 + 1
    end do

  end subroutine de_casteljau_one_round

  subroutine evaluate_barycentric( &
       num_nodes, dimension_, nodes, degree, &
       lambda1, lambda2, lambda3, point) &
       bind(c, name='evaluate_barycentric')

    ! NOTE: This evaluation is on a Bezier surface / triangle.
    ! NOTE: This assumes degree >= 1.

    integer(c_int), intent(in) :: num_nodes, dimension_
    real(c_double), intent(in) :: nodes(num_nodes, dimension_)
    integer(c_int), intent(in) :: degree
    real(c_double), intent(in) :: lambda1
    real(c_double), intent(in) :: lambda2
    real(c_double), intent(in) :: lambda3
    real(c_double), intent(out) :: point(1, dimension_)
    ! Variables outside of signature.
    real(c_double) :: param_vals(1, 3)

    param_vals(1, 1) = lambda1
    param_vals(1, 2) = lambda2
    param_vals(1, 3) = lambda3
    call evaluate_barycentric_multi( &
         num_nodes, dimension_, nodes, degree, 1, param_vals, point)

  end subroutine evaluate_barycentric

  subroutine evaluate_barycentric_multi( &
       num_nodes, dimension_, nodes, degree, num_vals, param_vals, evaluated) &
       bind(c, name='evaluate_barycentric_multi')

    ! NOTE: This evaluation is on a Bezier surface / triangle.
    ! NOTE: This assumes degree >= 1.

    integer(c_int), intent(in) :: num_nodes, dimension_
    real(c_double), intent(in) :: nodes(num_nodes, dimension_)
    integer(c_int), intent(in) :: degree, num_vals
    real(c_double), intent(in) :: param_vals(num_vals, 3)
    real(c_double), intent(out) :: evaluated(num_vals, dimension_)
    ! Variables outside of signature.
    integer(c_int) :: k, binom_val, index_, new_index
    real(c_double) :: row_result(num_vals, dimension_)

    index_ = num_nodes
    forall (new_index = 1:num_vals)  ! Borrow new_index for this loop.
       evaluated(new_index, :) = nodes(index_, :)
    end forall

    if (degree == 0) then
       return
    end if

    binom_val = 1
    do k = degree - 1, 0, -1
       ! We want to go from (d C (k + 1)) to (d C k).
       binom_val = (binom_val * (k + 1)) / (degree - k)
       index_ = index_ - 1  ! Step to last element in row.
       !     k = d - 1, d - 2, ...
       ! d - k =     1,     2, ...
       ! We know row k has (d - k + 1) elements.
       new_index = index_ - degree + k  ! First element in row.

       ! lambda1 = param_vals(:, 1)
       ! lambda2 = param_vals(:, 2)
       call evaluate_curve_barycentric( &
            degree - k + 1, dimension_, nodes(new_index:index_, :), &
            num_vals, param_vals(:, 1), param_vals(:, 2), row_result)

       ! Update index for next iteration.
       index_ = new_index

       ! lambda3 = param_vals(:, 3)
       forall (new_index = 1:num_vals)  ! Borrow new_index for this loop.
          evaluated(new_index, :) = ( &
               param_vals(new_index, 3) * evaluated(new_index, :) + &
               binom_val * row_result(new_index, :))
       end forall
    end do

  end subroutine evaluate_barycentric_multi

  subroutine evaluate_cartesian_multi( &
       num_nodes, dimension_, nodes, degree, num_vals, param_vals, evaluated) &
       bind(c, name='evaluate_cartesian_multi')

    ! NOTE: This evaluation is on a Bezier surface / triangle.
    ! NOTE: This mostly copies evaluate_barycentric_multi but does not just
    !       call it directly. This is to avoid copying param_vals.

    integer(c_int), intent(in) :: num_nodes, dimension_
    real(c_double), intent(in) :: nodes(num_nodes, dimension_)
    integer(c_int), intent(in) :: degree, num_vals
    real(c_double), intent(in) :: param_vals(num_vals, 2)
    real(c_double), intent(out) :: evaluated(num_vals, dimension_)
    ! Variables outside of signature.
    integer(c_int) :: k, binom_val, index_, new_index
    real(c_double) :: row_result(num_vals, dimension_)
    real(c_double) :: lambda1_vals(num_vals)

    index_ = num_nodes
    forall (new_index = 1:num_vals)  ! Borrow new_index for this loop.
       evaluated(new_index, :) = nodes(index_, :)
    end forall

    if (degree == 0) then
       return
    end if

    lambda1_vals = 1.0_dp - param_vals(:, 1) - param_vals(:, 2)

    binom_val = 1
    do k = degree - 1, 0, -1
       ! We want to go from (d C (k + 1)) to (d C k).
       binom_val = (binom_val * (k + 1)) / (degree - k)
       index_ = index_ - 1  ! Step to last element in row.
       !     k = d - 1, d - 2, ...
       ! d - k =     1,     2, ...
       ! We know row k has (d - k + 1) elements.
       new_index = index_ - degree + k  ! First element in row.

       ! lambda1 = param_vals(:, 1)
       ! lambda2 = param_vals(:, 1)
       call evaluate_curve_barycentric( &
            degree - k + 1, dimension_, nodes(new_index:index_, :), &
            num_vals, lambda1_vals, param_vals(:, 1), row_result)

       ! Update index for next iteration.
       index_ = new_index

       ! lambda3 = param_vals(:, 2)
       forall (new_index = 1:num_vals)  ! Borrow new_index for this loop.
          evaluated(new_index, :) = ( &
               param_vals(new_index, 2) * evaluated(new_index, :) + &
               binom_val * row_result(new_index, :))
       end forall
    end do

  end subroutine evaluate_cartesian_multi

  subroutine jacobian_both( &
       num_nodes, dimension_, nodes, degree, new_nodes) &
       bind(c, name='jacobian_both')

    integer(c_int), intent(in) :: num_nodes, dimension_
    real(c_double), intent(in) :: nodes(num_nodes, dimension_)
    integer(c_int), intent(in) :: degree
    real(c_double), intent(out) :: &
         new_nodes(num_nodes - degree - 1, 2 * dimension_)
    ! Variables outside of signature.
    integer(c_int) :: index_, i, j, k, num_vals

    index_ = 1
    i = 1
    j = degree + 2
    do num_vals = degree, 1, -1
       do k = 0, num_vals - 1
          ! jacobian_s
          new_nodes(index_, :dimension_) = nodes(i + 1, :) - nodes(i, :)
          ! jacobian_t
          new_nodes(index_, dimension_ + 1:) = nodes(j, :) - nodes(i, :)
          ! Update the indices
          index_ = index_ + 1
          i = i + 1
          j = j + 1
       end do
       ! In between each row, the index_ gains an extra value.
       i = i + 1
    end do

    new_nodes = degree * new_nodes

  end subroutine jacobian_both

  subroutine jacobian_det( &
       num_nodes, nodes, degree, num_vals, param_vals, evaluated) &
       bind(c, name='jacobian_det')

    integer(c_int), intent(in) :: num_nodes
    real(c_double), intent(in) :: nodes(num_nodes, 2)
    integer(c_int), intent(in) :: degree, num_vals
    real(c_double), intent(in) :: param_vals(num_vals, 2)
    real(c_double), intent(out) :: evaluated(num_vals)
    ! Variables outside of signature.
    real(c_double) :: jac_nodes(num_nodes - degree - 1, 4)
    real(c_double) :: Bs_Bt_vals(num_vals, 4)
    real(c_double) :: determinant

    call jacobian_both( &
         num_nodes, 2, nodes, degree, jac_nodes)
    if (degree == 1) then
       determinant = ( &
            jac_nodes(1, 1) * jac_nodes(1, 4) - &
            jac_nodes(1, 2) * jac_nodes(1, 3))
       evaluated = determinant
    else
       call evaluate_cartesian_multi( &
            num_nodes - degree - 1, 4, jac_nodes, degree - 1, &
            num_vals, param_vals, Bs_Bt_vals)
       evaluated = ( &
            Bs_Bt_vals(:, 1) * Bs_Bt_vals(:, 4) - &
            Bs_Bt_vals(:, 2) * Bs_Bt_vals(:, 3))
    end if

  end subroutine jacobian_det

  subroutine specialize_workspace_sizes(degree, size_odd, size_even)
    integer(c_int), intent(in) :: degree
    integer(c_int), intent(out) :: size_odd, size_even

    ! NOTE: This is a helper for ``specialize_surface``.
    if (mod(degree, 2) == 1) then
       size_odd = ((degree + 1) * (degree + 3)**2 * (degree + 5)) / 64
       size_even = size_odd
    else if (mod(degree, 4) == 0) then
       size_odd = (degree * (degree + 2) * (degree + 4) * (degree + 6)) / 64
       size_even = (((degree + 2) * (degree + 4)) / 8)**2
    else
       size_odd = (((degree + 2) * (degree + 4)) / 8)**2
       size_even = (degree * (degree + 2) * (degree + 4) * (degree + 6)) / 64
    end if

  end subroutine specialize_workspace_sizes

  subroutine specialize_surface_one_round( &
       dimension_, num_read, read_nodes, num_write, write_nodes, &
       size_read, size_write, step, local_degree, &
       weights_a, weights_b, weights_c)

    ! INVARIANT: `step + local_degree == (total) degree + 1`
    ! INVARIANT: `size_write == size_read - local_degree - 1`

    integer(c_int), intent(in) :: dimension_
    integer(c_int), intent(in) :: num_read
    real(c_double), intent(in) :: read_nodes(num_read, dimension_)
    integer(c_int), intent(in) :: num_write
    real(c_double), intent(inout) :: write_nodes(num_write, dimension_)
    integer(c_int), intent(in) :: size_read, size_write
    integer(c_int), intent(in) :: step, local_degree
    real(c_double), intent(in) :: weights_a(3), weights_b(3), weights_c(3)
    ! Variables outside of signature.
    integer(c_int) :: write_index, new_write, read_index, new_read, i

    ! First: (step, 0, 0)
    call de_casteljau_one_round( &
         size_read, dimension_, read_nodes(1:size_read, :), &
         local_degree, weights_a(1), weights_a(2), weights_a(3), &
         write_nodes(1:size_write, :))

    ! Second: (i, j, 0) for j > 0, i + j = step
    write_index = size_write + 1
    read_index = 1
    do i = 1, step
       new_write = write_index + size_write - 1
       new_read = read_index + size_read - 1
       call de_casteljau_one_round( &
            size_read, dimension_, read_nodes(read_index:new_read, :), &
            local_degree, weights_b(1), weights_b(2), weights_b(3), &
            write_nodes(write_index:new_write, :))
       ! Update the indices.
       write_index = new_write + 1
       read_index = new_read + 1
    end do

    ! Third:  (i, j, k) for k > 0, i + j + k = step
    read_index = 1
    do i = 1, ((step + 1) * step) / 2
       new_write = write_index + size_write - 1
       new_read = read_index + size_read - 1
       call de_casteljau_one_round( &
            size_read, dimension_, read_nodes(read_index:new_read, :), &
            local_degree, weights_c(1), weights_c(2), weights_c(3), &
            write_nodes(write_index:new_write, :))
       ! Update the indices.
       write_index = new_write + 1
       read_index = new_read + 1
    end do

  end subroutine specialize_surface_one_round

  subroutine specialize_surface( &
       num_nodes, dimension_, nodes, degree, &
       weights_a, weights_b, weights_c, specialized) &
       bind(c, name='specialize_surface')

    ! This re-parameterizes by "specializing" to a subregion of the unit
    ! triangle. This happens in waves by applying one round of de Casteljau
    ! with the given sets of barycentric weights. For example, in the degree
    ! 1 case, we transform
    !     [n0]          [dC(n0(1:3), a)]
    !     [  ] --> n1 = [dC(n0(1:3), b)]
    !     [  ]          [dC(n0(1:3), c)]
    ! where `n` on the LHS is 3xDIM and each of the transformed sets of
    ! nodes are 1xDIM (since de Casteljau drops the degree by 1). (NOTE:
    ! here I'm using `dC` as a shorthand for "de Casteljau" and `a` as a
    ! shorthand `weights_a`.) In the degree 2 case:
    !     [n0]          [dC(n0(1:6), a)]          [dC(n1(1:3), a)]
    !     [  ]          [              ]          [dC(n1(1:3), b)]
    !     [  ]          [              ] --> n2 = [dC(n1(4:6), b)]
    !     [  ] --> n1 = [dC(n0(1:6), b)]          [dC(n1(1:3), c)]
    !     [  ]          [              ]          [dC(n1(4:6), c)]
    !     [  ]          [              ]          [dC(n1(7:9), c)]
    !                   [dC(n0(1:6), c)]
    !                   [              ]
    !                   [              ]
    ! In the degree 3 case:
    !     [n0]          [dC(n0(1:10), a)]          [dC(n1( 1:6 ), a)]
    !     [  ]          [               ]          [                ]
    !     [  ]          [               ]          [                ]
    !     [  ]          [               ]          [dC(n1( 1:6 ), b)]
    !     [  ]          [               ]          [                ]
    !     [  ] --> n1 = [               ]          [                ]
    !     [  ]          [dC(n0(1:10), b)]          [dC(n1( 7:12), b)]
    !     [  ]          [               ]          [                ]
    !     [  ]          [               ]          [                ]
    !     [  ]          [               ] --> n2 = [dC(n1( 1:6 ), c)]
    !                   [               ]          [                ]
    !                   [               ]          [                ]
    !                   [dC(n0(1:10), c)]          [dC(n1( 7:12), c)]
    !                   [               ]          [                ]
    !                   [               ]          [                ]
    !                   [               ]          [dC(n1(13:18), c)]
    !                   [               ]          [                ]
    !                   [               ]          [                ]
    ! ... CONTINUING TO DEGREE 3 ...
    !                 [dC(n2( 1:3 ), a)]
    !                 [dC(n2( 1:3 ), b)]
    !                 [dC(n2( 4:6 ), b)]
    !                 [dC(n2( 7:9 ), b)]
    !                 [dC(n2( 1:3 ), c)]
    !     n2 --> n3 = [dC(n2( 4:6 ), c)]
    !                 [dC(n2( 7:9 ), c)]
    !                 [dC(n2(10:12), c)]
    !                 [dC(n2(13:15), c)]
    !                 [dC(n2(16:18), c)]
    ! For **all** cases, we are tracking applications of weights at
    ! each step:
    !     STEP 1: {a}, {b}, {c}
    !     STEP 2: {aa}, {ab}, {bb}, {ac}, {bc}, {cc}
    !     STEP 3: {aaa}, {aab}, {abb}, {bbb}, {aac}, ...
    ! and each of these quantities can be computed using the ones computed
    ! at the previous step. So in STEP 2, we compute {aa} by applying
    ! the `a` weights to {a}, we compute {ab} and {bb} by applying the
    ! `b` weights to {a} and {b} and we compute {ac}, {bc}, {cc} by
    ! applying the `c` weights to the whole set.
    !
    ! For a "general" step, we can treat the triple (#a, #b, #c) just like
    ! we treat an index triple (i, j, k), which we know has linear index
    ! (1-based) `1 + j + (k/2) (2(i + j) + k + 3)`. This is very useful because
    ! we can find the **previous** quantity by using this index. For example,
    ! to compute {aabccc} by applying `c` to {aabcc}, we know the index
    ! of the {aabcc} is 13 and the index of {aabccc} is 20. In fact, one can
    ! show that when dropping from (i, j, k) to (i, j, k - 1) the index will
    ! always drop by `(i + j + k) + 1 = step + 1`. Unfortunately, some values
    ! have no `c` weights at all, i.e. `k = 0`. For these special cases we
    ! also use the formula to show `(step, 0, 0) --> (step - 1, 0, 0)` has
    ! no change in index (both are the first index). From `(i, j, 0)` to
    ! `(i, j - 1, 0)` drops the index by `1`.
    integer(c_int), intent(in) :: num_nodes, dimension_
    real(c_double), intent(in) :: nodes(num_nodes, dimension_)
    integer(c_int), intent(in) :: degree
    real(c_double), intent(in) :: weights_a(3), weights_b(3), weights_c(3)
    real(c_double), intent(out) :: specialized(num_nodes, dimension_)
    ! Variables outside of signature.
    integer(c_int) :: num_curves, size, size_odd, size_even
    real(c_double), allocatable :: workspace_odd(:, :), workspace_even(:, :)
    integer(c_int) :: delta_nc, delta_size, size_new, step
    logical(c_bool) :: is_even

    num_curves = 1
    size = ((degree + 1) * (degree + 2)) / 2
    call specialize_workspace_sizes(degree, size_odd, size_even)
    allocate(workspace_odd(size_odd, dimension_))
    allocate(workspace_even(size_even, dimension_))

    ! `num_curves` and `delta_size` are triangular numbers going in
    ! the opposite direction. `num_curves` will go from 1, 3, 6, 10, ...
    ! and `delta_size` will go (d + 2 C 2), (d + 1 C 2), ...
    ! Since the delta between consecutive terms grows linearly, we track
    ! them as well to avoid multiplications.
    delta_nc = 2
    delta_size = -degree - 1
    is_even = .FALSE.  ! At `step == 1`.

    do step = 1, degree
       num_curves = num_curves + delta_nc
       size_new = size + delta_size
       if (step == 1) then
          ! Read from `nodes`, write to `workspace_odd`.
          call specialize_surface_one_round( &
               dimension_, num_nodes, nodes, size_odd, workspace_odd, &
               size, size_new, step, degree + 1 - step, &
               weights_a, weights_b, weights_c)
       else if (is_even) then
          ! Read from `workspace_odd`, write to `workspace_even`.
          call specialize_surface_one_round( &
               dimension_, size_odd, workspace_odd, &
               size_even, workspace_even, &
               size, size_new, step, degree + 1 - step, &
               weights_a, weights_b, weights_c)
       else
          ! Read from `workspace_even`, write to `workspace_odd`.
          call specialize_surface_one_round( &
               dimension_, size_even, workspace_even, &
               size_odd, workspace_odd, &
               size, size_new, step, degree + 1 - step, &
               weights_a, weights_b, weights_c)
       end if

       ! Update our index values.
       size = size_new
       delta_nc = delta_nc + 1
       delta_size = delta_size + 1
       is_even = .NOT. is_even  ! Switch parity.
    end do

    ! Read from the last workspace that was written to.
    if (is_even) then
       specialized = workspace_odd(1:num_nodes, :)
    else
       specialized = workspace_even(1:num_nodes, :)
    end if

  end subroutine specialize_surface

  subroutine subdivide_nodes( &
       num_nodes, dimension_, nodes, degree, &
       nodes_a, nodes_b, nodes_c, nodes_d) &
       bind(c, name='subdivide_nodes_surface')

    integer(c_int), intent(in) :: num_nodes, dimension_
    real(c_double), intent(in) :: nodes(num_nodes, dimension_)
    integer(c_int), intent(in) :: degree
    real(c_double), intent(out) :: nodes_a(num_nodes, dimension_)
    real(c_double), intent(out) :: nodes_b(num_nodes, dimension_)
    real(c_double), intent(out) :: nodes_c(num_nodes, dimension_)
    real(c_double), intent(out) :: nodes_d(num_nodes, dimension_)

    if (degree == 1) then
       nodes_a(1, :) = nodes(1, :)
       nodes_a(2, :) = 0.5_dp * (nodes(1, :) + nodes(2, :))
       nodes_a(3, :) = 0.5_dp * (nodes(1, :) + nodes(3, :))
       nodes_b(1, :) = 0.5_dp * (nodes(2, :) + nodes(3, :))
       nodes_b(2, :) = nodes_a(3, :)
       nodes_b(3, :) = nodes_a(2, :)
       nodes_c(1, :) = nodes_a(2, :)
       nodes_c(2, :) = nodes(2, :)
       nodes_c(3, :) = nodes_b(1, :)
       nodes_d(1, :) = nodes_a(3, :)
       nodes_d(2, :) = nodes_b(1, :)
       nodes_d(3, :) = nodes(3, :)
    else if (degree == 2) then
       nodes_a(1, :) = nodes(1, :)
       nodes_a(2, :) = 0.5_dp * (nodes(1, :) + nodes(2, :))
       nodes_a(3, :) = 0.25_dp * (nodes(1, :) + 2 * nodes(2, :) + nodes(3, :))
       nodes_a(4, :) = 0.5_dp * (nodes(1, :) + nodes(4, :))
       nodes_a(5, :) = 0.25_dp * ( &
            nodes(1, :) + nodes(2, :) + nodes(4, :) + nodes(5, :))
       nodes_a(6, :) = 0.25_dp * (nodes(1, :) + 2 * nodes(4, :) + nodes(6, :))
       nodes_b(1, :) = 0.25_dp * (nodes(3, :) + 2 * nodes(5, :) + nodes(6, :))
       nodes_b(2, :) = 0.25_dp * ( &
            nodes(2, :) + nodes(4, :) + nodes(5, :) + nodes(6, :))
       nodes_b(3, :) = nodes_a(6, :)
       nodes_b(4, :) = 0.25_dp * ( &
            nodes(2, :) + nodes(3, :) + nodes(4, :) + nodes(5, :))
       nodes_b(5, :) = nodes_a(5, :)
       nodes_b(6, :) = nodes_a(3, :)
       nodes_c(1, :) = nodes_a(3, :)
       nodes_c(2, :) = 0.5_dp * (nodes(2, :) + nodes(3, :))
       nodes_c(3, :) = nodes(3, :)
       nodes_c(4, :) = nodes_b(4, :)
       nodes_c(5, :) = 0.5_dp * (nodes(3, :) + nodes(5, :))
       nodes_c(6, :) = nodes_b(1, :)
       nodes_d(1, :) = nodes_a(6, :)
       nodes_d(2, :) = nodes_b(2, :)
       nodes_d(3, :) = nodes_b(1, :)
       nodes_d(4, :) = 0.5_dp * (nodes(4, :) + nodes(6, :))
       nodes_d(5, :) = 0.5_dp * (nodes(5, :) + nodes(6, :))
       nodes_d(6, :) = nodes(6, :)
    else if (degree == 3) then
       nodes_a(1, :) = nodes(1, :)
       nodes_a(2, :) = 0.5_dp * (nodes(1, :) + nodes(2, :))
       nodes_a(3, :) = 0.25_dp * (nodes(1, :) + 2 * nodes(2, :) + nodes(3, :))
       nodes_a(4, :) = 0.125_dp * ( &
            nodes(1, :) + 3 * nodes(2, :) + 3 * nodes(3, :) + nodes(4, :))
       nodes_a(5, :) = 0.5_dp * (nodes(1, :) + nodes(5, :))
       nodes_a(6, :) = 0.25_dp * ( &
            nodes(1, :) + nodes(2, :) + nodes(5, :) + nodes(6, :))
       nodes_a(7, :) = 0.125_dp * ( &
            nodes(1, :) + 2 * nodes(2, :) + nodes(3, :) + nodes(5, :) + &
            2 * nodes(6, :) + nodes(7, :))
       nodes_a(8, :) = 0.25_dp * (nodes(1, :) + 2 * nodes(5, :) + nodes(8, :))
       nodes_a(9, :) = 0.125_dp * ( &
            nodes(1, :) + nodes(2, :) + 2 * nodes(5, :) + 2 * nodes(6, :) + &
            nodes(8, :) + nodes(9, :))
       nodes_a(10, :) = 0.125_dp * ( &
            nodes(1, :) + 3 * nodes(5, :) + 3 * nodes(8, :) + nodes(10, :))
       nodes_b(1, :) = 0.125_dp * ( &
            nodes(4, :) + 3 * nodes(7, :) + 3 * nodes(9, :) + nodes(10, :))
       nodes_b(2, :) = 0.125_dp * ( &
            nodes(3, :) + 2 * nodes(6, :) + nodes(7, :) + nodes(8, :) + &
            2 * nodes(9, :) + nodes(10, :))
       nodes_b(3, :) = 0.125_dp * ( &
            nodes(2, :) + nodes(5, :) + 2 * nodes(6, :) + 2 * nodes(8, :) + &
            nodes(9, :) + nodes(10, :))
       nodes_b(4, :) = nodes_a(10, :)
       nodes_b(5, :) = 0.125_dp * ( &
            nodes(3, :) + nodes(4, :) + 2 * nodes(6, :) + 2 * nodes(7, :) + &
            nodes(8, :) + nodes(9, :))
       nodes_b(6, :) = 0.125_dp * ( &
            nodes(2, :) + nodes(3, :) + nodes(5, :) + 2 * nodes(6, :) + &
            nodes(7, :) + nodes(8, :) + nodes(9, :))
       nodes_b(7, :) = nodes_a(9, :)
       nodes_b(8, :) = 0.125_dp * ( &
            nodes(2, :) + 2 * nodes(3, :) + nodes(4, :) + nodes(5, :) + &
            2 * nodes(6, :) + nodes(7, :))
       nodes_b(9, :) = nodes_a(7, :)
       nodes_b(10, :) = nodes_a(4, :)
       nodes_c(1, :) = nodes_a(4, :)
       nodes_c(2, :) = 0.25_dp * (nodes(2, :) + 2 * nodes(3, :) + nodes(4, :))
       nodes_c(3, :) = 0.5_dp * (nodes(3, :) + nodes(4, :))
       nodes_c(4, :) = nodes(4, :)
       nodes_c(5, :) = nodes_b(8, :)
       nodes_c(6, :) = 0.25_dp * ( &
            nodes(3, :) + nodes(4, :) + nodes(6, :) + nodes(7, :))
       nodes_c(7, :) = 0.5_dp * (nodes(4, :) + nodes(7, :))
       nodes_c(8, :) = nodes_b(5, :)
       nodes_c(9, :) = 0.25_dp * (nodes(4, :) + 2 * nodes(7, :) + nodes(9, :))
       nodes_c(10, :) = nodes_b(1, :)
       nodes_d(1, :) = nodes_a(10, :)
       nodes_d(2, :) = nodes_b(3, :)
       nodes_d(3, :) = nodes_b(2, :)
       nodes_d(4, :) = nodes_b(1, :)
       nodes_d(5, :) = 0.25_dp * (nodes(5, :) + 2 * nodes(8, :) + nodes(10, :))
       nodes_d(6, :) = 0.25_dp * ( &
            nodes(6, :) + nodes(8, :) + nodes(9, :) + nodes(10, :))
       nodes_d(7, :) = 0.25_dp * (nodes(7, :) + 2 * nodes(9, :) + nodes(10, :))
       nodes_d(8, :) = 0.5_dp * (nodes(8, :) + nodes(10, :))
       nodes_d(9, :) = 0.5_dp * (nodes(9, :) + nodes(10, :))
       nodes_d(10, :) = nodes(10, :)
    else if (degree == 4) then
       nodes_a(1, :) = nodes(1, :)
       nodes_a(2, :) = 0.5_dp * (nodes(1, :) + nodes(2, :))
       nodes_a(3, :) = 0.25_dp * (nodes(1, :) + 2 * nodes(2, :) + nodes(3, :))
       nodes_a(4, :) = 0.125_dp * ( &
            nodes(1, :) + 3 * nodes(2, :) + 3 * nodes(3, :) + nodes(4, :))
       nodes_a(5, :) = 0.0625_dp * ( &
            nodes(1, :) + 4 * nodes(2, :) + 6 * nodes(3, :) + &
            4 * nodes(4, :) + nodes(5, :))
       nodes_a(6, :) = 0.5_dp * (nodes(1, :) + nodes(6, :))
       nodes_a(7, :) = 0.25_dp * ( &
            nodes(1, :) + nodes(2, :) + nodes(6, :) + nodes(7, :))
       nodes_a(8, :) = 0.125_dp * ( &
            nodes(1, :) + 2 * nodes(2, :) + nodes(3, :) + nodes(6, :) + &
            2 * nodes(7, :) + nodes(8, :))
       nodes_a(9, :) = 0.0625_dp * ( &
            nodes(1, :) + 3 * nodes(2, :) + 3 * nodes(3, :) + nodes(4, :) + &
            nodes(6, :) + 3 * nodes(7, :) + 3 * nodes(8, :) + nodes(9, :))
       nodes_a(10, :) = 0.25_dp * ( &
            nodes(1, :) + 2 * nodes(6, :) + nodes(10, :))
       nodes_a(11, :) = 0.125_dp * ( &
            nodes(1, :) + nodes(2, :) + 2 * nodes(6, :) + 2 * nodes(7, :) + &
            nodes(10, :) + nodes(11, :))
       nodes_a(12, :) = 0.0625_dp * ( &
            nodes(1, :) + 2 * nodes(2, :) + nodes(3, :) + 2 * nodes(6, :) + &
            4 * nodes(7, :) + 2 * nodes(8, :) + nodes(10, :) + &
            2 * nodes(11, :) + nodes(12, :))
       nodes_a(13, :) = 0.125_dp * ( &
            nodes(1, :) + 3 * nodes(6, :) + 3 * nodes(10, :) + nodes(13, :))
       nodes_a(14, :) = 0.0625_dp * ( &
            nodes(1, :) + nodes(2, :) + 3 * nodes(6, :) + 3 * nodes(7, :) + &
            3 * nodes(10, :) + 3 * nodes(11, :) + nodes(13, :) + nodes(14, :))
       nodes_a(15, :) = 0.0625_dp * ( &
            nodes(1, :) + 4 * nodes(6, :) + 6 * nodes(10, :) + &
            4 * nodes(13, :) + nodes(15, :))
       nodes_b(1, :) = 0.0625_dp * ( &
            nodes(5, :) + 4 * nodes(9, :) + 6 * nodes(12, :) + &
            4 * nodes(14, :) + nodes(15, :))
       nodes_b(2, :) = 0.0625_dp * ( &
            nodes(4, :) + 3 * nodes(8, :) + nodes(9, :) + 3 * nodes(11, :) + &
            3 * nodes(12, :) + nodes(13, :) + 3 * nodes(14, :) + nodes(15, :))
       nodes_b(3, :) = 0.0625_dp * ( &
            nodes(3, :) + 2 * nodes(7, :) + 2 * nodes(8, :) + nodes(10, :) + &
            4 * nodes(11, :) + nodes(12, :) + 2 * nodes(13, :) + &
            2 * nodes(14, :) + nodes(15, :))
       nodes_b(4, :) = 0.0625_dp * ( &
            nodes(2, :) + nodes(6, :) + 3 * nodes(7, :) + 3 * nodes(10, :) + &
            3 * nodes(11, :) + 3 * nodes(13, :) + nodes(14, :) + nodes(15, :))
       nodes_b(5, :) = nodes_a(15, :)
       nodes_b(6, :) = 0.0625_dp * ( &
            nodes(4, :) + nodes(5, :) + 3 * nodes(8, :) + 3 * nodes(9, :) + &
            3 * nodes(11, :) + 3 * nodes(12, :) + nodes(13, :) + nodes(14, :))
       nodes_b(7, :) = 0.0625_dp * ( &
            nodes(3, :) + nodes(4, :) + 2 * nodes(7, :) + 3 * nodes(8, :) + &
            nodes(9, :) + nodes(10, :) + 3 * nodes(11, :) + &
            2 * nodes(12, :) + nodes(13, :) + nodes(14, :))
       nodes_b(8, :) = 0.0625_dp * ( &
            nodes(2, :) + nodes(3, :) + nodes(6, :) + 3 * nodes(7, :) + &
            2 * nodes(8, :) + 2 * nodes(10, :) + 3 * nodes(11, :) + &
            nodes(12, :) + nodes(13, :) + nodes(14, :))
       nodes_b(9, :) = nodes_a(14, :)
       nodes_b(10, :) = 0.0625_dp * ( &
            nodes(3, :) + 2 * nodes(4, :) + nodes(5, :) + 2 * nodes(7, :) + &
            4 * nodes(8, :) + 2 * nodes(9, :) + nodes(10, :) + &
            2 * nodes(11, :) + nodes(12, :))
       nodes_b(11, :) = 0.0625_dp * ( &
            nodes(2, :) + 2 * nodes(3, :) + nodes(4, :) + nodes(6, :) + &
            3 * nodes(7, :) + 3 * nodes(8, :) + nodes(9, :) + nodes(10, :) + &
            2 * nodes(11, :) + nodes(12, :))
       nodes_b(12, :) = nodes_a(12, :)
       nodes_b(13, :) = 0.0625_dp * ( &
            nodes(2, :) + 3 * nodes(3, :) + 3 * nodes(4, :) + nodes(5, :) + &
            nodes(6, :) + 3 * nodes(7, :) + 3 * nodes(8, :) + nodes(9, :))
       nodes_b(14, :) = nodes_a(9, :)
       nodes_b(15, :) = nodes_a(5, :)
       nodes_c(1, :) = nodes_a(5, :)
       nodes_c(2, :) = 0.125_dp * ( &
            nodes(2, :) + 3 * nodes(3, :) + 3 * nodes(4, :) + nodes(5, :))
       nodes_c(3, :) = 0.25_dp * ( &
            nodes(3, :) + 2 * nodes(4, :) + nodes(5, :))
       nodes_c(4, :) = 0.5_dp * ( &
            nodes(4, :) + nodes(5, :))
       nodes_c(5, :) = nodes(5, :)
       nodes_c(6, :) = nodes_b(13, :)
       nodes_c(7, :) = 0.125_dp * ( &
            nodes(3, :) + 2 * nodes(4, :) + nodes(5, :) + nodes(7, :) + &
            2 * nodes(8, :) + nodes(9, :))
       nodes_c(8, :) = 0.25_dp * ( &
            nodes(4, :) + nodes(5, :) + nodes(8, :) + nodes(9, :))
       nodes_c(9, :) = 0.5_dp * (nodes(5, :) + nodes(9, :))
       nodes_c(10, :) = nodes_b(10, :)
       nodes_c(11, :) = 0.125_dp * ( &
            nodes(4, :) + nodes(5, :) + 2 * nodes(8, :) + 2 * nodes(9, :) + &
            nodes(11, :) + nodes(12, :))
       nodes_c(12, :) = 0.25_dp * ( &
            nodes(5, :) + 2 * nodes(9, :) + nodes(12, :))
       nodes_c(13, :) = nodes_b(6, :)
       nodes_c(14, :) = 0.125_dp * ( &
            nodes(5, :) + 3 * nodes(9, :) + 3 * nodes(12, :) + nodes(14, :))
       nodes_c(15, :) = nodes_b(1, :)
       nodes_d(1, :) = nodes_a(15, :)
       nodes_d(2, :) = nodes_b(4, :)
       nodes_d(3, :) = nodes_b(3, :)
       nodes_d(4, :) = nodes_b(2, :)
       nodes_d(5, :) = nodes_b(1, :)
       nodes_d(6, :) = 0.125_dp * ( &
            nodes(6, :) + 3 * nodes(10, :) + 3 * nodes(13, :) + nodes(15, :))
       nodes_d(7, :) = 0.125_dp * ( &
            nodes(7, :) + nodes(10, :) + 2 * nodes(11, :) + &
            2 * nodes(13, :) + nodes(14, :) + nodes(15, :))
       nodes_d(8, :) = 0.125_dp * ( &
            nodes(8, :) + 2 * nodes(11, :) + nodes(12, :) + nodes(13, :) + &
            2 * nodes(14, :) + nodes(15, :))
       nodes_d(9, :) = 0.125_dp * ( &
            nodes(9, :) + 3 * nodes(12, :) + 3 * nodes(14, :) + nodes(15, :))
       nodes_d(10, :) = 0.25_dp * ( &
            nodes(10, :) + 2 * nodes(13, :) + nodes(15, :))
       nodes_d(11, :) = 0.25_dp * ( &
            nodes(11, :) + nodes(13, :) + nodes(14, :) + nodes(15, :))
       nodes_d(12, :) = 0.25_dp * ( &
            nodes(12, :) + 2 * nodes(14, :) + nodes(15, :))
       nodes_d(13, :) = 0.5_dp * (nodes(13, :) + nodes(15, :))
       nodes_d(14, :) = 0.5_dp * (nodes(14, :) + nodes(15, :))
       nodes_d(15, :) = nodes(15, :)
    else
       call specialize_surface( &
            num_nodes, dimension_, nodes, degree, &
            [1.0_dp, 0.0_dp, 0.0_dp], &
            [0.5_dp, 0.5_dp, 0.0_dp], &
            [0.5_dp, 0.0_dp, 0.5_dp], &
            nodes_a)
       call specialize_surface( &
            num_nodes, dimension_, nodes, degree, &
            [0.0_dp, 0.5_dp, 0.5_dp], &
            [0.5_dp, 0.0_dp, 0.5_dp], &
            [0.5_dp, 0.5_dp, 0.0_dp], &
            nodes_b)
       call specialize_surface( &
            num_nodes, dimension_, nodes, degree, &
            [0.5_dp, 0.5_dp, 0.0_dp], &
            [0.0_dp, 1.0_dp, 0.0_dp], &
            [0.0_dp, 0.5_dp, 0.5_dp], &
            nodes_c)
       call specialize_surface( &
            num_nodes, dimension_, nodes, degree, &
            [0.5_dp, 0.0_dp, 0.5_dp], &
            [0.0_dp, 0.5_dp, 0.5_dp], &
            [0.0_dp, 0.0_dp, 1.0_dp], &
            nodes_d)
    end if

  end subroutine subdivide_nodes

  subroutine compute_edge_nodes( &
       num_nodes, dimension_, nodes, degree, nodes1, nodes2, nodes3) &
       bind(c, name='compute_edge_nodes')

    integer(c_int), intent(in) :: num_nodes, dimension_
    real(c_double), intent(in) :: nodes(num_nodes, dimension_)
    integer(c_int), intent(in) :: degree
    real(c_double), intent(out) :: nodes1(degree + 1, dimension_)
    real(c_double), intent(out) :: nodes2(degree + 1, dimension_)
    real(c_double), intent(out) :: nodes3(degree + 1, dimension_)
    ! Variables outside of signature.
    integer(c_int) :: index1, index2, index3

    index2 = degree + 1
    index3 = num_nodes
    do index1 = 1, degree + 1
       nodes1(index1, :) = nodes(index1, :)
       nodes2(index1, :) = nodes(index2, :)
       nodes3(index1, :) = nodes(index3, :)
       ! Update the indices.
       index2 = index2 - index1 + degree + 1
       index3 = index3 - index1 - 1
    end do

  end subroutine compute_edge_nodes

end module surface

! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     https://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

module status

  use, intrinsic :: iso_c_binding, only: c_int
  implicit none
  private
  public &
       Status_SUCCESS, Status_PARALLEL, Status_WIGGLE_FAIL, &
       Status_NO_CONVERGE, Status_INSUFFICIENT_SPACE, Status_SAME_CURVATURE, &
       Status_BAD_TANGENT, Status_EDGE_END, Status_UNKNOWN

  ! Values of Status enum:
  ! SUCCESS: Procedure exited with no error.
  integer(c_int), parameter :: Status_SUCCESS = 0
  ! PARALLEL: Corresponds to ``NotImplementedError('Line segments parallel.')``
  integer(c_int), parameter :: Status_PARALLEL = 1
  ! WIGGLE_FAIL: Indicates that ``helpers.wiggle_interval()`` failed.
  integer(c_int), parameter :: Status_WIGGLE_FAIL = 2
  ! NO_CONVERGE: An iterative algorithm has failed to converge. Used by
  !              ``curve_intersection.all_intersections()``.
  integer(c_int), parameter :: Status_NO_CONVERGE = 3
  ! INSUFFICIENT_SPACE: Intended to be used by ABI versions of procedures. Will
  !                     be used when the caller has not allocated enough space
  !                     for the output values. (On the Fortran side, an
  !                     ``allocatable`` array can be resized, but in the ABI,
  !                     we can only use what the caller has passed.)
  integer(c_int), parameter :: Status_INSUFFICIENT_SPACE = 4
  ! SAME_CURVATURE: Can't classify curve-curve intersection when the curves
  !                 have identical curvature at the point of intersection.
  integer(c_int), parameter :: Status_SAME_CURVATURE = 5
  ! BAD_TANGENT: Two curves are tangent where they intersect, but they move
  !              in an opposite direction while defining overlapping arcs.
  integer(c_int), parameter :: Status_BAD_TANGENT = 6
  ! EDGE_END: A surface-surface intersection point occurs at the **end** of
  !           an edge (only intersections at the beginning of an edge should
  !           be used).
  integer(c_int), parameter :: Status_EDGE_END = 7
  ! UNKNOWN: Signifies a block of code reached an "impossible" state. Either
  !          the code has violated some mathematical invariant or the author
  !          misunderstood the possible states of the system.
  integer(c_int), parameter :: Status_UNKNOWN = 999

end module status

! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     https://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

module triangle

  use, intrinsic :: iso_c_binding, only: &
       c_double, c_int, c_bool, c_ptr, c_f_pointer
  use types, only: dp
  use curve, only: evaluate_curve_barycentric
  implicit none
  private specialize_workspace_sizes, specialize_triangle_one_round
  public &
       de_casteljau_one_round, evaluate_barycentric, &
       evaluate_barycentric_multi, evaluate_cartesian_multi, jacobian_both, &
       jacobian_det, specialize_triangle, subdivide_nodes, compute_edge_nodes, &
       shoelace_for_area, compute_area

contains

  subroutine de_casteljau_one_round( &
       num_nodes, dimension_, nodes, degree, &
       lambda1, lambda2, lambda3, new_nodes) &
       bind(c, name='BEZ_de_casteljau_one_round')

    ! NOTE: This is de Casteljau on a Bezier triangle / triangle.

    integer(c_int), intent(in) :: num_nodes, dimension_
    real(c_double), intent(in) :: nodes(dimension_, num_nodes)
    integer(c_int), intent(in) :: degree
    real(c_double), intent(in) :: lambda1
    real(c_double), intent(in) :: lambda2
    real(c_double), intent(in) :: lambda3
    real(c_double), intent(out) :: &
         new_nodes(dimension_, num_nodes - degree - 1)
    ! Variables outside of signature.
    integer(c_int) :: index_
    integer(c_int) :: parent_i1, parent_i2, parent_i3
    integer(c_int) :: k, j

    index_ = 1
    parent_i1 = 1
    parent_i2 = 2
    parent_i3 = degree + 2
    ! NOTE: Throughout for index_ <--> (i, j, k) in the (degree - 1)
    !       triangle, we have parent_i1 = index_ + k <--> (i + 1, j, k),
    !       parent_i2 = index_ + k + 1 <--> (i, j + 1, k) and
    !       parent_i3 = index_ + degree + 1 <--> (i, j, k + 1).
    do k = 0, degree - 1
       do j = 0, degree - k - 1
          ! NOTE: i = (degree - 1) - j - k
          new_nodes(:, index_) = ( &
               lambda1 * nodes(:, parent_i1) + &
               lambda2 * nodes(:, parent_i2) + &
               lambda3 * nodes(:, parent_i3))
          ! Update all the indices.
          parent_i1 = parent_i1 + 1
          parent_i2 = parent_i2 + 1
          parent_i3 = parent_i3 + 1
          index_ = index_ + 1
       end do
       ! Update the indices that depend on k.
       parent_i1 = parent_i1 + 1
       parent_i2 = parent_i2 + 1
    end do

  end subroutine de_casteljau_one_round

  subroutine evaluate_barycentric( &
       num_nodes, dimension_, nodes, degree, &
       lambda1, lambda2, lambda3, point) &
       bind(c, name='BEZ_evaluate_barycentric')

    ! NOTE: This evaluation is on a Bezier triangle / triangle.
    ! NOTE: This assumes degree >= 1.

    integer(c_int), intent(in) :: num_nodes, dimension_
    real(c_double), intent(in) :: nodes(dimension_, num_nodes)
    integer(c_int), intent(in) :: degree
    real(c_double), intent(in) :: lambda1
    real(c_double), intent(in) :: lambda2
    real(c_double), intent(in) :: lambda3
    real(c_double), intent(out) :: point(dimension_, 1)
    ! Variables outside of signature.
    real(c_double) :: param_vals(3, 1)

    param_vals(1, 1) = lambda1
    param_vals(2, 1) = lambda2
    param_vals(3, 1) = lambda3
    call evaluate_barycentric_multi( &
         num_nodes, dimension_, nodes, degree, 1, param_vals, point)

  end subroutine evaluate_barycentric

  subroutine evaluate_barycentric_multi( &
       num_nodes, dimension_, nodes, degree, num_vals, param_vals, evaluated) &
       bind(c, name='BEZ_evaluate_barycentric_multi')

    ! NOTE: This evaluation is on a Bezier triangle / triangle.
    ! NOTE: This assumes degree >= 1.

    integer(c_int), intent(in) :: num_nodes, dimension_
    real(c_double), intent(in) :: nodes(dimension_, num_nodes)
    integer(c_int), intent(in) :: degree, num_vals
    real(c_double), intent(in) :: param_vals(num_vals, 3)
    real(c_double), intent(out) :: evaluated(dimension_, num_vals)
    ! Variables outside of signature.
    integer(c_int) :: k, binom_val, index_, new_index
    real(c_double) :: row_result(dimension_, num_vals)

    index_ = num_nodes
    forall (new_index = 1:num_vals)  ! Borrow new_index for this loop.
       evaluated(:, new_index) = nodes(:, index_)
    end forall

    if (degree == 0) then
       return
    end if

    binom_val = 1
    do k = degree - 1, 0, -1
       ! We want to go from (d C (k + 1)) to (d C k).
       binom_val = (binom_val * (k + 1)) / (degree - k)
       index_ = index_ - 1  ! Step to last element in row.
       !     k = d - 1, d - 2, ...
       ! d - k =     1,     2, ...
       ! We know row k has (d - k + 1) elements.
       new_index = index_ - degree + k  ! First element in row.

       ! lambda1 = param_vals(:, 1)
       ! lambda2 = param_vals(:, 2)
       call evaluate_curve_barycentric( &
            degree - k + 1, dimension_, nodes(:, new_index:index_), &
            num_vals, param_vals(:, 1), param_vals(:, 2), row_result)

       ! Update index for next iteration.
       index_ = new_index

       ! lambda3 = param_vals(:, 3)
       forall (new_index = 1:num_vals)  ! Borrow new_index for this loop.
          evaluated(:, new_index) = ( &
               param_vals(new_index, 3) * evaluated(:, new_index) + &
               binom_val * row_result(:, new_index))
       end forall
    end do

  end subroutine evaluate_barycentric_multi

  subroutine evaluate_cartesian_multi( &
       num_nodes, dimension_, nodes, degree, num_vals, param_vals, evaluated) &
       bind(c, name='BEZ_evaluate_cartesian_multi')

    ! NOTE: This evaluation is on a Bezier triangle / triangle.
    ! NOTE: This mostly copies evaluate_barycentric_multi but does not just
    !       call it directly. This is to avoid copying param_vals.

    integer(c_int), intent(in) :: num_nodes, dimension_
    real(c_double), intent(in) :: nodes(dimension_, num_nodes)
    integer(c_int), intent(in) :: degree, num_vals
    real(c_double), intent(in) :: param_vals(num_vals, 2)
    real(c_double), intent(out) :: evaluated(dimension_, num_vals)
    ! Variables outside of signature.
    integer(c_int) :: k, binom_val, index_, new_index
    real(c_double) :: row_result(dimension_, num_vals)
    real(c_double) :: lambda1_vals(num_vals)

    index_ = num_nodes
    forall (new_index = 1:num_vals)  ! Borrow new_index for this loop.
       evaluated(:, new_index) = nodes(:, index_)
    end forall

    if (degree == 0) then
       return
    end if

    lambda1_vals = 1.0_dp - param_vals(:, 1) - param_vals(:, 2)

    binom_val = 1
    do k = degree - 1, 0, -1
       ! We want to go from (d C (k + 1)) to (d C k).
       binom_val = (binom_val * (k + 1)) / (degree - k)
       index_ = index_ - 1  ! Step to last element in row.
       !     k = d - 1, d - 2, ...
       ! d - k =     1,     2, ...
       ! We know row k has (d - k + 1) elements.
       new_index = index_ - degree + k  ! First element in row.

       ! lambda1 = param_vals(:, 1)
       ! lambda2 = param_vals(:, 1)
       call evaluate_curve_barycentric( &
            degree - k + 1, dimension_, nodes(:, new_index:index_), &
            num_vals, lambda1_vals, param_vals(:, 1), row_result)

       ! Update index for next iteration.
       index_ = new_index

       ! lambda3 = param_vals(:, 2)
       forall (new_index = 1:num_vals)  ! Borrow new_index for this loop.
          evaluated(:, new_index) = ( &
               param_vals(new_index, 2) * evaluated(:, new_index) + &
               binom_val * row_result(:, new_index))
       end forall
    end do

  end subroutine evaluate_cartesian_multi

  subroutine jacobian_both( &
       num_nodes, dimension_, nodes, degree, new_nodes) &
       bind(c, name='BEZ_jacobian_both')

    integer(c_int), intent(in) :: num_nodes, dimension_
    real(c_double), intent(in) :: nodes(dimension_, num_nodes)
    integer(c_int), intent(in) :: degree
    real(c_double), intent(out) :: &
         new_nodes(2 * dimension_, num_nodes - degree - 1)
    ! Variables outside of signature.
    integer(c_int) :: index_, i, j, k, num_vals

    index_ = 1
    i = 1
    j = degree + 2
    do num_vals = degree, 1, -1
       do k = 0, num_vals - 1
          ! jacobian_s
          new_nodes(:dimension_, index_) = nodes(:, i + 1) - nodes(:, i)
          ! jacobian_t
          new_nodes(dimension_ + 1:, index_) = nodes(:, j) - nodes(:, i)
          ! Update the indices
          index_ = index_ + 1
          i = i + 1
          j = j + 1
       end do
       ! In between each row, the index_ gains an extra value.
       i = i + 1
    end do

    new_nodes = degree * new_nodes

  end subroutine jacobian_both

  subroutine jacobian_det( &
       num_nodes, nodes, degree, num_vals, param_vals, evaluated) &
       bind(c, name='BEZ_jacobian_det')

    integer(c_int), intent(in) :: num_nodes
    real(c_double), intent(in) :: nodes(2, num_nodes)
    integer(c_int), intent(in) :: degree, num_vals
    real(c_double), intent(in) :: param_vals(num_vals, 2)
    real(c_double), intent(out) :: evaluated(num_vals)
    ! Variables outside of signature.
    real(c_double) :: jac_nodes(4, num_nodes - degree - 1)
    real(c_double) :: Bs_Bt_vals(4, num_vals)
    real(c_double) :: determinant

    call jacobian_both( &
         num_nodes, 2, nodes, degree, jac_nodes)
    if (degree == 1) then
       determinant = ( &
            jac_nodes(1, 1) * jac_nodes(4, 1) - &
            jac_nodes(2, 1) * jac_nodes(3, 1))
       evaluated = determinant
    else
       call evaluate_cartesian_multi( &
            num_nodes - degree - 1, 4, jac_nodes, degree - 1, &
            num_vals, param_vals, Bs_Bt_vals)
       evaluated = ( &
            Bs_Bt_vals(1, :) * Bs_Bt_vals(4, :) - &
            Bs_Bt_vals(2, :) * Bs_Bt_vals(3, :))
    end if

  end subroutine jacobian_det

  subroutine specialize_workspace_sizes(degree, size_odd, size_even)

    ! NOTE: This is a helper for ``specialize_triangle()``.

    integer(c_int), intent(in) :: degree
    integer(c_int), intent(out) :: size_odd, size_even

    if (mod(degree, 2) == 1) then
       size_odd = ((degree + 1) * (degree + 3)**2 * (degree + 5)) / 64
       size_even = size_odd
    else if (mod(degree, 4) == 0) then
       size_odd = (degree * (degree + 2) * (degree + 4) * (degree + 6)) / 64
       size_even = (((degree + 2) * (degree + 4)) / 8)**2
    else
       size_odd = (((degree + 2) * (degree + 4)) / 8)**2
       size_even = (degree * (degree + 2) * (degree + 4) * (degree + 6)) / 64
    end if

  end subroutine specialize_workspace_sizes

  subroutine specialize_triangle_one_round( &
       dimension_, num_read, read_nodes, num_write, write_nodes, &
       size_read, size_write, step, local_degree, &
       weights_a, weights_b, weights_c)

    ! INVARIANT: `step + local_degree == (total) degree + 1`
    ! INVARIANT: `size_write == size_read - local_degree - 1`

    integer(c_int), intent(in) :: dimension_
    integer(c_int), intent(in) :: num_read
    real(c_double), intent(in) :: read_nodes(dimension_, num_read)
    integer(c_int), intent(in) :: num_write
    real(c_double), intent(inout) :: write_nodes(dimension_, num_write)
    integer(c_int), intent(in) :: size_read, size_write
    integer(c_int), intent(in) :: step, local_degree
    real(c_double), intent(in) :: weights_a(3), weights_b(3), weights_c(3)
    ! Variables outside of signature.
    integer(c_int) :: write_index, new_write, read_index, new_read, i

    ! First: (step, 0, 0)
    call de_casteljau_one_round( &
         size_read, dimension_, read_nodes(:, 1:size_read), &
         local_degree, weights_a(1), weights_a(2), weights_a(3), &
         write_nodes(:, 1:size_write))

    ! Second: (i, j, 0) for j > 0, i + j = step
    write_index = size_write + 1
    read_index = 1
    do i = 1, step
       new_write = write_index + size_write - 1
       new_read = read_index + size_read - 1
       call de_casteljau_one_round( &
            size_read, dimension_, read_nodes(:, read_index:new_read), &
            local_degree, weights_b(1), weights_b(2), weights_b(3), &
            write_nodes(:, write_index:new_write))
       ! Update the indices.
       write_index = new_write + 1
       read_index = new_read + 1
    end do

    ! Third:  (i, j, k) for k > 0, i + j + k = step
    read_index = 1
    do i = 1, ((step + 1) * step) / 2
       new_write = write_index + size_write - 1
       new_read = read_index + size_read - 1
       call de_casteljau_one_round( &
            size_read, dimension_, read_nodes(:, read_index:new_read), &
            local_degree, weights_c(1), weights_c(2), weights_c(3), &
            write_nodes(:, write_index:new_write))
       ! Update the indices.
       write_index = new_write + 1
       read_index = new_read + 1
    end do

  end subroutine specialize_triangle_one_round

  subroutine specialize_triangle( &
       num_nodes, dimension_, nodes, degree, &
       weights_a, weights_b, weights_c, specialized) &
       bind(c, name='BEZ_specialize_triangle')

    ! This re-parameterizes by "specializing" to a subregion of the unit
    ! triangle. This happens in waves by applying one round of de Casteljau
    ! with the given sets of barycentric weights. For example, in the degree
    ! 1 case, we transform
    !     [n0]          [dC(n0(1:3), a)]
    !     [  ] --> n1 = [dC(n0(1:3), b)]
    !     [  ]          [dC(n0(1:3), c)]
    ! where `n` on the LHS is 3xDIM and each of the transformed sets of
    ! nodes are 1xDIM (since de Casteljau drops the degree by 1). (NOTE:
    ! here I'm using `dC` as a shorthand for "de Casteljau" and `a` as a
    ! shorthand `weights_a`.) In the degree 2 case:
    !     [n0]          [dC(n0(1:6), a)]          [dC(n1(1:3), a)]
    !     [  ]          [              ]          [dC(n1(1:3), b)]
    !     [  ]          [              ] --> n2 = [dC(n1(4:6), b)]
    !     [  ] --> n1 = [dC(n0(1:6), b)]          [dC(n1(1:3), c)]
    !     [  ]          [              ]          [dC(n1(4:6), c)]
    !     [  ]          [              ]          [dC(n1(7:9), c)]
    !                   [dC(n0(1:6), c)]
    !                   [              ]
    !                   [              ]
    ! In the degree 3 case:
    !     [n0]          [dC(n0(1:10), a)]          [dC(n1( 1:6 ), a)]
    !     [  ]          [               ]          [                ]
    !     [  ]          [               ]          [                ]
    !     [  ]          [               ]          [dC(n1( 1:6 ), b)]
    !     [  ]          [               ]          [                ]
    !     [  ] --> n1 = [               ]          [                ]
    !     [  ]          [dC(n0(1:10), b)]          [dC(n1( 7:12), b)]
    !     [  ]          [               ]          [                ]
    !     [  ]          [               ]          [                ]
    !     [  ]          [               ] --> n2 = [dC(n1( 1:6 ), c)]
    !                   [               ]          [                ]
    !                   [               ]          [                ]
    !                   [dC(n0(1:10), c)]          [dC(n1( 7:12), c)]
    !                   [               ]          [                ]
    !                   [               ]          [                ]
    !                   [               ]          [dC(n1(13:18), c)]
    !                   [               ]          [                ]
    !                   [               ]          [                ]
    ! ... CONTINUING TO DEGREE 3 ...
    !                 [dC(n2( 1:3 ), a)]
    !                 [dC(n2( 1:3 ), b)]
    !                 [dC(n2( 4:6 ), b)]
    !                 [dC(n2( 7:9 ), b)]
    !                 [dC(n2( 1:3 ), c)]
    !     n2 --> n3 = [dC(n2( 4:6 ), c)]
    !                 [dC(n2( 7:9 ), c)]
    !                 [dC(n2(10:12), c)]
    !                 [dC(n2(13:15), c)]
    !                 [dC(n2(16:18), c)]
    ! For **all** cases, we are tracking applications of weights at
    ! each step:
    !     STEP 1: {a}, {b}, {c}
    !     STEP 2: {aa}, {ab}, {bb}, {ac}, {bc}, {cc}
    !     STEP 3: {aaa}, {aab}, {abb}, {bbb}, {aac}, ...
    ! and each of these quantities can be computed using the ones computed
    ! at the previous step. So in STEP 2, we compute {aa} by applying
    ! the `a` weights to {a}, we compute {ab} and {bb} by applying the
    ! `b` weights to {a} and {b} and we compute {ac}, {bc}, {cc} by
    ! applying the `c` weights to the whole set.
    !
    ! For a "general" step, we can treat the triple (#a, #b, #c) just like
    ! we treat an index triple (i, j, k), which we know has linear index
    ! (1-based) `1 + j + (k/2) (2(i + j) + k + 3)`. This is very useful because
    ! we can find the **previous** quantity by using this index. For example,
    ! to compute {aabccc} by applying `c` to {aabcc}, we know the index
    ! of the {aabcc} is 13 and the index of {aabccc} is 20. In fact, one can
    ! show that when dropping from (i, j, k) to (i, j, k - 1) the index will
    ! always drop by `(i + j + k) + 1 = step + 1`. Unfortunately, some values
    ! have no `c` weights at all, i.e. `k = 0`. For these special cases we
    ! also use the formula to show `(step, 0, 0) --> (step - 1, 0, 0)` has
    ! no change in index (both are the first index). From `(i, j, 0)` to
    ! `(i, j - 1, 0)` drops the index by `1`.
    integer(c_int), intent(in) :: num_nodes, dimension_
    real(c_double), intent(in) :: nodes(dimension_, num_nodes)
    integer(c_int), intent(in) :: degree
    real(c_double), intent(in) :: weights_a(3), weights_b(3), weights_c(3)
    real(c_double), intent(out) :: specialized(dimension_, num_nodes)
    ! Variables outside of signature.
    integer(c_int) :: num_curves, size, size_odd, size_even
    real(c_double), allocatable :: workspace_odd(:, :), workspace_even(:, :)
    integer(c_int) :: delta_nc, delta_size, size_new, step
    logical(c_bool) :: is_even

    num_curves = 1
    size = ((degree + 1) * (degree + 2)) / 2
    call specialize_workspace_sizes(degree, size_odd, size_even)
    allocate(workspace_odd(dimension_, size_odd))
    allocate(workspace_even(dimension_, size_even))

    ! `num_curves` and `delta_size` are triangular numbers going in
    ! the opposite direction. `num_curves` will go from 1, 3, 6, 10, ...
    ! and `delta_size` will go (d + 2 C 2), (d + 1 C 2), ...
    ! Since the delta between consecutive terms grows linearly, we track
    ! them as well to avoid multiplications.
    delta_nc = 2
    delta_size = -degree - 1
    is_even = .FALSE.  ! At `step == 1`.

    do step = 1, degree
       num_curves = num_curves + delta_nc
       size_new = size + delta_size
       if (step == 1) then
          ! Read from `nodes`, write to `workspace_odd`.
          call specialize_triangle_one_round( &
               dimension_, num_nodes, nodes, size_odd, workspace_odd, &
               size, size_new, step, degree + 1 - step, &
               weights_a, weights_b, weights_c)
       else if (is_even) then
          ! Read from `workspace_odd`, write to `workspace_even`.
          call specialize_triangle_one_round( &
               dimension_, size_odd, workspace_odd, &
               size_even, workspace_even, &
               size, size_new, step, degree + 1 - step, &
               weights_a, weights_b, weights_c)
       else
          ! Read from `workspace_even`, write to `workspace_odd`.
          call specialize_triangle_one_round( &
               dimension_, size_even, workspace_even, &
               size_odd, workspace_odd, &
               size, size_new, step, degree + 1 - step, &
               weights_a, weights_b, weights_c)
       end if

       ! Update our index values.
       size = size_new
       delta_nc = delta_nc + 1
       delta_size = delta_size + 1
       is_even = .NOT. is_even  ! Switch parity.
    end do

    ! Read from the last workspace that was written to.
    if (is_even) then
       specialized = workspace_odd(:, 1:num_nodes)
    else
       specialized = workspace_even(:, 1:num_nodes)
    end if

  end subroutine specialize_triangle

  subroutine subdivide_nodes( &
       num_nodes, dimension_, nodes, degree, &
       nodes_a, nodes_b, nodes_c, nodes_d) &
       bind(c, name='BEZ_subdivide_nodes_triangle')

    integer(c_int), intent(in) :: num_nodes, dimension_
    real(c_double), intent(in) :: nodes(dimension_, num_nodes)
    integer(c_int), intent(in) :: degree
    real(c_double), intent(out) :: nodes_a(dimension_, num_nodes)
    real(c_double), intent(out) :: nodes_b(dimension_, num_nodes)
    real(c_double), intent(out) :: nodes_c(dimension_, num_nodes)
    real(c_double), intent(out) :: nodes_d(dimension_, num_nodes)

    if (degree == 1) then
       nodes_a(:, 1) = nodes(:, 1)
       nodes_a(:, 2) = 0.5_dp * (nodes(:, 1) + nodes(:, 2))
       nodes_a(:, 3) = 0.5_dp * (nodes(:, 1) + nodes(:, 3))
       nodes_b(:, 1) = 0.5_dp * (nodes(:, 2) + nodes(:, 3))
       nodes_b(:, 2) = nodes_a(:, 3)
       nodes_b(:, 3) = nodes_a(:, 2)
       nodes_c(:, 1) = nodes_a(:, 2)
       nodes_c(:, 2) = nodes(:, 2)
       nodes_c(:, 3) = nodes_b(:, 1)
       nodes_d(:, 1) = nodes_a(:, 3)
       nodes_d(:, 2) = nodes_b(:, 1)
       nodes_d(:, 3) = nodes(:, 3)
    else if (degree == 2) then
       nodes_a(:, 1) = nodes(:, 1)
       nodes_a(:, 2) = 0.5_dp * (nodes(:, 1) + nodes(:, 2))
       nodes_a(:, 3) = 0.25_dp * (nodes(:, 1) + 2 * nodes(:, 2) + nodes(:, 3))
       nodes_a(:, 4) = 0.5_dp * (nodes(:, 1) + nodes(:, 4))
       nodes_a(:, 5) = 0.25_dp * ( &
            nodes(:, 1) + nodes(:, 2) + nodes(:, 4) + nodes(:, 5))
       nodes_a(:, 6) = 0.25_dp * (nodes(:, 1) + 2 * nodes(:, 4) + nodes(:, 6))
       nodes_b(:, 1) = 0.25_dp * (nodes(:, 3) + 2 * nodes(:, 5) + nodes(:, 6))
       nodes_b(:, 2) = 0.25_dp * ( &
            nodes(:, 2) + nodes(:, 4) + nodes(:, 5) + nodes(:, 6))
       nodes_b(:, 3) = nodes_a(:, 6)
       nodes_b(:, 4) = 0.25_dp * ( &
            nodes(:, 2) + nodes(:, 3) + nodes(:, 4) + nodes(:, 5))
       nodes_b(:, 5) = nodes_a(:, 5)
       nodes_b(:, 6) = nodes_a(:, 3)
       nodes_c(:, 1) = nodes_a(:, 3)
       nodes_c(:, 2) = 0.5_dp * (nodes(:, 2) + nodes(:, 3))
       nodes_c(:, 3) = nodes(:, 3)
       nodes_c(:, 4) = nodes_b(:, 4)
       nodes_c(:, 5) = 0.5_dp * (nodes(:, 3) + nodes(:, 5))
       nodes_c(:, 6) = nodes_b(:, 1)
       nodes_d(:, 1) = nodes_a(:, 6)
       nodes_d(:, 2) = nodes_b(:, 2)
       nodes_d(:, 3) = nodes_b(:, 1)
       nodes_d(:, 4) = 0.5_dp * (nodes(:, 4) + nodes(:, 6))
       nodes_d(:, 5) = 0.5_dp * (nodes(:, 5) + nodes(:, 6))
       nodes_d(:, 6) = nodes(:, 6)
    else if (degree == 3) then
       nodes_a(:, 1) = nodes(:, 1)
       nodes_a(:, 2) = 0.5_dp * (nodes(:, 1) + nodes(:, 2))
       nodes_a(:, 3) = 0.25_dp * (nodes(:, 1) + 2 * nodes(:, 2) + nodes(:, 3))
       nodes_a(:, 4) = 0.125_dp * ( &
            nodes(:, 1) + 3 * nodes(:, 2) + 3 * nodes(:, 3) + nodes(:, 4))
       nodes_a(:, 5) = 0.5_dp * (nodes(:, 1) + nodes(:, 5))
       nodes_a(:, 6) = 0.25_dp * ( &
            nodes(:, 1) + nodes(:, 2) + nodes(:, 5) + nodes(:, 6))
       nodes_a(:, 7) = 0.125_dp * ( &
            nodes(:, 1) + 2 * nodes(:, 2) + nodes(:, 3) + nodes(:, 5) + &
            2 * nodes(:, 6) + nodes(:, 7))
       nodes_a(:, 8) = 0.25_dp * (nodes(:, 1) + 2 * nodes(:, 5) + nodes(:, 8))
       nodes_a(:, 9) = 0.125_dp * ( &
            nodes(:, 1) + nodes(:, 2) + 2 * nodes(:, 5) + 2 * nodes(:, 6) + &
            nodes(:, 8) + nodes(:, 9))
       nodes_a(:, 10) = 0.125_dp * ( &
            nodes(:, 1) + 3 * nodes(:, 5) + 3 * nodes(:, 8) + nodes(:, 10))
       nodes_b(:, 1) = 0.125_dp * ( &
            nodes(:, 4) + 3 * nodes(:, 7) + 3 * nodes(:, 9) + nodes(:, 10))
       nodes_b(:, 2) = 0.125_dp * ( &
            nodes(:, 3) + 2 * nodes(:, 6) + nodes(:, 7) + nodes(:, 8) + &
            2 * nodes(:, 9) + nodes(:, 10))
       nodes_b(:, 3) = 0.125_dp * ( &
            nodes(:, 2) + nodes(:, 5) + 2 * nodes(:, 6) + 2 * nodes(:, 8) + &
            nodes(:, 9) + nodes(:, 10))
       nodes_b(:, 4) = nodes_a(:, 10)
       nodes_b(:, 5) = 0.125_dp * ( &
            nodes(:, 3) + nodes(:, 4) + 2 * nodes(:, 6) + 2 * nodes(:, 7) + &
            nodes(:, 8) + nodes(:, 9))
       nodes_b(:, 6) = 0.125_dp * ( &
            nodes(:, 2) + nodes(:, 3) + nodes(:, 5) + 2 * nodes(:, 6) + &
            nodes(:, 7) + nodes(:, 8) + nodes(:, 9))
       nodes_b(:, 7) = nodes_a(:, 9)
       nodes_b(:, 8) = 0.125_dp * ( &
            nodes(:, 2) + 2 * nodes(:, 3) + nodes(:, 4) + nodes(:, 5) + &
            2 * nodes(:, 6) + nodes(:, 7))
       nodes_b(:, 9) = nodes_a(:, 7)
       nodes_b(:, 10) = nodes_a(:, 4)
       nodes_c(:, 1) = nodes_a(:, 4)
       nodes_c(:, 2) = 0.25_dp * (nodes(:, 2) + 2 * nodes(:, 3) + nodes(:, 4))
       nodes_c(:, 3) = 0.5_dp * (nodes(:, 3) + nodes(:, 4))
       nodes_c(:, 4) = nodes(:, 4)
       nodes_c(:, 5) = nodes_b(:, 8)
       nodes_c(:, 6) = 0.25_dp * ( &
            nodes(:, 3) + nodes(:, 4) + nodes(:, 6) + nodes(:, 7))
       nodes_c(:, 7) = 0.5_dp * (nodes(:, 4) + nodes(:, 7))
       nodes_c(:, 8) = nodes_b(:, 5)
       nodes_c(:, 9) = 0.25_dp * (nodes(:, 4) + 2 * nodes(:, 7) + nodes(:, 9))
       nodes_c(:, 10) = nodes_b(:, 1)
       nodes_d(:, 1) = nodes_a(:, 10)
       nodes_d(:, 2) = nodes_b(:, 3)
       nodes_d(:, 3) = nodes_b(:, 2)
       nodes_d(:, 4) = nodes_b(:, 1)
       nodes_d(:, 5) = 0.25_dp * (nodes(:, 5) + 2 * nodes(:, 8) + nodes(:, 10))
       nodes_d(:, 6) = 0.25_dp * ( &
            nodes(:, 6) + nodes(:, 8) + nodes(:, 9) + nodes(:, 10))
       nodes_d(:, 7) = 0.25_dp * (nodes(:, 7) + 2 * nodes(:, 9) + nodes(:, 10))
       nodes_d(:, 8) = 0.5_dp * (nodes(:, 8) + nodes(:, 10))
       nodes_d(:, 9) = 0.5_dp * (nodes(:, 9) + nodes(:, 10))
       nodes_d(:, 10) = nodes(:, 10)
    else if (degree == 4) then
       nodes_a(:, 1) = nodes(:, 1)
       nodes_a(:, 2) = 0.5_dp * (nodes(:, 1) + nodes(:, 2))
       nodes_a(:, 3) = 0.25_dp * (nodes(:, 1) + 2 * nodes(:, 2) + nodes(:, 3))
       nodes_a(:, 4) = 0.125_dp * ( &
            nodes(:, 1) + 3 * nodes(:, 2) + 3 * nodes(:, 3) + nodes(:, 4))
       nodes_a(:, 5) = 0.0625_dp * ( &
            nodes(:, 1) + 4 * nodes(:, 2) + 6 * nodes(:, 3) + &
            4 * nodes(:, 4) + nodes(:, 5))
       nodes_a(:, 6) = 0.5_dp * (nodes(:, 1) + nodes(:, 6))
       nodes_a(:, 7) = 0.25_dp * ( &
            nodes(:, 1) + nodes(:, 2) + nodes(:, 6) + nodes(:, 7))
       nodes_a(:, 8) = 0.125_dp * ( &
            nodes(:, 1) + 2 * nodes(:, 2) + nodes(:, 3) + nodes(:, 6) + &
            2 * nodes(:, 7) + nodes(:, 8))
       nodes_a(:, 9) = 0.0625_dp * ( &
            nodes(:, 1) + 3 * nodes(:, 2) + 3 * nodes(:, 3) + nodes(:, 4) + &
            nodes(:, 6) + 3 * nodes(:, 7) + 3 * nodes(:, 8) + nodes(:, 9))
       nodes_a(:, 10) = 0.25_dp * ( &
            nodes(:, 1) + 2 * nodes(:, 6) + nodes(:, 10))
       nodes_a(:, 11) = 0.125_dp * ( &
            nodes(:, 1) + nodes(:, 2) + 2 * nodes(:, 6) + 2 * nodes(:, 7) + &
            nodes(:, 10) + nodes(:, 11))
       nodes_a(:, 12) = 0.0625_dp * ( &
            nodes(:, 1) + 2 * nodes(:, 2) + nodes(:, 3) + 2 * nodes(:, 6) + &
            4 * nodes(:, 7) + 2 * nodes(:, 8) + nodes(:, 10) + &
            2 * nodes(:, 11) + nodes(:, 12))
       nodes_a(:, 13) = 0.125_dp * ( &
            nodes(:, 1) + 3 * nodes(:, 6) + 3 * nodes(:, 10) + nodes(:, 13))
       nodes_a(:, 14) = 0.0625_dp * ( &
            nodes(:, 1) + nodes(:, 2) + 3 * nodes(:, 6) + 3 * nodes(:, 7) + &
            3 * nodes(:, 10) + 3 * nodes(:, 11) + nodes(:, 13) + nodes(:, 14))
       nodes_a(:, 15) = 0.0625_dp * ( &
            nodes(:, 1) + 4 * nodes(:, 6) + 6 * nodes(:, 10) + &
            4 * nodes(:, 13) + nodes(:, 15))
       nodes_b(:, 1) = 0.0625_dp * ( &
            nodes(:, 5) + 4 * nodes(:, 9) + 6 * nodes(:, 12) + &
            4 * nodes(:, 14) + nodes(:, 15))
       nodes_b(:, 2) = 0.0625_dp * ( &
            nodes(:, 4) + 3 * nodes(:, 8) + nodes(:, 9) + 3 * nodes(:, 11) + &
            3 * nodes(:, 12) + nodes(:, 13) + 3 * nodes(:, 14) + nodes(:, 15))
       nodes_b(:, 3) = 0.0625_dp * ( &
            nodes(:, 3) + 2 * nodes(:, 7) + 2 * nodes(:, 8) + nodes(:, 10) + &
            4 * nodes(:, 11) + nodes(:, 12) + 2 * nodes(:, 13) + &
            2 * nodes(:, 14) + nodes(:, 15))
       nodes_b(:, 4) = 0.0625_dp * ( &
            nodes(:, 2) + nodes(:, 6) + 3 * nodes(:, 7) + 3 * nodes(:, 10) + &
            3 * nodes(:, 11) + 3 * nodes(:, 13) + nodes(:, 14) + nodes(:, 15))
       nodes_b(:, 5) = nodes_a(:, 15)
       nodes_b(:, 6) = 0.0625_dp * ( &
            nodes(:, 4) + nodes(:, 5) + 3 * nodes(:, 8) + 3 * nodes(:, 9) + &
            3 * nodes(:, 11) + 3 * nodes(:, 12) + nodes(:, 13) + nodes(:, 14))
       nodes_b(:, 7) = 0.0625_dp * ( &
            nodes(:, 3) + nodes(:, 4) + 2 * nodes(:, 7) + 3 * nodes(:, 8) + &
            nodes(:, 9) + nodes(:, 10) + 3 * nodes(:, 11) + &
            2 * nodes(:, 12) + nodes(:, 13) + nodes(:, 14))
       nodes_b(:, 8) = 0.0625_dp * ( &
            nodes(:, 2) + nodes(:, 3) + nodes(:, 6) + 3 * nodes(:, 7) + &
            2 * nodes(:, 8) + 2 * nodes(:, 10) + 3 * nodes(:, 11) + &
            nodes(:, 12) + nodes(:, 13) + nodes(:, 14))
       nodes_b(:, 9) = nodes_a(:, 14)
       nodes_b(:, 10) = 0.0625_dp * ( &
            nodes(:, 3) + 2 * nodes(:, 4) + nodes(:, 5) + 2 * nodes(:, 7) + &
            4 * nodes(:, 8) + 2 * nodes(:, 9) + nodes(:, 10) + &
            2 * nodes(:, 11) + nodes(:, 12))
       nodes_b(:, 11) = 0.0625_dp * ( &
            nodes(:, 2) + 2 * nodes(:, 3) + nodes(:, 4) + nodes(:, 6) + &
            3 * nodes(:, 7) + 3 * nodes(:, 8) + nodes(:, 9) + nodes(:, 10) + &
            2 * nodes(:, 11) + nodes(:, 12))
       nodes_b(:, 12) = nodes_a(:, 12)
       nodes_b(:, 13) = 0.0625_dp * ( &
            nodes(:, 2) + 3 * nodes(:, 3) + 3 * nodes(:, 4) + nodes(:, 5) + &
            nodes(:, 6) + 3 * nodes(:, 7) + 3 * nodes(:, 8) + nodes(:, 9))
       nodes_b(:, 14) = nodes_a(:, 9)
       nodes_b(:, 15) = nodes_a(:, 5)
       nodes_c(:, 1) = nodes_a(:, 5)
       nodes_c(:, 2) = 0.125_dp * ( &
            nodes(:, 2) + 3 * nodes(:, 3) + 3 * nodes(:, 4) + nodes(:, 5))
       nodes_c(:, 3) = 0.25_dp * ( &
            nodes(:, 3) + 2 * nodes(:, 4) + nodes(:, 5))
       nodes_c(:, 4) = 0.5_dp * ( &
            nodes(:, 4) + nodes(:, 5))
       nodes_c(:, 5) = nodes(:, 5)
       nodes_c(:, 6) = nodes_b(:, 13)
       nodes_c(:, 7) = 0.125_dp * ( &
            nodes(:, 3) + 2 * nodes(:, 4) + nodes(:, 5) + nodes(:, 7) + &
            2 * nodes(:, 8) + nodes(:, 9))
       nodes_c(:, 8) = 0.25_dp * ( &
            nodes(:, 4) + nodes(:, 5) + nodes(:, 8) + nodes(:, 9))
       nodes_c(:, 9) = 0.5_dp * (nodes(:, 5) + nodes(:, 9))
       nodes_c(:, 10) = nodes_b(:, 10)
       nodes_c(:, 11) = 0.125_dp * ( &
            nodes(:, 4) + nodes(:, 5) + 2 * nodes(:, 8) + 2 * nodes(:, 9) + &
            nodes(:, 11) + nodes(:, 12))
       nodes_c(:, 12) = 0.25_dp * ( &
            nodes(:, 5) + 2 * nodes(:, 9) + nodes(:, 12))
       nodes_c(:, 13) = nodes_b(:, 6)
       nodes_c(:, 14) = 0.125_dp * ( &
            nodes(:, 5) + 3 * nodes(:, 9) + 3 * nodes(:, 12) + nodes(:, 14))
       nodes_c(:, 15) = nodes_b(:, 1)
       nodes_d(:, 1) = nodes_a(:, 15)
       nodes_d(:, 2) = nodes_b(:, 4)
       nodes_d(:, 3) = nodes_b(:, 3)
       nodes_d(:, 4) = nodes_b(:, 2)
       nodes_d(:, 5) = nodes_b(:, 1)
       nodes_d(:, 6) = 0.125_dp * ( &
            nodes(:, 6) + 3 * nodes(:, 10) + 3 * nodes(:, 13) + nodes(:, 15))
       nodes_d(:, 7) = 0.125_dp * ( &
            nodes(:, 7) + nodes(:, 10) + 2 * nodes(:, 11) + &
            2 * nodes(:, 13) + nodes(:, 14) + nodes(:, 15))
       nodes_d(:, 8) = 0.125_dp * ( &
            nodes(:, 8) + 2 * nodes(:, 11) + nodes(:, 12) + nodes(:, 13) + &
            2 * nodes(:, 14) + nodes(:, 15))
       nodes_d(:, 9) = 0.125_dp * ( &
            nodes(:, 9) + 3 * nodes(:, 12) + 3 * nodes(:, 14) + nodes(:, 15))
       nodes_d(:, 10) = 0.25_dp * ( &
            nodes(:, 10) + 2 * nodes(:, 13) + nodes(:, 15))
       nodes_d(:, 11) = 0.25_dp * ( &
            nodes(:, 11) + nodes(:, 13) + nodes(:, 14) + nodes(:, 15))
       nodes_d(:, 12) = 0.25_dp * ( &
            nodes(:, 12) + 2 * nodes(:, 14) + nodes(:, 15))
       nodes_d(:, 13) = 0.5_dp * (nodes(:, 13) + nodes(:, 15))
       nodes_d(:, 14) = 0.5_dp * (nodes(:, 14) + nodes(:, 15))
       nodes_d(:, 15) = nodes(:, 15)
    else
       call specialize_triangle( &
            num_nodes, dimension_, nodes, degree, &
            [1.0_dp, 0.0_dp, 0.0_dp], &
            [0.5_dp, 0.5_dp, 0.0_dp], &
            [0.5_dp, 0.0_dp, 0.5_dp], &
            nodes_a)
       call specialize_triangle( &
            num_nodes, dimension_, nodes, degree, &
            [0.0_dp, 0.5_dp, 0.5_dp], &
            [0.5_dp, 0.0_dp, 0.5_dp], &
            [0.5_dp, 0.5_dp, 0.0_dp], &
            nodes_b)
       call specialize_triangle( &
            num_nodes, dimension_, nodes, degree, &
            [0.5_dp, 0.5_dp, 0.0_dp], &
            [0.0_dp, 1.0_dp, 0.0_dp], &
            [0.0_dp, 0.5_dp, 0.5_dp], &
            nodes_c)
       call specialize_triangle( &
            num_nodes, dimension_, nodes, degree, &
            [0.5_dp, 0.0_dp, 0.5_dp], &
            [0.0_dp, 0.5_dp, 0.5_dp], &
            [0.0_dp, 0.0_dp, 1.0_dp], &
            nodes_d)
    end if

  end subroutine subdivide_nodes

  subroutine compute_edge_nodes( &
       num_nodes, dimension_, nodes, degree, nodes1, nodes2, nodes3) &
       bind(c, name='BEZ_compute_edge_nodes')

    integer(c_int), intent(in) :: num_nodes, dimension_
    real(c_double), intent(in) :: nodes(dimension_, num_nodes)
    integer(c_int), intent(in) :: degree
    real(c_double), intent(out) :: nodes1(dimension_, degree + 1)
    real(c_double), intent(out) :: nodes2(dimension_, degree + 1)
    real(c_double), intent(out) :: nodes3(dimension_, degree + 1)
    ! Variables outside of signature.
    integer(c_int) :: index1, index2, index3

    index2 = degree + 1
    index3 = num_nodes
    do index1 = 1, degree + 1
       nodes1(:, index1) = nodes(:, index1)
       nodes2(:, index1) = nodes(:, index2)
       nodes3(:, index1) = nodes(:, index3)
       ! Update the indices.
       index2 = index2 - index1 + degree + 1
       index3 = index3 - index1 - 1
    end do

  end subroutine compute_edge_nodes

  subroutine shoelace_for_area(num_nodes, nodes, shoelace, not_implemented)

    ! NOTE: This is a helper for ``compute_area()``.
    ! NOTE: This subroutine is not part of the C ABI for this module,
    !       but it is (for now) public, so that it can be tested.

    integer(c_int), intent(in) :: num_nodes
    real(c_double), intent(in) :: nodes(2, num_nodes)
    real(c_double), intent(out) :: shoelace
    logical(c_bool), intent(out) :: not_implemented

    not_implemented = .FALSE.
    if (num_nodes == 2) then
       shoelace = ( &
            nodes(1, 1) * nodes(2, 2) - nodes(2, 1) * nodes(1, 2))
       shoelace = shoelace / 2
    else if (num_nodes == 3) then
       shoelace = ( &
            2 * (nodes(1, 1) * nodes(2, 2) - nodes(2, 1) * nodes(1, 2)) + &
            (nodes(1, 1) * nodes(2, 3) - nodes(2, 1) * nodes(1, 3)) + &
            2 * (nodes(1, 2) * nodes(2, 3) - nodes(2, 2) * nodes(1, 3)))
       shoelace = shoelace / 6
    else if (num_nodes == 4) then
       shoelace = ( &
            6 * (nodes(1, 1) * nodes(2, 2) - nodes(2, 1) * nodes(1, 2)) + &
            3 * (nodes(1, 1) * nodes(2, 3) - nodes(2, 1) * nodes(1, 3)) + &
            (nodes(1, 1) * nodes(2, 4) - nodes(2, 1) * nodes(1, 4)) + &
            3 * (nodes(1, 2) * nodes(2, 3) - nodes(2, 2) * nodes(1, 3)) + &
            3 * (nodes(1, 2) * nodes(2, 4) - nodes(2, 2) * nodes(1, 4)) + &
            6 * (nodes(1, 3) * nodes(2, 4) - nodes(2, 3) * nodes(1, 4)))
       shoelace = shoelace / 20
    else if (num_nodes == 5) then
       shoelace = ( &
            20 * (nodes(1, 1) * nodes(2, 2) - nodes(2, 1) * nodes(1, 2)) + &
            10 * (nodes(1, 1) * nodes(2, 3) - nodes(2, 1) * nodes(1, 3)) + &
            4 * (nodes(1, 1) * nodes(2, 4) - nodes(2, 1) * nodes(1, 4)) + &
            (nodes(1, 1) * nodes(2, 5) - nodes(2, 1) * nodes(1, 5)) + &
            8 * (nodes(1, 2) * nodes(2, 3) - nodes(2, 2) * nodes(1, 3)) + &
            8 * (nodes(1, 2) * nodes(2, 4) - nodes(2, 2) * nodes(1, 4)) + &
            4 * (nodes(1, 2) * nodes(2, 5) - nodes(2, 2) * nodes(1, 5)) + &
            8 * (nodes(1, 3) * nodes(2, 4) - nodes(2, 3) * nodes(1, 4)) + &
            10 * (nodes(1, 3) * nodes(2, 5) - nodes(2, 3) * nodes(1, 5)) + &
            20 * (nodes(1, 4) * nodes(2, 5) - nodes(2, 4) * nodes(1, 5)))
       shoelace = shoelace / 70
    else
       shoelace = 0.0_dp
       not_implemented = .TRUE.
    end if

  end subroutine shoelace_for_area

  subroutine compute_area( &
       num_edges, sizes, nodes_pointers, area, not_implemented) &
       bind(c, name='BEZ_compute_area')

    integer(c_int), intent(in) :: num_edges
    integer(c_int), intent(in) :: sizes(num_edges)
    type(c_ptr), intent(in) :: nodes_pointers(num_edges)
    real(c_double), intent(out) :: area
    logical(c_bool), intent(out) :: not_implemented
    ! Variables outside of signature.
    integer(c_int) :: i
    real(c_double), pointer :: nodes(:, :)
    real(c_double) :: shoelace

    area = 0.0_dp
    do i = 1, num_edges
       call c_f_pointer(nodes_pointers(i), nodes, [2, sizes(i)])
       call shoelace_for_area(sizes(i), nodes, shoelace, not_implemented)
       if (not_implemented) then
          return
       else
          area = area + shoelace
       end if
    end do

  end subroutine compute_area

end module triangle

! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     https://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

module curve_intersection

  use, intrinsic :: iso_c_binding, only: c_double, c_int, c_bool
  use types, only: dp
  use status, only: &
       Status_SUCCESS, Status_PARALLEL, Status_WIGGLE_FAIL, &
       Status_NO_CONVERGE, Status_INSUFFICIENT_SPACE
  use helpers, only: &
       VECTOR_CLOSE_EPS, cross_product, bbox, wiggle_interval, &
       vector_close, in_interval, ulps_away
  use curve, only: &
       CurveData, evaluate_multi, evaluate_hodograph, subdivide_curve
  implicit none
  private &
       MAX_INTERSECT_SUBDIVISIONS, MAX_CANDIDATES, SIMILAR_ULPS, &
       CANDIDATES_ODD, CANDIDATES_EVEN, make_candidates
  public &
       BoxIntersectionType_INTERSECTION, BoxIntersectionType_TANGENT, &
       BoxIntersectionType_DISJOINT, Subdivide_FIRST, Subdivide_SECOND, &
       Subdivide_BOTH, Subdivide_NEITHER, LINEARIZATION_THRESHOLD, &
       INTERSECTIONS_WORKSPACE, linearization_error, segment_intersection, &
       newton_refine_intersect, bbox_intersect, parallel_different, &
       from_linearized, bbox_line_intersect, add_intersection, &
       add_from_linearized, endpoint_check, tangent_bbox_intersection, &
       add_candidates, intersect_one_round, all_intersections, &
       all_intersections_abi, set_max_candidates, get_max_candidates, &
       set_similar_ulps, get_similar_ulps, free_curve_intersections_workspace

  ! Values of BoxIntersectionType enum:
  integer(c_int), parameter :: BoxIntersectionType_INTERSECTION = 0
  integer(c_int), parameter :: BoxIntersectionType_TANGENT = 1
  integer(c_int), parameter :: BoxIntersectionType_DISJOINT = 2
  ! Values of Subdivide enum:
  integer(c_int), parameter :: Subdivide_FIRST = 0
  integer(c_int), parameter :: Subdivide_SECOND = 1
  integer(c_int), parameter :: Subdivide_BOTH = 2
  integer(c_int), parameter :: Subdivide_NEITHER = -1
  ! Set the threshold for linearization error at half the bits available.
  real(c_double), parameter :: LINEARIZATION_THRESHOLD = 0.5_dp**26
  integer(c_int), parameter :: MAX_INTERSECT_SUBDIVISIONS = 20
  ! Run-time parameters that can be modified. If multiple threads are used,
  ! these **should** be thread-local (though it's expected that callers will
  ! update these values **before** beginning computation).
  integer(c_int) :: MAX_CANDIDATES = 64
  integer(c_int) :: SIMILAR_ULPS = 1
  ! Long-lived workspaces for ``all_intersections()`` and
  ! ``all_intersections_abi()``. If multiple threads are used, each of these
  ! **should** be thread-local.
  type(CurveData), allocatable :: CANDIDATES_ODD(:, :)
  type(CurveData), allocatable :: CANDIDATES_EVEN(:, :)
  real(c_double), allocatable :: INTERSECTIONS_WORKSPACE(:, :)

contains

  subroutine linearization_error( &
       num_nodes, dimension_, nodes, error)

    integer(c_int), intent(in) :: num_nodes, dimension_
    real(c_double), intent(in) :: nodes(num_nodes, dimension_)
    real(c_double), intent(out) :: error
    ! Variables outside of signature.
    real(c_double) :: second_deriv(num_nodes - 2, dimension_)
    real(c_double) :: worst_case(dimension_)

    ! A line has no linearization error.
    if (num_nodes == 2) then
       error = 0.0_dp
       return
    end if

    second_deriv = ( &
         nodes(:num_nodes - 2, :) - &
         2.0_dp * nodes(2:num_nodes - 1, :) + &
         nodes(3:, :))
    worst_case = maxval(abs(second_deriv), 1)
    error = 0.125_dp * (num_nodes - 1) * (num_nodes - 2) * norm2(worst_case)

  end subroutine linearization_error

  subroutine segment_intersection( &
       start0, end0, start1, end1, s, t, success)

    real(c_double), intent(in) :: start0(1, 2)
    real(c_double), intent(in) :: end0(1, 2)
    real(c_double), intent(in) :: start1(1, 2)
    real(c_double), intent(in) :: end1(1, 2)
    real(c_double), intent(out) :: s, t
    logical(c_bool), intent(out) :: success
    ! Variables outside of signature.
    real(c_double) :: delta0(1, 2)
    real(c_double) :: delta1(1, 2)
    real(c_double) :: start_delta(1, 2)
    real(c_double) :: cross_d0_d1
    real(c_double) :: other_cross

    delta0 = end0 - start0
    delta1 = end1 - start1
    call cross_product(delta0, delta1, cross_d0_d1)

    if (cross_d0_d1 == 0.0_dp) then
       success = .FALSE.
    else
       start_delta = start1 - start0
       call cross_product(start_delta, delta1, other_cross)
       s = other_cross / cross_d0_d1
       call cross_product(start_delta, delta0, other_cross)
       t = other_cross / cross_d0_d1
       success = .TRUE.
    end if

  end subroutine segment_intersection

  subroutine newton_refine_intersect( &
       s, num_nodes1, nodes1, t, num_nodes2, nodes2, new_s, new_t) &
       bind(c, name='newton_refine_curve_intersect')

    real(c_double), intent(in) :: s
    integer(c_int), intent(in) :: num_nodes1
    real(c_double), intent(in) :: nodes1(num_nodes1, 2)
    real(c_double), intent(in) :: t
    integer(c_int), intent(in) :: num_nodes2
    real(c_double), intent(in) :: nodes2(num_nodes2, 2)
    real(c_double), intent(out) :: new_s, new_t
    ! Variables outside of signature.
    real(c_double) :: param(1)
    real(c_double) :: func_val(1, 2)
    real(c_double) :: workspace(1, 2)
    real(c_double) :: jac_mat(2, 2)
    real(c_double) :: determinant, delta_s, delta_t

    param = t
    call evaluate_multi( &
         num_nodes2, 2, nodes2, 1, param, func_val)
    param = s
    call evaluate_multi( &
         num_nodes1, 2, nodes1, 1, param, workspace)
    func_val = func_val - workspace

    if (all(func_val == 0.0_dp)) then
       new_s = s
       new_t = t
       return
    end if

    call evaluate_hodograph(s, num_nodes1, 2, nodes1, jac_mat(1:1, :))
    ! NOTE: We actually want the negative, since we want -B2'(t), but
    !       since we manually solve the system, it's just algebra
    !       to figure out how to use the negative values.
    call evaluate_hodograph(t, num_nodes2, 2, nodes2, jac_mat(2:2, :))

    determinant = ( &
         jac_mat(1, 1) * jac_mat(2, 2) - jac_mat(1, 2) * jac_mat(2, 1))

    ! NOTE: We manually invert the 2x2 system ([ds, dt] J)^T = f^T.
    delta_s = ( &
         (jac_mat(2, 2) * func_val(1, 1) - &
         jac_mat(2, 1) * func_val(1, 2)) / determinant)
    new_s = s + delta_s

    delta_t = ( &
         (jac_mat(1, 2) * func_val(1, 1) - &
         jac_mat(1, 1) * func_val(1, 2)) / determinant)
    new_t = t + delta_t

  end subroutine newton_refine_intersect

  subroutine bbox_intersect( &
       num_nodes1, nodes1, num_nodes2, nodes2, enum_) &
       bind(c, name='bbox_intersect')

    integer(c_int), intent(in) :: num_nodes1
    real(c_double), intent(in) :: nodes1(num_nodes1, 2)
    integer(c_int), intent(in) :: num_nodes2
    real(c_double), intent(in) :: nodes2(num_nodes2, 2)
    integer(c_int), intent(out) :: enum_
    ! Variables outside of signature.
    real(c_double) :: left1, right1, bottom1, top1
    real(c_double) :: left2, right2, bottom2, top2

    call bbox(num_nodes1, nodes1, left1, right1, bottom1, top1)
    call bbox(num_nodes2, nodes2, left2, right2, bottom2, top2)

    if ( &
         right2 < left1 .OR. right1 < left2 .OR. &
         top2 < bottom1 .OR. top1 < bottom2) then
       enum_ = BoxIntersectionType_DISJOINT
    else if ( &
         right2 == left1 .OR. right1 == left2 .OR. &
         top2 == bottom1 .OR. top1 == bottom2) then
       enum_ = BoxIntersectionType_TANGENT
    else
       enum_ = BoxIntersectionType_INTERSECTION
    end if

  end subroutine bbox_intersect

  subroutine parallel_different( &
       start0, end0, start1, end1, result_)

    real(c_double), intent(in) :: start0(1, 2)
    real(c_double), intent(in) :: end0(1, 2)
    real(c_double), intent(in) :: start1(1, 2)
    real(c_double), intent(in) :: end1(1, 2)
    logical(c_bool), intent(out) :: result_
    ! Variables outside of signature.
    real(c_double) :: delta0(1, 2)
    real(c_double) :: val1, val2  ! Workspace

    delta0 = end0 - start0
    call cross_product(start0, delta0, val1)  ! line0_const
    call cross_product(start1, delta0, val2)  ! start1_against

    if (val1 /= val2) then
       result_ = .TRUE.
       return
    end if

    val1 = dot_product(delta0(1, :), delta0(1, :))  ! norm0_sq
    ! val2 == start_numer
    val2 = dot_product(start1(1, :) - start0(1, :), delta0(1, :))
    !      0 <= start_numer / norm0_sq <= 1
    ! <==> 0 <= start_numer            <= norm0_sq
    if (0.0_dp <= val2 .AND. val2 <= val1) then
       result_ = .FALSE.
       return
    end if

    val2 = dot_product(end1(1, :) - start0(1, :), delta0(1, :))  ! end_numer
    !      0 <= end_numer / norm0_sq <= 1
    ! <==> 0 <= end_numer            <= norm0_sq
    if (0.0_dp <= val2 .AND. val2 <= val1) then
       result_ = .FALSE.
       return
    end if

    ! We know neither the start or end parameters are in [0, 1], but
    ! they may contain [0, 1] between them, so we make sure that 0
    ! isn't between them.
    result_ = (0.0_dp < min(val1, val2) .OR. max(val1, val2) < 0.0_dp)

  end subroutine parallel_different

  subroutine from_linearized( &
       error1, curve1, num_nodes1, root_nodes1, &
       error2, curve2, num_nodes2, root_nodes2, &
       refined_s, refined_t, does_intersect, status)

    ! Possible error states:
    ! * Status_SUCCESS    : On success.
    ! * Status_PARALLEL   : If ``segment_intersection()`` fails (which means
    !                       the linearized segments are parallel). This
    !                       can still be avoided if the "root" curves are
    !                       also (parallel) lines that don't overlap or if
    !                       the "root" curves have disjoint bounding boxes.
    ! * Status_WIGGLE_FAIL: If the s- or t-parameter are too far outside of
    !                       [0, 1] to be "wiggled" into it.

    real(c_double), intent(in) :: error1
    type(CurveData), intent(in) :: curve1
    integer(c_int), intent(in) :: num_nodes1
    real(c_double), intent(in) :: root_nodes1(num_nodes1, 2)
    real(c_double), intent(in) :: error2
    type(CurveData), intent(in) :: curve2
    integer(c_int), intent(in) :: num_nodes2
    real(c_double), intent(in) :: root_nodes2(num_nodes2, 2)
    real(c_double), intent(out) :: refined_s, refined_t
    logical(c_bool), intent(out) :: does_intersect
    integer(c_int), intent(out) :: status
    ! Variables outside of signature.
    real(c_double) :: s, t
    integer(c_int) :: enum_
    logical(c_bool) :: success

    status = Status_SUCCESS
    does_intersect = .FALSE.  ! Default value.
    call segment_intersection( &
         curve1%nodes(1, :), curve1%nodes(num_nodes1, :), &
         curve2%nodes(1, :), curve2%nodes(num_nodes2, :), &
         s, t, success)

    if (success) then
       ! Special case for lines, allow no leeway on almost intersections.
       if (error1 == 0.0_dp .AND. (s < 0.0_dp .OR. 1.0_dp < s)) then
          return
       end if

       if (error2 == 0.0_dp .AND. (t < 0.0_dp .OR. 1.0_dp < t)) then
          return
       end if

       if (s < -(0.5_dp**16) .OR. 1.0_dp + 0.5_dp**16 < s) then
          return
       end if

       if (t < -(0.5_dp**16) .OR. 1.0_dp + 0.5_dp**16 < t) then
          return
       end if
    else
       ! Handle special case where the curves are actually lines.
       if (error1 == 0.0_dp .AND. error2 == 0.0_dp) then
          call parallel_different( &
               curve1%nodes(1, :), curve1%nodes(num_nodes1, :), &
               curve2%nodes(1, :), curve2%nodes(num_nodes2, :), &
               success)
          if (success) then
             return
          end if
       else
          call bbox_intersect( &
               num_nodes1, root_nodes1, num_nodes2, root_nodes2, enum_)
          if (enum_ == BoxIntersectionType_DISJOINT) then
             return
          end if
       end if

       status = Status_PARALLEL
       return
    end if

    does_intersect = .TRUE.
    ! Now, promote ``s`` and ``t`` onto the original curves.
    s = (1.0_dp - s) * curve1%start + s * curve1%end_  ! orig_s
    t = (1.0_dp - t) * curve2%start + t * curve2%end_  ! orig_t
    ! Perform one step of Newton iteration to refine the computed
    ! values of s and t.
    call newton_refine_intersect( &
         s, num_nodes1, root_nodes1, t, &
         num_nodes2, root_nodes2, refined_s, refined_t)

    call wiggle_interval(refined_s, s, success)
    if (.NOT. success) then
       ! LCOV_EXCL_START
       status = Status_WIGGLE_FAIL
       return
       ! LCOV_EXCL_STOP
    end if
    refined_s = s

    call wiggle_interval(refined_t, t, success)
    if (.NOT. success) then
       ! LCOV_EXCL_START
       status = Status_WIGGLE_FAIL
       return
       ! LCOV_EXCL_STOP
    end if
    refined_t = t

  end subroutine from_linearized

  subroutine bbox_line_intersect( &
       num_nodes, nodes, line_start, line_end, enum_)

    integer(c_int), intent(in) :: num_nodes
    real(c_double), intent(in) :: nodes(num_nodes, 2)
    real(c_double), intent(in) :: line_start(1, 2)
    real(c_double), intent(in) :: line_end(1, 2)
    integer(c_int), intent(out) :: enum_
    ! Variables outside of signature.
    real(c_double) :: left, right, bottom, top
    real(c_double) :: segment_start(1, 2)
    real(c_double) :: segment_end(1, 2)
    real(c_double) :: s_curr, t_curr
    logical(c_bool) :: success

    call bbox(num_nodes, nodes, left, right, bottom, top)

    ! Check if line start is inside the bounding box.
    if ( &
         in_interval(line_start(1, 1), left, right) .AND. &
         in_interval(line_start(1, 2), bottom, top)) then
       enum_ = BoxIntersectionType_INTERSECTION
       return
    end if

    ! Check if line end is inside the bounding box.
    if ( &
         in_interval(line_end(1, 1), left, right) .AND. &
         in_interval(line_end(1, 2), bottom, top)) then
       enum_ = BoxIntersectionType_INTERSECTION
       return
    end if

    ! NOTE: We allow ``segment_intersection`` to fail below (i.e.
    !       ``success=False``). At first, this may appear to "ignore"
    !       some potential intersections of parallel lines. However,
    !       no intersections will be missed. If parallel lines don't
    !       overlap, then there is nothing to miss. If they do overlap,
    !       then either the segment will have endpoints on the box (already
    !       covered by the checks above) or the segment will contain an
    !       entire side of the box, which will force it to intersect the 3
    !       edges that meet at the two ends of those sides. The parallel
    !       edge will be skipped, but the other two will be covered.

    ! Bottom Edge
    segment_start(1, 1) = left
    segment_start(1, 2) = bottom
    segment_end(1, 1) = right
    segment_end(1, 2) = bottom
    call segment_intersection( &
         segment_start, segment_end, line_start, line_end, &
         s_curr, t_curr, success)
    if ( &
         success .AND. &
         in_interval(s_curr, 0.0_dp, 1.0_dp) .AND. &
         in_interval(t_curr, 0.0_dp, 1.0_dp)) then
       enum_ = BoxIntersectionType_INTERSECTION
       return
    end if

    ! Right Edge
    segment_start(1, 1) = right
    segment_start(1, 2) = bottom
    segment_end(1, 1) = right
    segment_end(1, 2) = top
    call segment_intersection( &
         segment_start, segment_end, line_start, line_end, &
         s_curr, t_curr, success)
    if ( &
         success .AND. &
         in_interval(s_curr, 0.0_dp, 1.0_dp) .AND. &
         in_interval(t_curr, 0.0_dp, 1.0_dp)) then
       enum_ = BoxIntersectionType_INTERSECTION
       return
    end if

    ! Top Edge
    segment_start(1, 1) = right
    segment_start(1, 2) = top
    segment_end(1, 1) = left
    segment_end(1, 2) = top
    call segment_intersection( &
         segment_start, segment_end, line_start, line_end, &
         s_curr, t_curr, success)
    if ( &
         success .AND. &
         in_interval(s_curr, 0.0_dp, 1.0_dp) .AND. &
         in_interval(t_curr, 0.0_dp, 1.0_dp)) then
       enum_ = BoxIntersectionType_INTERSECTION
       return
    end if

    ! NOTE: We skip the "last" edge. This is because any curve
    !       that doesn't have an endpoint on a curve must cross
    !       at least two, so we will have already covered such curves
    !       in one of the branches above.

    enum_ = BoxIntersectionType_DISJOINT

  end subroutine bbox_line_intersect

  subroutine add_intersection( &
       s, t, num_intersections, intersections)

    ! Adds an intersection to list of ``intersections``.

    real(c_double), intent(in) :: s
    real(c_double), intent(in) :: t
    integer(c_int), intent(inout) :: num_intersections
    real(c_double), allocatable, intent(inout) :: intersections(:, :)
    ! Variables outside of signature.
    integer(c_int) :: curr_size, index_
    real(c_double), allocatable :: intersections_swap(:, :)

    ! First, check if the intersection is a duplicate (up to precision,
    ! determined by ``ulps_away``).
    do index_ = 1, num_intersections
       if ( &
            ulps_away(intersections(1, index_), s, &
            SIMILAR_ULPS, VECTOR_CLOSE_EPS) .AND. &
            ulps_away(intersections(2, index_), t, &
            SIMILAR_ULPS, VECTOR_CLOSE_EPS)) then
          return
       end if
    end do

    ! Update the number of intersections.
    num_intersections = num_intersections + 1

    if (allocated(intersections)) then
       curr_size = size(intersections, 2)
       if (curr_size < num_intersections) then
          allocate(intersections_swap(2, num_intersections))
          intersections_swap(:, :curr_size) = intersections(:, :curr_size)
          call move_alloc(intersections_swap, intersections)
       end if
    else
       allocate(intersections(2, num_intersections))
    end if

    intersections(1, num_intersections) = s
    intersections(2, num_intersections) = t

  end subroutine add_intersection

  subroutine add_from_linearized( &
       first, root_nodes1, linearization_error1, &
       second, root_nodes2, linearization_error2, &
       num_intersections, intersections, status)

    ! Adds an intersection from two linearizations.
    !
    ! NOTE: This is **explicitly** not intended for C inter-op.

    ! Possible error states:
    ! * Status_SUCCESS    : On success.
    ! * Status_PARALLEL   : Via ``from_linearized()``.
    ! * Status_WIGGLE_FAIL: Via ``from_linearized()``.

    type(CurveData), intent(in) :: first
    real(c_double), intent(in) :: root_nodes1(:, :)
    real(c_double), intent(in) :: linearization_error1
    type(CurveData), intent(in) :: second
    real(c_double), intent(in) :: root_nodes2(:, :)
    real(c_double), intent(in) :: linearization_error2
    integer(c_int), intent(inout) :: num_intersections
    real(c_double), allocatable, intent(inout) :: intersections(:, :)
    integer(c_int), intent(out) :: status
    ! Variables outside of signature.
    integer(c_int) :: num_nodes1, num_nodes2
    real(c_double) :: refined_s, refined_t
    logical(c_bool) :: does_intersect

    num_nodes1 = size(first%nodes, 1)
    num_nodes2 = size(second%nodes, 1)

    call from_linearized( &
         linearization_error1, first, num_nodes1, root_nodes1, &
         linearization_error2, second, num_nodes2, root_nodes2, &
         refined_s, refined_t, does_intersect, status)

    if (status /= Status_SUCCESS) then
       return
    end if

    if (.NOT. does_intersect) then
       return
    end if

    call add_intersection( &
         refined_s, refined_t, num_intersections, intersections)

  end subroutine add_from_linearized

  subroutine endpoint_check( &
       first, node_first, s, second, node_second, t, &
       num_intersections, intersections)

    ! NOTE: This is **explicitly** not intended for C inter-op.

    type(CurveData), intent(in) :: first
    real(c_double), intent(in) :: node_first(1, 2)
    real(c_double), intent(in) :: s
    type(CurveData), intent(in) :: second
    real(c_double), intent(in) :: node_second(1, 2)
    real(c_double), intent(in) :: t
    integer(c_int), intent(inout) :: num_intersections
    real(c_double), allocatable, intent(inout) :: intersections(:, :)
    ! Variables outside of signature.
    real(c_double) :: orig_s, orig_t

    if (.NOT. vector_close(2, node_first, node_second, VECTOR_CLOSE_EPS)) then
       return
    end if

    orig_s = (1 - s) * first%start + s * first%end_
    orig_t = (1 - t) * second%start + t * second%end_
    call add_intersection(orig_s, orig_t, num_intersections, intersections)

  end subroutine endpoint_check

  subroutine tangent_bbox_intersection( &
       first, second, num_intersections, intersections)

    ! NOTE: This is **explicitly** not intended for C inter-op.

    type(CurveData), intent(in) :: first, second
    integer(c_int), intent(inout) :: num_intersections
    real(c_double), allocatable, intent(inout) :: intersections(:, :)
    ! Variables outside of signature.
    integer(c_int) :: num_nodes1, num_nodes2
    real(c_double) :: nodes1_start(1, 2), nodes1_end(1, 2)
    real(c_double) :: nodes2_start(1, 2), nodes2_end(1, 2)

    num_nodes1 = size(first%nodes, 1)
    nodes1_start(1, :) = first%nodes(1, :2)
    nodes2_start(1, :) = first%nodes(num_nodes1, :2)

    num_nodes2 = size(second%nodes, 1)
    nodes1_end(1, :) = second%nodes(1, :2)
    nodes2_end(1, :) = second%nodes(num_nodes2, :2)

    call endpoint_check( &
         first, nodes1_start, 0.0_dp, &
         second, nodes1_end, 0.0_dp, &
         num_intersections, intersections)
    call endpoint_check( &
         first, nodes1_start, 0.0_dp, &
         second, nodes2_end, 1.0_dp, &
         num_intersections, intersections)
    call endpoint_check( &
         first, nodes2_start, 1.0_dp, &
         second, nodes1_end, 0.0_dp, &
         num_intersections, intersections)
    call endpoint_check( &
         first, nodes2_start, 1.0_dp, &
         second, nodes2_end, 1.0_dp, &
         num_intersections, intersections)

  end subroutine tangent_bbox_intersection

  subroutine add_candidates( &
       candidates, num_candidates, first, second, enum_)

    ! Helper for ``intersect_one_round``.

    type(CurveData), allocatable, intent(inout) :: candidates(:, :)
    integer(c_int), intent(inout) :: num_candidates
    type(CurveData), intent(in) :: first, second
    integer(c_int), intent(in) :: enum_
    ! Variables outside of signature.
    integer(c_int) :: curr_size
    type(CurveData), allocatable :: candidates_swap(:, :)

    ! First, update the number of candidates.
    if (enum_ == Subdivide_FIRST .OR. enum_ == Subdivide_SECOND) then
       num_candidates = num_candidates + 2
    else if (enum_ == Subdivide_BOTH) then
       num_candidates = num_candidates + 4
    else
       return
    end if

    if (allocated(candidates)) then
       curr_size = size(candidates, 2)
       if (curr_size < num_candidates) then
          allocate(candidates_swap(2, num_candidates))
          ! NOTE: This assumes, but does not check ``candidates`` has two rows.
          candidates_swap(:, :curr_size) = candidates(:, :curr_size)
          call move_alloc(candidates_swap, candidates)
       end if
    else
       allocate(candidates(2, num_candidates))
    end if

    ! NOTE: This assumes, but does not check, that ``candidates`` is MxN with
    !       M == 2 and ``num_candidates`` <= N.

    if (enum_ == Subdivide_FIRST) then
       candidates(2, num_candidates - 1) = second
       candidates(2, num_candidates) = second
       call subdivide_curve( &
            first, &
            candidates(1, num_candidates - 1), &
            candidates(1, num_candidates))
    else if (enum_ == Subdivide_SECOND) then
       candidates(1, num_candidates - 1) = first
       candidates(1, num_candidates) = first
       call subdivide_curve( &
            second, &
            candidates(2, num_candidates - 1), &
            candidates(2, num_candidates))
    else if (enum_ == Subdivide_BOTH) then
       call subdivide_curve( &
            first, &
            candidates(1, num_candidates - 3), &
            candidates(1, num_candidates - 1))
       call subdivide_curve( &
            second, &
            candidates(2, num_candidates - 3), &
            candidates(2, num_candidates - 2))

       candidates(1, num_candidates - 2) = candidates(1, num_candidates - 3)
       candidates(2, num_candidates - 1) = candidates(2, num_candidates - 3)
       candidates(1, num_candidates) = candidates(1, num_candidates - 1)
       candidates(2, num_candidates) = candidates(2, num_candidates - 2)
    end if

  end subroutine add_candidates

  subroutine intersect_one_round( &
       root_nodes_first, root_nodes_second, num_candidates, candidates, &
       num_intersections, intersections, &
       next_candidates, num_next_candidates, status)

    ! NOTE: This is **explicitly** not intended for C inter-op.
    ! NOTE: This assumes, but does not check, that ``candidates`` has
    !       two rows and has at **least** ``num_candidates`` columns.

    ! Possible error states:
    ! * Status_SUCCESS    : On success.
    ! * Status_PARALLEL   : Via ``add_from_linearized()``.
    ! * Status_WIGGLE_FAIL: Via ``add_from_linearized()``.

    real(c_double), intent(in) :: root_nodes_first(:, :)
    real(c_double), intent(in) :: root_nodes_second(:, :)
    integer(c_int), intent(in) :: num_candidates
    type(CurveData), intent(in) :: candidates(:, :)
    integer(c_int), intent(inout) :: num_intersections
    real(c_double), allocatable, intent(inout) :: intersections(:, :)
    type(CurveData), allocatable, intent(inout) :: next_candidates(:, :)
    integer(c_int), intent(out) :: num_next_candidates
    integer(c_int), intent(out) :: status
    ! Variables outside of signature.
    type(CurveData) :: first, second
    real(c_double) :: linearization_error1, linearization_error2
    integer(c_int) :: bbox_int, index_, num_nodes1, num_nodes2
    integer(c_int) :: subdivide_enum

    num_next_candidates = 0
    status = Status_SUCCESS
    subdivide_loop: do index_ = 1, num_candidates
       ! NOTE: We **hope** that the compiler avoids turning this alias (for
       !       the sake of typing fewer characters) into a copy.
       first = candidates(1, index_)
       second = candidates(2, index_)
       ! Compute the linearization error for each curve.
       num_nodes1 = size(first%nodes, 1)
       num_nodes2 = size(second%nodes, 1)
       call linearization_error( &
            num_nodes1, 2, first%nodes, linearization_error1)
       call linearization_error( &
            num_nodes2, 2, second%nodes, linearization_error2)

       if (linearization_error1 < LINEARIZATION_THRESHOLD) then
          if (linearization_error2 < LINEARIZATION_THRESHOLD) then
             ! If both ``first`` and ``second`` are linearizations, then
             ! we can (attempt to) intersect them immediately.
             subdivide_enum = Subdivide_NEITHER
             call add_from_linearized( &
                  first, root_nodes_first, linearization_error1, &
                  second, root_nodes_second, linearization_error2, &
                  num_intersections, intersections, status)

             ! If there was a failure, exit this subroutine.
             if (status /= Status_SUCCESS) then
                return
             end if

             ! If there was no failure, move to the next iteration.
             cycle subdivide_loop
          else
             subdivide_enum = Subdivide_SECOND
             call bbox_line_intersect( &
                  num_nodes2, second%nodes, &
                  first%nodes(1, :), first%nodes(num_nodes1, :), bbox_int)
          end if
       else
          if (linearization_error2 < LINEARIZATION_THRESHOLD) then
             subdivide_enum = Subdivide_FIRST
             call bbox_line_intersect( &
                  num_nodes1, first%nodes, &
                  second%nodes(1, :), second%nodes(num_nodes2, :), bbox_int)
          else
             subdivide_enum = Subdivide_BOTH
             ! If neither curve is close to a line, we can still reject the
             ! pair if the bounding boxes are disjoint.
             call bbox_intersect( &
                  num_nodes1, first%nodes, num_nodes2, second%nodes, bbox_int)
          end if
       end if

       ! Reject if the bounding boxes do not intersect.
       if (bbox_int == BoxIntersectionType_DISJOINT) then
          cycle subdivide_loop
       else if (bbox_int == BoxIntersectionType_TANGENT) then
          call tangent_bbox_intersection( &
               first, second, num_intersections, intersections)
          cycle subdivide_loop
       end if

       ! If we haven't ``cycle``-d this iteration, add the
       ! ``next_candidates`` pair.
       call add_candidates( &
            next_candidates, num_next_candidates, &
            first, second, subdivide_enum)
    end do subdivide_loop

  end subroutine intersect_one_round

  subroutine make_candidates( &
       nodes_first, nodes_second, candidates)

    ! NOTE: This is a (private) helper for ``all_intersections``.

    real(c_double), intent(in) :: nodes_first(:, :)
    real(c_double), intent(in) :: nodes_second(:, :)
    type(CurveData), allocatable, intent(inout) :: candidates(:, :)

    ! NOTE: This assumes (but does not verify) that if ``candidates`` has
    !       been allocated, then it is ``2 x N`` with ``N > 0``.
    if (.NOT. allocated(candidates)) then
       allocate(candidates(2, 1))
    end if

    ! NOTE: Since we **might** be re-using ``candidates``, we can't rely on
    !       the default values of all fields being intact.
    candidates(1, 1)%start = 0.0_dp
    candidates(1, 1)%end_ = 1.0_dp
    candidates(1, 1)%nodes = nodes_first
    candidates(2, 1)%start = 0.0_dp
    candidates(2, 1)%end_ = 1.0_dp
    candidates(2, 1)%nodes = nodes_second

  end subroutine make_candidates

  subroutine all_intersections( &
       num_nodes_first, nodes_first, num_nodes_second, nodes_second, &
       intersections, num_intersections, status)

    ! NOTE: This is **explicitly** not intended for C inter-op, but
    !       a C compatible interface is exposed as ``all_intersections_abi``.

    ! Possible error states:
    ! * Status_SUCCESS       : On success.
    ! * Status_PARALLEL      : Via ``intersect_one_round()``.
    ! * Status_WIGGLE_FAIL   : Via ``intersect_one_round()``.
    ! * Status_NO_CONVERGE   : If the curves don't converge to linear after
    !                          ``MAX_INTERSECT_SUBDIVISIONS``.
    ! * (N >= MAX_CANDIDATES): The number of candidates if it exceeds the limit
    !                          ``MAX_CANDIDATES`` (64 is the default).

    integer(c_int), intent(in) :: num_nodes_first
    real(c_double), intent(in) :: nodes_first(num_nodes_first, 2)
    integer(c_int), intent(in) :: num_nodes_second
    real(c_double), intent(in) :: nodes_second(num_nodes_second, 2)
    real(c_double), allocatable, intent(inout) :: intersections(:, :)
    integer(c_int), intent(out) :: num_intersections
    integer(c_int), intent(out) :: status
    ! Variables outside of signature.
    integer(c_int) :: num_candidates, num_next_candidates
    integer(c_int) :: index_, intersect_status
    logical(c_bool) :: is_even

    num_intersections = 0
    ! First iteration is odd (i.e. ``index_ == 1``).
    num_candidates = 1
    call make_candidates( &
         nodes_first, nodes_second, CANDIDATES_ODD)
    status = Status_SUCCESS  ! Default.

    is_even = .TRUE.  ! At zero.
    do index_ = 1, MAX_INTERSECT_SUBDIVISIONS
       is_even = .NOT. is_even  ! Switch parity.

       if (is_even) then
          ! Since ``index_`` is even, we READ from ``CANDIDATES_EVEN``
          ! and WRITE to ``CANDIDATES_ODD``.
          call intersect_one_round( &
               nodes_first, nodes_second, &
               num_candidates, CANDIDATES_EVEN, &
               num_intersections, intersections, &
               CANDIDATES_ODD, num_next_candidates, intersect_status)
       else
          ! Since ``index_`` is odd, we READ from ``CANDIDATES_ODD``
          ! and WRITE to ``CANDIDATES_EVEN``.
          call intersect_one_round( &
               nodes_first, nodes_second, &
               num_candidates, CANDIDATES_ODD, &
               num_intersections, intersections, &
               CANDIDATES_EVEN, num_next_candidates, intersect_status)
       end if

       ! NOTE: This only checks for two error statuses from
       !       ``intersect_one_round()``, so it is inherently brittle
       !       to changes there.
       if (intersect_status /= Status_SUCCESS) then
          status = intersect_status
          return
       end if

       ! Update the number of candidates.
       num_candidates = num_next_candidates

       ! Bail out of there are too many candidates.
       if (num_candidates > MAX_CANDIDATES) then
          ! NOTE: This assumes that all of the status enum values are less
          !       than ``MAX_CANDIDATES + 1``.
          status = num_candidates
          return
       end if

       ! If none of the candidate pairs have been accepted, then there are
       ! no more intersections to find.
       if (num_candidates == 0) then
          return
       end if
    end do

    ! If we've reached this point, then the curve intersection failed to
    ! converge to "approximately linear" subdivided curves after
    ! ``MAX_INTERSECT_SUBDIVISIONS``.
    status = Status_NO_CONVERGE

  end subroutine all_intersections

  subroutine all_intersections_abi( &
       num_nodes_first, nodes_first, num_nodes_second, nodes_second, &
       intersections_size, intersections, num_intersections, status) &
       bind(c, name='curve_intersections')

    ! NOTE: The number of intersections cannot be known beforehand (though it
    !       will be **at most** the product of the degrees of the two curves,
    !       by Bezout's theorem). If ``intersections`` is not large enough
    !       (i.e. if ``intersections_size`` < num_intersections``), then
    !       ``intersections`` will not be populated and the ``status`` will be
    !       set to ``Status_INSUFFICIENT_SPACE``. However, the value of
    !       ``num_intersections`` will be accurate and ``intersections``
    !       should be re-sized by the caller to accommodate.

    ! Possible error states:
    ! * Status_SUCCESS           : On success.
    ! * Status_PARALLEL          : Via ``all_intersections()``.
    ! * Status_WIGGLE_FAIL       : Via ``all_intersections()``.
    ! * Status_NO_CONVERGE       : Via ``all_intersections()``.
    ! * Status_INSUFFICIENT_SPACE: If ``intersections_size`` is smaller than
    !                              the number of intersections.
    ! * (N >= MAX_CANDIDATES)    : Via ``all_intersections()``.

    integer(c_int), intent(in) :: num_nodes_first
    real(c_double), intent(in) :: nodes_first(num_nodes_first, 2)
    integer(c_int), intent(in) :: num_nodes_second
    real(c_double), intent(in) :: nodes_second(num_nodes_second, 2)
    integer(c_int), intent(in) :: intersections_size
    real(c_double), intent(out) :: intersections(2, intersections_size)
    integer(c_int), intent(out) :: num_intersections
    integer(c_int), intent(out) :: status

    call all_intersections( &
         num_nodes_first, nodes_first, num_nodes_second, nodes_second, &
         INTERSECTIONS_WORKSPACE, num_intersections, status)

    if (status /= Status_SUCCESS) then
       return
    end if

    if (num_intersections > intersections_size) then
       status = Status_INSUFFICIENT_SPACE
    else if (num_intersections > 0) then
       ! NOTE: This assumes, but doesn't check that
       !       ``INTERSECTIONS_WORKSPACE`` has been allocated
       !       and that is has 2 rows, just like ``intersections``.
       intersections(:, :num_intersections) = ( &
            INTERSECTIONS_WORKSPACE(:, :num_intersections))
    end if

  end subroutine all_intersections_abi

  subroutine set_max_candidates(num_candidates) &
       bind(c, name='set_max_candidates')

    integer(c_int), intent(in) :: num_candidates

    MAX_CANDIDATES = num_candidates

  end subroutine set_max_candidates

  subroutine get_max_candidates(num_candidates) &
       bind(c, name='get_max_candidates')

    integer(c_int), intent(out) :: num_candidates

    num_candidates = MAX_CANDIDATES

  end subroutine get_max_candidates

  subroutine set_similar_ulps(num_bits) &
       bind(c, name='set_similar_ulps')

    integer(c_int), intent(in) :: num_bits

    SIMILAR_ULPS = num_bits

  end subroutine set_similar_ulps

  subroutine get_similar_ulps(num_bits) &
       bind(c, name='get_similar_ulps')

    integer(c_int), intent(out) :: num_bits

    num_bits = SIMILAR_ULPS

  end subroutine get_similar_ulps

  subroutine free_curve_intersections_workspace() &
       bind(c, name='free_curve_intersections_workspace')

    ! NOTE: This **should** be run during clean-up for any code which
    !       invokes ``all_intersections()``.

    if (allocated(CANDIDATES_ODD)) then
       deallocate(CANDIDATES_ODD)
    end if

    if (allocated(CANDIDATES_EVEN)) then
       deallocate(CANDIDATES_EVEN)
    end if

    if (allocated(INTERSECTIONS_WORKSPACE)) then
       deallocate(INTERSECTIONS_WORKSPACE)
    end if

  end subroutine free_curve_intersections_workspace

end module curve_intersection

c***FROM: http://www.netlib.org/quadpack/dqk21.f
      subroutine dqk21(f,a,b,result,abserr,resabs,resasc)
c***begin prologue  dqk21
c***date written   800101   (yymmdd)
c***revision date  830518   (yymmdd)
c***category no.  h2a1a2
c***keywords  21-point gauss-kronrod rules
c***author  piessens,robert,appl. math. & progr. div. - k.u.leuven
c           de doncker,elise,appl. math. & progr. div. - k.u.leuven
c***purpose  to compute i = integral of f over (a,b), with error
c                           estimate
c                       j = integral of abs(f) over (a,b)
c***description
c
c           integration rules
c           standard fortran subroutine
c           double precision version
c
c           parameters
c            on entry
c              f      - double precision
c                       function subprogram defining the integrand
c                       function f(x). the actual name for f needs to be
c                       declared e x t e r n a l in the driver program.
c
c              a      - double precision
c                       lower limit of integration
c
c              b      - double precision
c                       upper limit of integration
c
c            on return
c              result - double precision
c                       approximation to the integral i
c                       result is computed by applying the 21-point
c                       kronrod rule (resk) obtained by optimal addition
c                       of abscissae to the 10-point gauss rule (resg).
c
c              abserr - double precision
c                       estimate of the modulus of the absolute error,
c                       which should not exceed abs(i-result)
c
c              resabs - double precision
c                       approximation to the integral j
c
c              resasc - double precision
c                       approximation to the integral of abs(f-i/(b-a))
c                       over (a,b)
c
c***references  (none)
c***routines called  d1mach
c***end prologue  dqk21
c
      double precision a,absc,abserr,b,centr,dabs,dhlgth,dmax1,dmin1,
     *  d1mach,epmach,f,fc,fsum,fval1,fval2,fv1,fv2,hlgth,resabs,resasc,
     *  resg,resk,reskh,result,uflow,wg,wgk,xgk
      integer j,jtw,jtwm1
      external f
c
      dimension fv1(10),fv2(10),wg(5),wgk(11),xgk(11)
c
c           the abscissae and weights are given for the interval (-1,1).
c           because of symmetry only the positive abscissae and their
c           corresponding weights are given.
c
c           xgk    - abscissae of the 21-point kronrod rule
c                    xgk(2), xgk(4), ...  abscissae of the 10-point
c                    gauss rule
c                    xgk(1), xgk(3), ...  abscissae which are optimally
c                    added to the 10-point gauss rule
c
c           wgk    - weights of the 21-point kronrod rule
c
c           wg     - weights of the 10-point gauss rule
c
c
c gauss quadrature weights and kronron quadrature abscissae and weights
c as evaluated with 80 decimal digit arithmetic by l. w. fullerton,
c bell labs, nov. 1981.
c
      data wg  (  1) / 0.0666713443 0868813759 3568809893 332 d0 /
      data wg  (  2) / 0.1494513491 5058059314 5776339657 697 d0 /
      data wg  (  3) / 0.2190863625 1598204399 5534934228 163 d0 /
      data wg  (  4) / 0.2692667193 0999635509 1226921569 469 d0 /
      data wg  (  5) / 0.2955242247 1475287017 3892994651 338 d0 /
c
      data xgk (  1) / 0.9956571630 2580808073 5527280689 003 d0 /
      data xgk (  2) / 0.9739065285 1717172007 7964012084 452 d0 /
      data xgk (  3) / 0.9301574913 5570822600 1207180059 508 d0 /
      data xgk (  4) / 0.8650633666 8898451073 2096688423 493 d0 /
      data xgk (  5) / 0.7808177265 8641689706 3717578345 042 d0 /
      data xgk (  6) / 0.6794095682 9902440623 4327365114 874 d0 /
      data xgk (  7) / 0.5627571346 6860468333 9000099272 694 d0 /
      data xgk (  8) / 0.4333953941 2924719079 9265943165 784 d0 /
      data xgk (  9) / 0.2943928627 0146019813 1126603103 866 d0 /
      data xgk ( 10) / 0.1488743389 8163121088 4826001129 720 d0 /
      data xgk ( 11) / 0.0000000000 0000000000 0000000000 000 d0 /
c
      data wgk (  1) / 0.0116946388 6737187427 8064396062 192 d0 /
      data wgk (  2) / 0.0325581623 0796472747 8818972459 390 d0 /
      data wgk (  3) / 0.0547558965 7435199603 1381300244 580 d0 /
      data wgk (  4) / 0.0750396748 1091995276 7043140916 190 d0 /
      data wgk (  5) / 0.0931254545 8369760553 5065465083 366 d0 /
      data wgk (  6) / 0.1093871588 0229764189 9210590325 805 d0 /
      data wgk (  7) / 0.1234919762 6206585107 7958109831 074 d0 /
      data wgk (  8) / 0.1347092173 1147332592 8054001771 707 d0 /
      data wgk (  9) / 0.1427759385 7706008079 7094273138 717 d0 /
      data wgk ( 10) / 0.1477391049 0133849137 4841515972 068 d0 /
      data wgk ( 11) / 0.1494455540 0291690566 4936468389 821 d0 /
c
c
c           list of major variables
c           -----------------------
c
c           centr  - mid point of the interval
c           hlgth  - half-length of the interval
c           absc   - abscissa
c           fval*  - function value
c           resg   - result of the 10-point gauss formula
c           resk   - result of the 21-point kronrod formula
c           reskh  - approximation to the mean value of f over (a,b),
c                    i.e. to i/(b-a)
c
c
c           machine dependent constants
c           ---------------------------
c
c           epmach is the largest relative spacing.
c           uflow is the smallest positive magnitude.
c
c***first executable statement  dqk21
      epmach = d1mach(4)
      uflow = d1mach(1)
c
      centr = 0.5d+00*(a+b)
      hlgth = 0.5d+00*(b-a)
      dhlgth = dabs(hlgth)
c
c           compute the 21-point kronrod approximation to
c           the integral, and estimate the absolute error.
c
      resg = 0.0d+00
      fc = f(centr)
      resk = wgk(11)*fc
      resabs = dabs(resk)
      do 10 j=1,5
        jtw = 2*j
        absc = hlgth*xgk(jtw)
        fval1 = f(centr-absc)
        fval2 = f(centr+absc)
        fv1(jtw) = fval1
        fv2(jtw) = fval2
        fsum = fval1+fval2
        resg = resg+wg(j)*fsum
        resk = resk+wgk(jtw)*fsum
        resabs = resabs+wgk(jtw)*(dabs(fval1)+dabs(fval2))
   10 continue
      do 15 j = 1,5
        jtwm1 = 2*j-1
        absc = hlgth*xgk(jtwm1)
        fval1 = f(centr-absc)
        fval2 = f(centr+absc)
        fv1(jtwm1) = fval1
        fv2(jtwm1) = fval2
        fsum = fval1+fval2
        resk = resk+wgk(jtwm1)*fsum
        resabs = resabs+wgk(jtwm1)*(dabs(fval1)+dabs(fval2))
   15 continue
      reskh = resk*0.5d+00
      resasc = wgk(11)*dabs(fc-reskh)
      do 20 j=1,10
        resasc = resasc+wgk(j)*(dabs(fv1(j)-reskh)+dabs(fv2(j)-reskh))
   20 continue
      result = resk*hlgth
      resabs = resabs*dhlgth
      resasc = resasc*dhlgth
      abserr = dabs((resk-resg)*hlgth)
      if(resasc.ne.0.0d+00.and.abserr.ne.0.0d+00)
     *  abserr = resasc*dmin1(0.1d+01,(0.2d+03*abserr/resasc)**1.5d+00)
      if(resabs.gt.uflow/(0.5d+02*epmach)) abserr = dmax1
     *  ((epmach*0.5d+02)*resabs,abserr)
      return
      end
